CHANGES
=======

10.0.5
------

* NetApp: block drivers fail when volume missing
* NetApp: Fix SVM scoped user startup exception
* Kamiario: Fix over subscription reporting
* Adds missing entries for Quobyte driver to rootwrap
* Do not delete group if group snapshot exists
* Switch to use stable data_utils
* Huawei driver supports front-end qos
* Change Huawei driver's private data storing place

10.0.4
------

* LVM: Don't initialize VG with lvm_type='auto'
* Revert "Correct RBD Provision stats&fix a perf problem"
* XtremIO: fix fetching FC targets from X2 array
* VMAX driver - volume and snapshot treated as dicts in attach snapshot
* Unity: temp snapshot for backup deleted twice
* VNX: failed to create from image cache
* Fix image cache db query when limits are enabled
* XtremIO: reduce number of backend calls
* VMAX driver - None connector object in a terminate_connection
* Fix bugs while integrated with Huawei Dorado array
* ScaleIO Driver: Fix for using scheduler specified pool
* VMAX driver - Detaching volumes if part of two or more MVs
* Delete consistency group fails on xtremio driver
* create snapshot with generic group fail with XtremIO Driver

10.0.3
------

* Use requests lib for Huawei array connection
* [BugFix] Add 'all_tenants', 'project_id' in attachment-list
* VMAX driver - failure in initiator group cleanup
* VMAX driver - conflicting threads effecting rollback
* VNX: fix issue when backing-up in-use volume
* GPFS: Fix forceful delete for consistency group
* GPFS: Handle unsupported operations with an exception
* VMAX driver - Rollback error on Live Migration
* VMAX driver - Close ecom connections
* VMAX driver - Manage/Unmanage performance fix
* NFS Backup: Fix overwritting backups
* LIO: Fix terminate_connection AttributeError
* Fix permission error in VNX driver
* RemoteFS: prevent creation of encrypted volumes
* Fix forceful deletion of Consistency Group for GPFS Driver
* RBD:Move RBDVolume calls to a separate threads
* Updated from global requirements

10.0.2
------

* VMAX driver - Pre-zoned port group fix
* ds8k: should verify REST version separately
* Fix encryption key deletion error handling on volume delete
* Fix Pep8 Failures for Python3
* genopts: Fix python 3 compat, sort options
* Use cg object when invoking update cg method
* Give more time for LVM deactivation
* NetApp: Refresh directory before waiting
* Fix attach issue for failed-over volume
* Remove "list_volume" from filter
* VNX: allow specify pool name for replication
* Fix for Group API update to include check policy
* Dell EMC SC: Raise on _init_volume create_snapshot failure
* Separate out routine for getting qemu_img_info
* Unity driver: fail to disconnect volume
* [BugFix]Cinder forgets to update 'deleted_at' when deleting
* VMAX driver - Live Migration is dropping connection
* Correct Extend lvm Volume
* VMAX driver - superfluous debug messages causing error
* Don't use tempest special_fields

10.0.1
------

* Fix create_consistencygroup when using CG objects
* VMAX driver - volumes part of CG not managed correctly
* Added gigabyte unit to values in exception message
* Prevent duplicate entries in the image cache
* Consistency groups API is not returning project_id filter groups
* Dell EMC SC: Return dict from delete_consisgroup
* XtremIO: allow a cloned volume with larger size
* VMAX driver - replace pickle with jsonutils
* VMAX driver - Change vendor_name from EMC to Dell EMC
* VMAX driver - consistency group remove empty values
* VNX: Handle error during volume deletion
* Fix lock contention in SolidFire driver
* Bump prlimit cpu time for qemu-img from 2 to 8
* Fix internal tempest tests
* NetApp: Track SVM and Cluster scoped credentials
* Enforce _usage_from_snapshot to fetch info from deleted volume
* Updated from global requirements
* cinder-backup - coordination not initialized
* 3PAR: rally test create-volume-from-snapshot fails
* VMAX driver - snapshot creation and immediate deletion fix
* VMAX Driver - disable initiator check by default
* VMAX driver - widen locking around storage groups

10.0.0
------

* Fix attachments after attached migration
* Fix volume retype with migration as non-admin
* Fix SolidFire cgsnap clone bug
* SolidFire: Handle connect_volume() failure when create vol from image
* Dell EMC SC: Return dict in delete_cgsnapshot
* 3PAR: Remove un-necessary snapshot in online copy operation
* VMAX driver - allow for multi volume types in Consistency Group
* Fix duplicate lvs2 entry in rootwrap volume filter
* fix create_consistencygroup in xiv
* Dell EMC: Create independent volume on clone
* VMAX driver - copy state fix
* Prepare for using standard python tests
* Update UPPER_CONSTRAINTS_FILE for stable/ocata
* Update .gitreview for stable/ocata

10.0.0.0rc1
-----------

* Reserve 5 migrations for DB backports
* Tests: Fix NetApp unit test failure w/ hash randomization
* xiv create vol from replicated source fails
* Don't use None value for sql query
* Remove promote and reenable from policy
* VMAX driver - ignore service level and workload in xml
* VMAX driver - Convert eval to ast.literal_eval
* VMAX driver - failover error fix
* Add SUPPORTED flag to Lenovo FC driver
* Image utils: fix fetching available space on Windows
* Fix max_age calculation for quota usage refresh
* Fix 500 error while listing manageable volumes and snapshots
* Add usage and limit info on quota limit errors
* Convert ignoreskippedcluster check to be static
* Clean up release notes for Ocata
* xiv delete cg fails if removed on backend
* Make get_capabilities look for clusters
* Resolve Brocade HTTPS connection error
* Add SUPPORTED flag to Lenovo iSCSI driver
* Add SUPPORTED flag to HP MSA driver
* Hitachi VSP: Specify compute nodes and copy ports
* ZTE: Added CI_WIKI_NAME
* Fix notification short-circuit
* Fix CopyVolumeToImageTestCase max recursion depth
* HNAS: Cloned volume with different volume type
* Move release notes to correct location
* Add cluster_name to temporary volumes
* Fix host assignment when clustered
* 3PAR: Inconsistency in copied and source CG
* Remove redundant log during initialize connection
* VMAX driver - sync sv issue
* Reduced the complexity of the main() method
* Add descriptions to Pure drivers
* Adds API documentation for update snapshot status
* clean up replication volume on an xiv backend
* Add create volume from image policy
* Short-circuit notifications when not enabled
* Stop get_notifier mock in tests cleanup
* VMAX driver - removed incorrect six.text_type
* Updated from global requirements
* Rebrand and move EQLX driver to dell_emc folder
* Fix Live Migration for Nimble Storage Driver
* create consistency group mishandles types
* VMAX driver - QoS key fix
* VMAX driver - remove global mock of volume_types
* Set image_owner before adding location to glance
* Dell EMC SC: Delete doesn't account for migration
* Zero out SolidFire capacity when unreachable
* IBM driver update CI_WIKI_NAME

10.0.0.0b3
----------

* Fix Qos for clone for Nimble Storage Driver
* Add lock acquire/release debug messages
* [api-ref]Fix the volume metadata description error
* [api-ref]Add volumes/summary API doc
* [api-ref]Change tenant to project
* Fix double call to "qemu-img create"
* Fix api-ref status parameter
* Small change to microversion header on devref
* Check if volume node has enough space for image operations
* Revert "Mark the sheepdog driver as unsupported"
* backup of active 3par ISCSI bootable volume fails
* Open the source code of ibm_storage driver
* NFS snapshots
* Tests: Fix hash unstable dict comparison
* Tests: Fix mock for vzstorage remotefs
* Fix the api-ref CI failure
* Eager load projects when getting types by group
* VMAX driver - rename and restructure driver
* Updated from global requirements
* Switch ManageableSnaphots & ManageableVolumes list to OVO
* VMAX driver - storage group cleanup on error
* Add assert_min_rpc_version decorator
* NetApp cDOT: Add NetApp Volume Encryption support
* Add volume backup tempest tests
* Make CappedVersionUnknown exception more useful
* Break migrate_add_message_prefix into two queries
* Remove useless FIXME
* Fix some problem for attachment list
* Don't drop the volume type's extra spec at DB layer
* Switch to using generic groups with Pure driver
* VMAX driver - Implement volume replication for VMAX
* Brcd zonemanager: Fix unstable command generation
* Dell SC: Logging asyncTask if XML returned
* Test: Fix assert_has_calls dict order bug (QoS)
* FalconStor: Drop the copy_image_to_volume feature
* Refactor backup RPC API test cases
* Refactor scheduler RPC API test cases
* Update the parameter check when create attachment
* FalconStor: Restore option "san_secondary_ip"
* Extracted HTTP response codes to constants
* XtremIO: Add CG capability to generic groups
* VMAX driver - Consistency Group automerge fix
* VMAX driver - Support for compression on All Flash
* Add new attachment APIS
* Add lock around SolidFire clone-image
* VMAX driver - Storage assisted volume migration
* Dell SC: Retype fixes
* Revert "Mark Huawei volume driver as unsupported"
* Fix typos
* Adds getfattr and mount to Cinder rootwrap volume.filters
* Refactor volume RPC API test cases
* Make notify_service_capabilities cluster aware
* VNX: Add async migration support
* VNX: Update sg cache if it already existed
* Allow snapshots and volumes to have Null group values
* Fix for FC Initiator API in Nimble Storage Driver
* Revert "Mark Quobyte volume driver as unsupported"
* Fix retype with migrate
* VMware: Allow deletion of snapshot in error state
* Move driver tests to tests/unit/volume/drivers
* Prevent claiming and updating races on worker
* Fix replication freeze mechanism
* Move service and cluster creation in test to utils
* Make Image Volume Cache cluster aware
* Make Replication support Active-Active
* Fix for live migration for Nimble Storage
* NexentaStor5: Added extend method to NFS driver
* Sync ``services`` SQLA model with what's in the DB
* Make BackupManager not a SchedulerDependentManager
* Optimise: Use sqlalchemy to build table sequence
* Fix volume manage
* Revert "Mark Tintri volume driver as unsupported"
* Nosec subprocess with shell equal True from Bandit
* Modify the spelling mistakes
* Add volume to fake snapshot object
* Clean up image tmp file if c-vol gets restarted
* Prevent driver load failures from objects
* Nosec Paramiko exec_command() warning from Bandit
* Replace deprecated pylint disable-msg with disable
* Updated from global requirements
* Save model_update as admin in create_volume
* Improvement to get group detail(Part 2)
* Add api version history for 3.23
* Deprecate the Linux SMBFS driver
* Storwize: do the correct update after failover
* Unity Driver: Backup volume via snapshot
* RBD: Fix RBD replication on volumes from image source
* Dell SC: Change DRP search to reference type
* vzstorage: fixed snapshot deletion in error state
* Dell SC: Missing version history
* Remove deprecated RequestBodySizeLimiter class
* Allow triggering cleanup from API
* [py35] image file should be open in binary mode
* HNAS: Change snapshot names
* Add prefix to user message event ids
* Improve compatibility with novaclient 7.0.0
* Updated from global requirements
* Unity: Add support to set IO ports in option
* Fixes hpelefthandclient AttributeError
* Mark the sheepdog driver as unsupported
* Add volume type access operations notification
* Remove inheritance from deprecated classes
* FusionStorage: rename the CI_WIKI_NAME
* Dell SC: Failback timeout extended
* Tests: Remove more InvalidUUID warnings
* Don't translate exceptions w/ no message
* Add command information to cinder-manage.rst
* Add CG capability to generic groups in VNX driver
* RBD: Remove volume_tmp_dir option
* VMware: Use versionutils in oslo.utils
* Delete volume when rescheduling
* VMware: Set backend UUID to volume UUID
* Rename AddFCZone and RemoveFCZone according to PEP 8
* Cleanup limit view name processing
* Datera 2.3 driver update
* Skip CI link in list for infra supported drivers
* Add manage/unmanage to DISCO driver
* Updated from global requirements
* Fix a few typos in storwize_svc_common.py
* Doc: Fix build warnings for missing code-block lang
* CoprHD: Handle ScaleIO CI failing with version-3.5
* Python3 common patterns
* Enable DeprecationWarning in test environments
* Add orm type check for paginate_query
* [api-ref]Add api ref for "volume type encryption"
* Fix sphinx errors related to missing paths/modules
* Cascade + force volume delete parameters
* Adds metadata in search option for snapshot
* Fix python integer interpretation in Py2 and Py3
* Fix Cisco Initiator zoning updates
* Add QoS and Dedupe Support for Nimble Storage
* Remove unused PasteAppNotFound exception
* tgt: Remove existence check before delete
* Only log insecure key manager warning once
* Refactoring ITRI DISCO cinder volume driver
* Convert 'parallels' format name to 'ploop'
* Add psycopg2 and PyMySQL to test-requirements
* Attach/Delete volume for tgt driver race condition fix
* Correct RBD Provision stats&fix a perf problem
* Avoid Forcing the Translation of Translatable Variables
* Updated from global requirements
* Deprecate the block_device driver
* [1/4]Reset generic volume group status
* HNAS: Deprecate HNAS iSCSI driver
* VMAX driver - PortGroup rollback error path scenario
* Report multiattach capability for Hitachi VSP drivers
* Tests: Split up NFS backup notification test
* Set replication_status automatically on retype
* Set replication_status on volume creation
* Update replication property in capabilities
* Cisco: can't add new zone when no zone is created before
* VMware: Fix inventory folder after volume transfer
* Use oslo.messaging topics for multibackend
* Backup project attribute support
* Cinder consistency group returning generic error message
* Move VNX driver to dell_emc folder
* NexentaStor5: sessions and HTTPS support
* Add more operations to cluster
* Make workers ORM compatible with SQLAlchemy 1.1.4
* VMAX driver - MVs and SGs not reflecting correct protocol
* Delete space to pass the check of pep8
* Fix logging traceback in service logs
* Remove "service" from required_import_options
* Add Rest API Support for Nimble Storage
* Adds release note for 'Route extend_volume' bugfix
* Add 'unmanaging' state to volumes and snapshots
* Fix service_get mock method
* Mark Nexenta Edge volume drivers as unsupported
* Mark DotHill volume drivers as unsupported
* leave the unreleased branch unspecified for release notes
* Fix VMAX clone CG release note
* Mark Tintri volume driver as unsupported
* Mark Quobyte volume driver as unsupported
* Mark Huawei volume driver as unsupported
* Mark CloudByte volume driver as unsupported
* Mark HPE XP volume driver as unsupported
* RBD: Implement v2.1 replication
* Updated from global requirements
* Storwize: create vol fails near licensed limit
* Add get_all capability to volume_attachments
* Cluster volume group fix in lvm
* Drop the judgement condition for FakeConnector
* Rolling upgrade procedure documentation
* Remove Scality backend driver
* Use method is_valid_boolstr from oslo_utils

10.0.0.0b2
----------

* Updated from global requirements
* Support new osprofiler API
* [api-ref] Show more specific parameter of capabilities
* Cosmetic changes to scheduler
* Support A/A on Scheduler operations
* Fix detach twice of snapshot
* Add cinder volume drivers for NEC Storage M series
* Remove authorisation checks at the DB level for quota operations
* Fix condition parameter bug in routes
* Add Apache 2.0 license to source file
* VMAX driver - Attach and detach snapshot
* Improve DB method naming consistency
* Simplify calls to mock_object
* Make APIVersionRequest's null check more pythonic
* Nexenta: Added ZFS cleanup in NexentaStor4 iSCSI driver
* Correct reraising of exception
* Fix warning when running `tox -e docs`
* ibm_storage driver: Added fczm decorators
* Dell SC: Added Logging to _swap_credentials
* Unreserve volume: fix log message for completion
* Dell SC: Missing volume creation options
* Hacking: Remove N333 oslo namespace import check
* Adds Unity Cinder Driver
* Added initial backend ISCSI driver for Reduxio
* Switch default py3x to py35
* Remove run_tests.sh wrapper
* Do not manage VG with > 1 volume in Kaminario driver
* HNAS: Add list manageable volume/snapshots
* Move to hacking 0.12
* Modify variable's usage in Log Messages
* Prohibit creating volume from source with dif encryptions
* Route extend_volume calls to scheduler
* Remove deprecated volume_clear shred option
* Fix dos-style endlines
* Add QNAP ES Storage Driver
* Fix TypeError when execute cinder-volume-usage-audit
* Log detailed attach/detach volumes info
* Remove anyjson test dependency
* EMC VMAX: Remove unused is_in_range() method
* Non-WAN port filter issue in Kaminario iSCSI driver
* Updated from global requirements
* Introduce Hitachi VSP iSCSI driver
* Remove Kaminario deprecated option
* Introduce Hitachi VSP driver
* Support A/A in delete actions and get_capabilities
* Dell SC: Incorrect exceptions being returned
* Tests: Fix invalid UUID warnings
* Block 3.1 message with c-sch RPCAPI pinned to 3.0
* Huawei: Mask unnecessary log print
* Fix status after a VolumeDriverException
* Fix replication_status on InvalidReplicationTarget
* Add host check on replication actions
* Updated from global requirements
* Revert "Swap volume type for migration started by retype"
* SolidFire QoS scaled by volume size
* Refactor api test_common to use ddt library
* New cinder driver to support INFINIDAT InfiniBox
* Remove cgsnapshot_id before snapshot.save
* Add missing consistencygroup_id in volume
* Remove support for single backend config
* Add back policy check for CG
* Fix secondary lvm cmds rootwrap filters
* Update detach_volume() with versionedobjects
* Update attach_volume() with versionedobjects
* Calculate virtual free capacity and notify
* NetApp cDOT driver fails to clone from NFS cache
* Admin API policy enforcement contingent on is_admin_project
* test: fix wrong usage of config option in test_window
* Fix wrong usage of config option gpfs_images_share_mode
* Correct the attributes of volume which created by clone a CG
* Swap volume type for migration started by retype
* Replace functions 'Dict.get' and 'del' with 'Dict.pop'
* Reuse already existing groups in tempest plugin
* Huawei: Mark password option as secret
* Remove Unicode byte order mark
* Add driver interface for groups
* Remove emc folder
* Always allow to create snapshot db record with snapshot-manage
* [api-ref] Correct status code of backup delete
* Add cg constraint when deleting a volume type
* Fix response bootable parameter type in api document
* Skip more parameters when import backup record
* Dell SC: Reject thaw call when backend is failed over
* Dell SC: Unable to locate LV primary after LV-AFO
* Remove nosetests i18n fix
* Remove temporary directory creation for BaseBackupTest
* Add logging to FakeLoggingVolumeDriver
* Remove empty debug_opts
* Add unsupported status to driver listing
* Add is_up property to service and cluster objects
* HNAS: Rename hnas_svcX_volume_type
* Fix UnBoundLocalError in update_consistencygroup
* Support A/A in attach/detach operations
* Remove 2 unnecessary assignments
* Show team and repo badges on README
* HPE3PAR: handle conflict in iscsi host create
* Add dev doc for generic volume groups
* Remove unused constant in hbsd_horcm.py
* Fix create_group with group type name
* Show provider_id for admin
* Fix online data migrations cmd in release notes
* Fix UnableToFailOver exception message
* Gate migration tests: Add Cinder tempest hook
* Updated from global requirements
* Create a dell_emc folder for Dell EMC drivers
* CG API changes for migrating CGs
* [2/4]Reset group snapshot status
* Update is_up from Service OVO class to match ORM
* Replace assertDictMatch with assertDictEqual method in tests
* Move XtremIO driver to dell_emc folder
* Replace six.iteritems with dict.items()
* Fix VMAX unit test timeout issue
* Migrate consistency groups to groups
* Move ScaleIO driver to dell_emc folder
* Modify the position of try-except
* Fix names in online-data-migrations release note
* Windows SMB: use os-brick remotefs client
* Fix typo in test_quotas.py
* Skip test_storwize_get_host_from_connector_with_lshost_failure
* Update v2 and v3 Volume actions documentation
* Handle NotImplementedError for image cache cloning
* Fix v2 volume create api-reference request parameters
* VMware: VMDK driver performance improvements
* VMAX driver - Create a CG from a source CG
* Deprecate Hitachi Block Storage Driver
* Add host check while create snapshot
* Prevent Active-Active on drivers by default
* Log traceback for validate_connector exception
* Fix "wrap functions with 2 blank lines" pep8 check
* RBD: improve readability in over provisioning tests
* Delete the redundant expression expected_attrs

10.0.0.0b1
----------

* Remove use of timeutils.set_time_override
* Add generic code for online data migrations
* VMAX driver - Ensure VMAX volume matches cinder db volume
* Updated from global requirements
* Pass OVO instance to copy_volume_to_image
* Drop unused parameter in class EntryCreateTask
* Set EVENTLET_NO_GREENDNS for IPv6 and dnspython compat
* Fix doc comments
* Add multipath enhancement to Storwize iSCSI driver
* Update replication doc
* Add VolumeAttachStatus Enum
* Dell SC: Live Volumes not cleaned up
* Remove race conditions from transfer API
* Convert backup_device to OVO
* Clean _get_cctxt method signatures
* DB: Optimize volume_update method
* Fix typo error
* Fix compatibility with decorator < 4.0.x
* Fix config generator issue with OVO decorators
* Dell SC: Minor cleanup
* NetApp ONTAP: Deprecate 7-mode driver
* Fix unit tests for LVM migration with os-brick 1.7.0
* Fix releasenotes job
* Make c-vol use workers table for cleanup
* Updated from global requirements
* Dell SC: Log FO state more clearly
* Add API unit tests for snapshot creation force values
* Use VolumeDriverException for driver exceptions
* Dell SC: Error creating snapshots with live volume
* Remove GlusterFS volume driver
* VMAX driver - Useful name convention for CG names
* VMAX driver - Duplicate initiator group name error
* To fix miscellaneous bugs in OVOs
* Dell SC: Add init_volume check and logging
* RBD: prevent creation of encrypted volumes
* Remove mox3 in test-requirement.txt
* Fix typos in comment
* VMAX driver - No support for creating CG from CG source
* Updated from global requirements
* NetApp Data ONTAP driver enhanced support logging
* FalconStor: Fix creating snapshot failed
* Dell SC: AsyncTask could return incomplete
* VNX:Add more check on replication_device keys
* Skip unit-tests which use os.fdatasync on MacOS
* Missing parameter for storage pools in Pure Storage driver
* NetApp: Report shared blocks exhaustion
* Allow entry created in VolumeAttachment table for 2nd and later volumes
* storwize: get_host_from_connector optimization
* Huawei: Fix the rest query timeout problem
* Updated from global requirements
* Remove logging import unused
* Add current status to error msg in reserve_volume
* Return HTTPBadRequest instead of HTTPNotFound
* Removed extra xml api-ref files
* Fix return values of consistencygroup actions in Pure storage driver
* Update .coveragerc after the removal of openstack directory
* Fixes ZFSSANFS driver on Solaris platform
* VMware:Config option for http connection pool size
* Updated from global requirements
* Add generic reset-status method in admin actions' testcases
* Updated from global requirements
* Imported Translations from Zanata
* Mark backup_swift_key option as secret
* make Liberty incompatibility error more helpful
* Add Fibre Channel support for Nimble Storage
* Updated from global requirements
* Adjust doc about threading
* RemoteFS: Remove deprecated config options
* Fix HNAS Driver KeyError exception in volume manage
* NetApp NFS: Look for new file for >60s
* Cleanup RCP API versioning
* VMware: Fix deprecation warning
* VMware:Remove redundant check for usable ESX hosts
* Updated from global requirements
* NetApp Data ONTAP headroom calculation error
* Update synchronized decorator
* VNX: use delete instead of remove
* Stop using mox in unit/api/v2/ tests
* Fix the issue that osprofiler opts not in cinder.conf.sample
* Remove volid from attachments_get_by_host|instance
* Coho Data: New socket connections per request
* Imported Translations from Zanata
* Log message cleanup for volume-usage-audit
* Imported Translations from Zanata
* Make divisible py3 compatible in remotefs driver
* Add 'cinder' to the 'allowed_direct_url_schemes'
* Imported Translations from Zanata
* Add backup notification to cinder-volume-usage-audit
* VMAX driver - Create initiator group in single call
* Fix log translation marker in volume/utils.py
* Fix policy file used for testing
* Imported Translations from Zanata
* Dell SC: Can incorrectly identify if it is failed over
* Enable release notes translation
* Add VERSION to ZTE driver class
* Imported Translations from Zanata
* Switch from tempest-lib to tempest
* VMAX driver - Misleading logging on portgroups
* VMAX driver - Heat detach issue
* Sort options in cinder.conf by module name
* Fix typos in documentation
* Move volume drivers unit tests to tests.unit.volume.driver module
* Add version to ibm_storage driver
* Remove support for 2.x volume RPC API
* Remove support for 2.x scheduler RPC API
* Imported Translations from Zanata
* Error message for image conversion failure
* Add cleanable base object and cleanup request VO
* Imported Translations from Zanata
* Fix for Tegile driver failing to establish volume connection
* Removing deprecated Dell EqualLogic config options
* Hacking: Remove C305 contextlib.nested check
* Fix typo: remove redundant 'that'
* Removing cinder-all binary
* Updated from global requirements
* Remove old deprecated driver mappings
* Imported Translations from Zanata
* Nexenta: Use base VolumeDriver migrate_volume
* Add the note of maximum microversion
* VNX: raise exception if no storops
* Speed up kaminario's drivers tests
* VMware: Skip setting vmdk UUID
* Imported Translations from Zanata
* Fix typo in emc_vmax_fast.py
* Disable API v1 by default
* RBD Thin Provisioning stats
* Drop unused parameter in class ExtractSchedulerSpecTask
* Add interface decorator to ibm_storage driver
* Imported Translations from Zanata
* VMware: Remove FakeObject
* Updated from global requirements
* Fix typo in devref/api_conditional_updates.rst
* Fix a typo in manager.py,test_common.py and emc_vmax_utils.py
* Re-use RBDImageMetadata and RBDVolumeIOWrapper from os-brick
* Fix IndexError in volume manager
* Remove ovo[fixtures] dependency from tox.ini
* extract_host: Handle empty host string input
* Updated from global requirements
* Hacking checks for H105
* Remove dead code - replication RPC APIs
* Speed up ibm storwize svc driver's tests
* Files with no code must be left completely empty
* Add support for Infortrend GS Series products
* Add 'replication_targets' and 'display_name' in API docs
* Imported Translations from Zanata
* OVO: OPTIONAL_FIELDS should be moved inside the OVO
* OPTIONAL_FIELDS should be inside OVO object group_snapshot
* Moving the OPTIONAL_FIELDS inside the OVO object group
* Updated from global requirements
* Cleanup lintstack exceptions related to objects
* Imported Translations from Zanata
* Remove placeholder tempest test
* Hacking: remove check for "tests/unit/integrated"
* Allow attribute lazy loading in VolumeType OVO
* Provide cfg to ignore lvm descriptor leak warnings
* Imported Translations from Zanata
* Imported Translations from Zanata
* Imported Translations from Zanata
* Volume get: Check policy before fetching metadata
* Fix a typo in scheduler manager "filter_propterties"
* Fix test case note
* Fix project assignment in VolumeType OVO
* Imported Translations from Zanata
* Fix pep8 E501 line too long
* Using assertIsNone() instead of assertIs(None)
* Fix formatting in generate_config_opts
* Reduce redundant call of image show
* Limit memory & CPU when running qemu-img info
* Updated from global requirements
* Allow getting qos_specs in db.volume_type_get
* Fix missing string format specifiers
* Deprecate LocalVD, SnapshotVD, CGVD, ExtendVD, TransferVD
* Use keystoneauth1 for creating the keystone session
* Add test_get_all_by_volume in objects/test_backup
* replace filter() to meet python3
* Add snapshot id validation during volume creation
* Imported Translations from Zanata
* Remove extra param in list_manageable_snapshots
* Stop using mox in cinder/tests/unit
* Modifies override logic for key_manager
* Remove unnecessary setUp
* Imported Translations from Zanata
* Sheepdog: fix clone failure
* Read domain info from context when contacting nova
* Compact Liberty database migrations
* XtremIO: fix migration bug
* Remove unnecessary setUp and tearDown
* Imported Translations from Zanata
* Don't attempt to escalate cinder-manage privileges
* Remove duplicate keys from dictionary
* Remove unnecessary setUp and tearDown
* Add missing %s in print message
* Create v3 API Reference
* Reserve 5 migrations for Newton backports
* Add os-detach to api-ref
* Fix request_spec conversion from o.vo to dict
* Storwize: remove SCSI LUN ID for volume attaching
* Stop using mox in unit/*.py (2/2)
* Imported Translations from Zanata
* Huawei: Backend capabilies report optimization
* Imported Translations from Zanata
* Imported Translations from Zanata
* Update reno for stable/newton
* NetApp cDOT: Fix model update for cheesecake volumes

9.0.0.0rc1
----------

* Fixed request/response parameters in doc
* Add volume RPC API v3.0
* Add scheduler RPC API v3.0
* XtremIO: bump driver version to 1.0.8
* Imported Translations from Zanata
* Fix missing JSON response in API reference
* Mark v1 as DEPRECATED in devref
* Add xUnknownSliceID to retry list
* Dell SC: ISCSI initialize_connection fixes
* Use IP in Kaminario locks and add/delete loggers
* Add combined function get_vol_type_by_name_or_id
* Imported Translations from Zanata
* Remove unreachable return statement
* Dell SC: Disable connectivity failures for new servers
* Fix release notes formatting
* Fix coerce good values in test_fields.py
* VMAX driver - Does not honor clone volume size
* Updated from global requirements
* Fix glance v2 image update
* Unit test to use vol obj instead of dictionary
* Imported Translations from Zanata
* Remove few Kaminario release notes
* Newton release notes cleanup
* Use to_policy_values for enforcing policy
* Fix logic in retype check for encryption changes
* Added default for ScaleIO driver max_over_subscription
* Save volume_type/group_type uuid into db when creating group
* Imported Translations from Zanata
* DRBD: Don't put clients everywhere
* VMAX driver - Cleanup of Initiator group fails
* Imported Translations from Zanata
* fix the %{} when string formating
* Fixed illegal syntax error code in ScaleIO rename volume
* VMware: Send additional connection info
* Imported Translations from Zanata
* Have a default OPTIONAL_FIELDS for persistent OVOs
* Include OPTIONAL_FIELDS in VolumeType OVO class
* Remove sleep mocks in RBD unit tests
* Fix RBD timeout
* Fix creating typeless volumes with Mitaka's c-sch
* Add missing release notes
* Make sure get_backup_device result is an o.vo
* [api-ref] Correct response code in Cinder API v2
* VMAX driver - failed rollback on VMAX3 when MV issue
* Fix order of arguments in assertIs
* Remove driver interface changes from reno devref
* Imported Translations from Zanata
* Doc: qos-specs is always and only "Administrators only"
* Cleanup Newton release notes
* Clean create_snapshots_in_db method
* standardize release note page ordering
* Dell SC: Error attaching after LV-AFO
* VMAX driver - Removal of iscsiadm from vmax cinder
* VMAX Plugin - Target WWN change for redundancy
* Orphan view and multipath issue in Kaminario driver
* Imported Translations from Zanata
* [api-ref] Correct response code in Cinder API v1
* Eqlx: Ignore missing snapshot on delete
* NetApp cDOT: Fix reporting of replication capabilities
* Mark Scality volume driver as unsupported
* Trivial: Fix a trivial flake8 error
* VMAX driver - Replace "SLO" tag with "ServiceLevel" tag
* Register state_path opts and add it to sample conf
* Imported Translations from Zanata
* Refactor volume status in managing vol
* Updated from global requirements
* VMAX driver - Won't delete pre-existing initiator groups
* NetApp: Fix issue with busy snapshot deletion
* Provide volume size for tempest volume creation
* Nexenta: Added use of sessions for NexentaEdge drivers
* Imported Translations from Zanata
* RBD: Error when managing a nonexistent volume
* Fixed indentation
* XtremIO: fix bug deleting cgsnapshot
* Raise NotImplementedError instead of NotImplemented
* Imported Translations from Zanata
* Support create group with group type name
* Rename specific driver option with synology prefix
* Remove doc for promote/reenable replica
* Imported Translations from Zanata
* Imported Translations from Zanata
* LeftHand add entry point tracing
* Remove host assignment in Snapshot OVO
* Fix lazy loading cluster field from Service OVO
* Fix manage existing MissingDependencies error
* Do not pass unicode to str.isspace()  when disabling a service
* Correction in log massage format syntax
* EMC VMAX - multi-attach failure to VMAX3 when SLO is omitted
* add more credentials information to check_is_admin
* VMAX driver - Retrieve volume from snapshot
* Fix CapacityWeiger to accept None volume type
* Imported Translations from Zanata
* check quota per_volume_gigabytes for transfer-accept

9.0.0.0b3
---------

* Dell SC: Add dell_server_os configuration option
* Add supported driver checks to Zone Manager
* Fix backup unit tests imports for os-brick
* Fix backup unit test with new os-brick
* Stop using mox in unit/api/contrib/ tests (1/2)
* Stop using mox in unit/volume/drivers/*.py
* ScaleIO over subscription support
* Fix exceed of dd action when copying with path
* Fix CapacityFilter to accept None volume type
* Fix HNAS stats reporting
* Imported Translations from Zanata
* Stop using mox in unit/api/v3/ tests
* Deleting volume metadata keys with a single request
* Switch StrOpt to URIOpt for URL config options
* Add Castellan release note
* Changes stats report for ScaleIO driver
* Remove cinder/tests/unit/test_misc.py
* Imported Translations from Zanata
* CoprHD: Handle create volume from CG snapshot error
* Performance issue for VNX attache LUN
* Config logABug feature for Cinder api-ref
* Stop using mox in test_wsgi, test_nexenta, test_netapp
* Remove unused source file tests/unit/db/fakes.py
* Fix an invalid function call in test_consistencygroups.py
* zfssaiscsi driver log messges need cleaned up
* Fix typo in enable_unsupported_driver description
* Mark GlusterFS driver as deprecated
* Retype encrypted volumes
* Fix DellStorageCenter docstrings
* Fix driver interface checks for ZTE driver
* Add CI_WIKI_NAME to ZTE Driver
* Add CI_WIKI_NAME to X-IO Driver
* Add CI_WIKI_NAME to Synology iSCSI Driver
* Create encrypted volumes from images
* Add encryptor attach/detach in utils
* XtremIO: fix the returned value of CG actions
* Stop using mox in unit/api/contrib/ tests (2/2)
* Change assertTrue(isinstance()) with optimal assert
* Stop using mox in unit/*.py tests (1/2)
* Use assertIn instead of assertTrue(A in B)
* Remove unused function from unit/fake_utils.py
* Imported Translations from Zanata
* Clean import in code
* Remove unused config.CONF
* Add tempest tests for Consistency Groups
* HNAS: Add support for manage/unmanage snapshots in NFS driver
* Reduce the runtime of drivers/ibm/test_storwize_svc
* Improve TestCase.mock_object method
* Fix the password print in cinder-volume.log issue
* VMAX Driver - Live Migration for VMAX3
* Remove self.__dict__ for formatting strings
* Imported Translations from Zanata
* CoprHD: Add missing key in ScaleIO driver
* Avoid patch loopingcall in VNX
* Add validation for the metadata properties
* Removed RPC topic config options
* Clean imports in code
* Replace key manager with Castellan
* Cleanup api-ref
* Update api-ref path
* Nexenta: NexentaStor4 NFS driver cache capacity and use sessions
* Stop using /etc/cinder/cinder.conf for cmd tests
* Use utils.validate_dictionary_string_length
* Stop using mox from unit/image/*.py
* Separate create and update rules for volume metadata
* Updated from global requirements
* TrivialFix: remove unnecessary VERSION_COMPATIBILITY
* When only .pyc left, the extended API can not be used
* Recover volume status after remove_export
* Pure - warn when deleting destroyed snapshot
* Fix quota rollback on retype failure
* Pin RPC server's serializer to min obj version
* Driver documentation cleanup
* Host selection when creating backup
* TrivialFix: Remove cfg import unused
* Fix password masking result
* Let setup.py compile_catalog process all language files
* Dell SC: Add exclude_domain_ip option
* Add support for force backup for Nimble Storage
* Retype issue in Kaminario Cinder drivers
* TrivialFix: Remove logging import unused
* Stop using mox in unit/volume/drivers/emc/*.py tests
* Stop using mox in unit/consistencygroup/*.py tests
* Stop using mox in unit/scheduler/*.py tests
* Stop using mox in unit/zonemanager/*.py tests
* Stop using mox in unit/backup/drivers/*.py
* Fix incorrect parameter in create_key
* Use constraints for api-ref environment
* Dell SC: Live Volume Autofailover
* Add new supported driver checks
* Tests: Fix racy volume unit test
* [Trivial] Refactor the using of dict.get() in the test assertion
* vzstorage: fix create/delete snapshots
* Sending ScaleIO volume id in attach and detach volume
* Cleanup upgrade-related FIXME's
* Using oslo_config's min attribute
* Add replication failback in Kaminario K2 drivers
* Added config option to enable SSL
* Group specs: Fix exception name
* Dell SC: Failback replications limited to 5 at a time
* VMware: Add volume name in vCenter to conn info
* NetApp: Report multiattach as enabled
* Attachment lost after migrating in-use volume
* Fix typo in the huawei_driver.py
* Fix invalid services caused by enabled_backends
* Updated from global requirements
* Change NFS driver to not throw exception without nfs shares file
* Datera driver 2.2 update
* Reduce the runtime of drivers/dell/test_dellsc
* Add release note to warn about os-brick lock dir
* Updated from global requirements
* Use min attribute from oslo_config
* Imported Translations from Zanata
* Fix the interface to call update_server_volume
* Dell SC: Break_replication unhandled NoneType error
* Volume Manage/Unmanage Support for IBM FlashSystem
* Imported Translations from Zanata
* Change a typo error in the releasenote
* Fix reported driver's versions
* Use OVOs to set errors in manage volume/snapshot
* Use original volume OVO instance in create flow
* Fix mysql binary comparison
* VMware: Allow images in ova container
* Add CI_WIKI_NAME to driver's devref
* Improve Hitachi HNAS volume drivers log messages
* Updated from global requirements
* EMC VMAX - iSCSI Multipath support
* Fix typo in cinder/tests/unit/image/test_glance.py
* Clean imports in code
* Imported Translations from Zanata
* Enhance api_microversion doc
* Add CI_WIKI_NAME to Tegile volume driver
* Add get_manageable_* methods to Pure drivers
* Use constraints for all tox environments
* Imported Translations from Zanata
* Remove the using of dict.get() in assertIsNone
* Revise Synology DSM storage driver
* Refactor the usage of save_and_reraise_exception
* Add volumes/summary API support
* Imported Translations from Zanata
* Ignore case when comparing wwns in Pure FC driver
* NetApp: Add Consistency Group Support for NFS
* Replication, hard-coding and dict.name issues in K2
* Update homepage with developer document page
* Add CI wiki page to driver listing
* Imported Translations from Zanata
* Refactor cinder.utils._copy_volume_with_path
* HNAS: Deprecating XML config file
* Add functional-py35 to tox
* Remove code duplication in enums
* Concurrency issue in K2 iSCSI and FC Cinder drivers
* VMAX Driver - QoS support for the VMAX3
* Mask out passwords when tracing
* Remove debug logger translations
* Imported Translations from Zanata
* Fix volume creation with no volume type
* Dell SC: delete_live_volume payload incorrect
* Dell SC: Requests async header is invalid
* Imported Translations from Zanata
* Use object instead of string when reset backup
* Prevent doc generation failure on OVO decorators
* CI: Add CI_WIKI_NAME to all drivers
* Imported Translations from Zanata
* Make the volume-manage doc be more general
* Add missing dependency on keystoneauth1
* Fix tox pip-missing-reqs
* Revert "Remove Tegile volume driver"
* HPE XP add entry point debug tracing
* Remove resource_common_manage load warning
* Updated from global requirements
* Huawei: Modify array LUNs naming rules
* Added update-host for CGs in cinder-manage
* Imported Translations from Zanata
* Remove unused context parameter
* Imported Translations from Zanata
* QoS support for the Coho Data Cinder driver
* Fix backup NFS share mount with default backup_mount_options
* Add tracing to remotefs entry points
* NetApp cDOT: Add cheesecake replication support
* Don't use config option sqlite_db
* Improve snapshot handling in K2
* Fix volume retype from SolidFire
* EMC VMAX - Oversubscription support
* Ceph doesn't save a container name for volume backup
* Updated from global requirements
* Fix volume upload-to-image for vhd disk-format
* Imported Translations from Zanata
* Remove context object in oslo.log method
* 3PAR add entry point debug tracing
* Fail manage operations if service is down
* Support retype in K2 cinder driver
* Remove comma from end of policy.json
* Prevent adding same OVO version twice to history
* Removed a dead db function register_models()
* Handle snapshot delete conflict in 3par driver
* Imported Translations from Zanata
* Specify key algorithm and size for create_key
* Add functional-py34 to tox
* Fix size exceed of dd action when clearing a volume
* HNAS drivers refactoring
* Use volume o.vo in get_backup_volume_temp_snapshot
* Imported Translations from Zanata
* Fix ImportError of fake_driver
* Add proxy config option to google backup driver
* Add API Reference for groups
* Add stochastic weight handler to scheduler
* Fix Scheduler manager masking retype fail details
* fixed misspelling in synology_common.py
* Updated from global requirements
* Don't puke when exiting driver list
* corrected the help string in coho.driver
* Fix ImportError of fake_driver
* Storwize:create_volume_from_snapshot with different size
* Imported Translations from Zanata
* Fixing pending comments for CoprHD Drivers
* Huawei: Fixed problems caused by password expiration
* Add metadata length check to volume-manage
* Added unit test coverage to test_limits.py for api v2
* Dell SC: Use Live Volume for replication
* Remove race condition from lvextend
* Switch request_spec in create volume calls to ovo
* Support replication in K2
* Support manage/unmanage and extra-specs in K2
* Update xiv_ds8k driver name and description
* Imported Translations from Zanata
* Set VERSION in VNX cinder driver
* ScaleIO ignore rename of external volumes
* Managed snapshot should return ceiling of size in Huawei driver
* Size in tintri driver should be converted to integer
* Improvement to query cg detail(Part 1)
* Fix documentation and remove dead code
* VMware: Fix retype when storage policy is enabled
* Validate name in qos-spec
* Replace functions 'Dict.get' and 'del' with 'Dict.pop'
* Updated from global requirements
* NetApp: Report hybrid aggregates in volume stats
* Storwize: Quote vdisk names to handle spaces
* Add group_type_id in create_group_snapshot
* Fixes ZFSSANFS driver
* DRBD: Disk-options for new resources
* Fix mistakes introduced with QoSSpecs object
* Add backup update function (microversion)
* VMware: Fix upload to image with glance v2
* Remove Tegile volume driver
* Quobyte volume driver should use DLM
* Add functional tests for nested quotas
* XtremIO: Implement update_migrated_volume
* NetApp: Refactor unit tests
* Add driver list to doc build
* Move fake_driver to tests root dir
* Map volume/snapshot manage extensions to v3
* Replace OpenStack LLC with OpenStack Foundation
* VMAX Driver - SnapVX licensing checks for VMAX3
* LVM driver: list manageable volumes and snapshots
* Sheepdog:fix the bug of failed to clone image
* Move drivers unit tests to unit.volume.drivers directory
* Docs: Correct i18n information
* Fix db purge for quality_of_service_specs FK constraint
* Fix log message when service is disabled
* Add interface documentation to driver devref
* Remove duplicate code in functional tests
* Docs: cleanup doc8 errors
* Docs: remove todo list generation
* Update doc README and remove old Makefile
* Imported Translations from Zanata
* Handle API NotFound exceptions at WSGI level
* Add worker's DB operations
* Add workers table
* Modify API to include cluster related operations
* Update manage with cluster related commands
* Improve cinder-manage arg parsing
* Add cluster job distribution
* Update Versioned Objects with Cluster object
* Add cluster table and related methods
* Update OVO instance on destroy method call
* Fix wrong declaration in Scheduler's base driver
* Refactor sqlalchemy service methods
* Improve api_version decorator to avoid noqa
* Imported Translations from Zanata
* Add functional tests for groups
* Tests: mock notifier in CG tests
* Remove duplicated code in manage_existing_snapshot
* Initialise oslo.privsep early in main
* Imported Translations from Zanata
* Add lock decorator to SolidFire clone_image method
* Dell: Fix docstring cut/paste error
* NetApp: Support new parameter to cDOT clone API
* Auto sync manager's RPC_API_VERSION
* Fix CinderPersistentObject.refresh
* Replace locks in remotefs and glusterfs backend drivers
* Block Device Driver: report pools in volume stats
* Add missing test case
* Updated from global requirements
* Invalid volume state when manage operation fails
* Add group snapshots - APIs
* Dell SC: Add secondary DSM support
* Fix some typos
* Remove generate_driver_list dependency on cur dir
* Huawei: Support reporting disk type of pool
* Fix 500 for 'qos-create' key or value > 255 characters
* Add group snapshots - manager
* Add group snapshots - db and objects
* XtremIO: support of snapshot manage commands
* Fix the group type filter
* Fix policy check for group types
* Differentiate thick and thin provisioning
* Remove force option from create_snapshots_in_db()
* Set sleep time to 0 in Datera driver
* Add generic volume groups
* Huawei: Support backup snapshot
* Fix assertEqual usage in test_volume_manage
* Fix chunked backup driver interface name
* Removed unused code from cinder.utils
* 3par driver handles concurrent host create conflict
* Fix typo in delete snapshot in Synology driver
* Removed unused code from cinder.utils

9.0.0.0b2
---------

* Fixes consistency snapshot creation
* [doc] Fix a non-alphabetical order bug
* Trivial: Use fake.VOLUME_ID instead of id
* Violin Memory iSCSI storage for 7000 series AFA
* update min tox version to 2.0
* Updated from global requirements
* Switch _create_temp_cloned_volume in driver to VO
* NetApp: Add aggregate capacity info to scheduler
* Add strict Boolean checking for storage pools
* Add Synology DSM storage driver
* Use from_environ to load context
* Use context.from_dict to determine available arguments
* Add ZTE Block Storage Driver
* iSCSI Target: remove confusing comment/log
* Storwize: Fix exception ProcessExecutionError
* Changing method _from_db_object to classmethod
* Allow admin project to operate on all quotas
* Use default provisioning type from config
* Delete *.pyc files before running tox tests
* Implementation for CoprHD Cinder Drivers
* Image virtual size doesn't fit to volume size
* Don't apply config fixture to auth_token.CONF
* Check flashcopy mapping before deleting volume
* Send scaleio id to os-brick
* Nexenta: Added HA support and enhance get_volume_stats()
* Fix failure with "None" volume type in Pure drivers
* Add backend driver for Zadara Storage VPSA
* Add group type and group specs
* Don't use shred for volume clearing
* Add cinder backend driver for Huawei FusionStorage
* Do not conjecture volume-id from iscsi_name
* VNX: New Cinder driver in Newton
* Return vaild reason when unknown error occur
* Moving the OPTIONAL_FIELDS inside the OVO  object
* Support microversions on inherited Controllers
* Replace use of mox with mock in test_base_filter
* Replace 10 ** 9 with a constant units.G
* Reduce logging level of API validation messages
* Fix manage existing volume fails after object merged
* Add strict Boolean checking for volume manage
* Adds unit test coverage for consistencygroups.py
* FalconStor: New Cinder driver in Newton
* Move QualityOfServiceSpecs to use VersionedObject
* Snapshot object has no attribute about size
* Add return parameter info for manage_existing_get_size
* cinder-manage db purge has issues with foreign keys
* Huawei: Use versionedObject
* Resolve unittest hang issue
* Fix some typos
* Add logging when filtering returns nothing
* Validate extra_specs type
* Just a few spelling modification. "occurred"
* Remove white space between print and ()
* Log traceback for initialize connection failure
* Remove unused LOG
* Use assertEqual/Less/Greater/In/IsNone
* Updated from global requirements
* Add __ne__ built-in function
* Fix consisgroup V3 interfaces
* Add proper scheduler_hint key to dev-ref
* check the validity of metadata when update volume
* Remove unused __init__
* EQLX: Extend of snapshot or clone failure
* Log terminate_connection exception with traceback
* Replace use of mox with mock in test_api_urlmap
* Add README in release notes directory
* Fix broken link in HACKING.rst
* Replace int with float to bring math.ceil into effect
* EMC ScaleIO should return ceiling of volume size
* Deprecate defining c-vol backends in DEFAULT
* Dell SC: Do not set High Availability in async mode
* Replace use of mox with mock in test_ibm_xiv_ds8k
* Remove translation from config options
* Correct reraising of exception
* EMC VMAX - locking SG for concurrent threads
* Use elevated context to query DB in VolumeNumberWeigher
* Huawei: Support huawei consistency group
* Make divisible py3 compatible in nfs driver
* Updated unit tests to use official unittest methods
* Fix raise UnableToFailover call in SolidFire
* Provide Kaminario K2 all-flash array FC driver
* RBD: uppercase rbd_opts for consistency
* Add strict Boolean checking for volume create
* Replace use of mox with mock in test_brick_lvm
* Replace use of mox with mock in test_lvm_driver
* Remove six.iter*
* Updated from global requirements
* Add validation for container name
* VMware: Fix create vol from streamOptimized image
* Use True instead of 1 in while loop
* Remove mock.patch.stopall call in test_smbfs
* XtremIO: fix test suite
* Add strict Boolean checking for quota show
* Correct unavailabe to unavailable
* Huawei: Support iSCSI configuration in replication feature
* Dell SC: Specify High Availability for create replication
* Increment Pure Storage Driver Versions
* Refactoring Kaminario iSCSI driver
* Don't reuse pep8 env in compliance tox runs
* Trivial Fix
* NetApp: Finish SSC refactor by removing dead code
* Implement unit test for HPE Lefthand driver
* Added coverage report to tox.ini
* Add strict Boolean checking for qos delete
* Add validation for type extra_specs
* Replace mock with self.override_config
* fix cinder ceph backup driver padding error
* Replace 1024*1024*1024 with units.Gi to express more accurately
* Unexpected function is called in _migrate_volume_generic
* Violin: resize volume if cloned lun is larger
* Make dict.keys() PY3 compatible
* Move _validate_extra_specs to cinder/utils
* VMware: Refactor vmdk unit tests
* Updated from global requirements
* Move _check_metadata_properties to cinder/utils
* Remove deprecaterd mapping in manager.py
* Capability lists in Cinder scheduler
* Updated from global requirements
* Nexenta: Add NBD driver for NexentaEdge
* Add missing coordination=True on service start
* tempest: Add Unicode volume name test
* Adding Scaling QoS for ScaleIO driver
* Updated from global requirements
* Implement match-set type 3PAR FC VLUN creation
* Fix pylint error in K2 iSCSI driver
* Fix lock files littering working dir during tests
* Fix TSM backup driver test mocks
* Improve DB volume check in LVM manage volume
* VMware: Honor vmware_cluster_name during retype
* Revert "Revert "use utf8 as default charset for all tables in mysql db""
* Fix snapshot stuck in 'deleting' after reboot c-v
* Update initialize_connection to use versionedobjects
* Updated from global requirements
* NetApp: Replace SSC for cDOT block & file drivers
* Revert "use utf8 as default charset for all tables in mysql db"
* huawei-iscsi-multipath-support
* use utf8 as default charset for all tables in mysql db
* Implemented unit test cases for HPE LeftHand driver
* add FIXME tag for extra argument 'topic' in scheduler rpc api
* update coordination.Lock.release's docstring
* Fix permissions error when configuring nfs backend
* Use cinders test class in cloudbyte unit tests
* Correct DB modifications from compaction
* Add unit tests in cinder for HPE Lefthand driver
* Provide Kaminario K2 all-flash array iSCSI driver
* VMware:Persist storage policy ID in vmdk meta-data
* Allow setting CG name or description to empty value
* Support None value of extra_specs in cinder-scheduler filter
* Fix db purge for volume_types FK constraint
* ABC Metaclass for IBM FlashSystem
* IBM FlashSystem: Add host check for iSCSI driver
* vzstorage: add ploop volume format support
* Use versionedobjects in remotefs.py
* Move test from test_glusterfs and test_quobyte to test_remotefs
* Netmask needs corersion to string
* image_size_m should get ceiling of image
* Add unit tests in cinder component for 3PAR driver
* Handle quota exceed exception
* Replace locks in volume manager
* Updated from global requirements
* Start/Stop coordinator with Volume service
* Tests: Remove notification_driver config
* Tests: Use mock for notifier tests
* 3PAR: Fix delete volume when online clone
* Add driver interface checks
* Add test type clarification to devref
* Backup and restore broken in zfssaiscsi driver
* Windows SMBFS: fix VHD/x resize
* Remove duplicated fake drivers
* Cleanup volume_type_projects
* Implement OVO class init mechanism
* Add debug level logs on OVO backports
* Stop assuming persistent OVOs are also DictCompat
* Move OVO methods from CinderObject to Persistent
* Remove remotable from OVOs
* Use manifest to backport OVOs during upgrades
* Nimble: Don't query all vols from DB in do_setup()
* Fix wrong usage of exception's attribute message
* Add parameter info for manageable snapshots
* Adds ACL, IP Pool, Multipath to Datera Driver
* Dell SC: Retry unhandled exception REST Gets
* Fixed _create_3par_iscsi_host(), added unit test for 3PAR
* Set QoS on cloned volumes
* VMware: Deprecate vCenter version 5.1
* Update manage_existing to use volume object
* VMware: Fix constants in unit tests
* Updated from global requirements
* EMC driver should return ceiling of volume size
* Use oslo_middleware sizelimit
* migrate to os-api-ref
* volume upload-to-image fails for iso disk-format
* Huawei driver should return ceiling of volume size
* Volume manage/unmanage support for Eqlx driver
* NetApp: Log unexpected errors from backend
* Add Auth Version 3 support in Swift Backup Driver
* Add error messages to conditional updates devref
* Add docstrings to CG and CG Snapshot filters
* Virtual size should get ceiling of image
* DRBD: Allow to set options for new resources
* SolidFire driver should return ceiling of volume size
* Clean up man page and remove version/date
* 3PAR: Fix terminate_connection when failed over
* VMware: Remove unused methods
* Fix MySQL DB error in Delete CG
* Nimble driver should return ceiling of volume size
* Updated from global requirements
* Remove locks from Pure volume drivers
* Give more fine grained access to DriverInitiatorData
* Remove IN_USE from ConsistencyGroupStatus enum
* Compact Kilo database migrations
* Bump to Nova v2.1
* Switch to using correct TaskFlow Failure class
* Optimize service find in migration
* NetApp NFS Cmode: Fix NotFound exception
* Add check to limit maximum value of age_in_days
* GPFS: Fix consistency group ERROR_CREATE status
* Remove the duplicated definition of _add_to_threadpool
* Imported Translations from Zanata
* Coho data sanity fix in the driver unittest

9.0.0.0b1
---------

* Dell SC: Added support for failover_host failback
* Remove API races from consistency groups
* Minimize cost of DB exists decorator checks
* Pass volume_type_id in when deleting snapshot
* Add unit test case in Nimble Driver
* Fix attachment_get_by_* to return entire list
* Remove API races from migrate and retype
* SwiftBackupDriver: Dont add project_id to authurl
* Updated from global requirements
* Catch GlanceMetadataNotFound in creating cgsnp
* Updated from global requirements
* List manageable volumes and snapshots
* Updated from global requirements
* Add pagination support to messages
* gpfs: Add changed options for 'find' command in rootwrap filters
* Huawei replication should use auto recovery policy
* Dell SC: Switched REST calls to async where available
* Move all backups related unit tests to backup directory
* Move consistency groups tests to consistencygroup directory
* Volume manage should parse volume size as float
* Return BadRequest for invalid 4byte unicode character
* NetApp: Add iterator handling to client library
* Make IBM drivers return snapshot object for cg ops
* Coho Data: Reconnect to cluster on broken pipe
* Remove mox usage from test_nexenta
* Manage/unmanage snapshot in ScaleIO driver
* 'display-name' is not used in snapshot_manage
* LeftHand Fix terminate_connection when failed over
* Storwize: terminate_connetion NPIV perf improvement
* Revert "Add hacking check to prevent assert_called_once"
* Fix 3PAR cg display name issues
* DRBD: ensure_export() might not have 'provider_location'
* Fix image-volume cache to use volume object when evicting
* Fix retype from non-repl to repl type in Pure drivers
* Remove test_conf.py
* Dell SC: Changed rename volume REST API call
* Add hacking check to prevent assert_called_once
* Updated from global requirements
* Huawei: Raise if no FC port found
* VMware: Increase default task poll interval
* VMware: Update volume config during unmanage
* Drop use of invalid assert_called_once call
* Fix AttributeError when obtaining 'name' attribute from 'snap'
* Handle SSL termination proxies for version list
* Call _init_volume_driver in backup manager
* Updated from global requirements
* model_update for temp volume or snapshot in backup
* Add debug messages and comments for ceph backup
* Avoid ascii code error for request body strings
* Fail on disabled_reasons with more than 255 chars
* Windows iSCSI: properly handle config option
* Remove unused logging import and LOG global var
* Fix Brcd zone driver initiator zone update
* Add SnapshotStatus enum field
* Tests: Fix mock imports
* NetApp: Remove type checks from manage workflow
* ScaleIO actual volume size model update
* Capacity weigher: Pass correct arg to super()
* IBM Flashsystem: Add missing items to common
* Prevent Multitable conditional updates
* Remove support for 1.x volume RPC API
* Remove inappropriate Copyright
* RBD: include cluster name in connection info
* Tests: Don't attempt connection for Coho driver init
* 3PAR Clean up VLUN deletion on detach
* Remove object to dictionary translation logic
* Refactored the update method in api.py for vol obj
* Tests: Use unique volume IDs in backup tests
* Move LVM tests to test_lvm_driver.py
* Move CG unit tests to test_cg.py
* Fix an error in CG object
* Fix backup using temp snapshot code path
* IBM FlashSystem: Cleanup host resource leaking
* Updated from global requirements
* Add sample config file to cinder docs
* Make api_microversion_dev more explicit
* Use check_string_length from oslo_utils
* Fix up RPC cleanup process
* Add unit tests in cinder component for HPE drivers
* Whitelist 'rm' in api-ref tox environment
* gpfs: remove a race in deleting volumes
* Fix taskflow parameters for manage_existing
* Correct misspelt words in msg in cinder
* Implement CHAP Authentication for E-Series Driver
* WADL to RST migration in cinder tree
* Properly mock out image_utils operations for tests
* Dell Eqlx: Volume from snapshot now honors resize
* Use example.com in unit tests
* Extend remove_version_from_href support
* Fix return value of _clone_image_volume
* image: don't use is_public with glance V2 API
* Change provider_id to StringField
* Add missing SnapshotUnavailable to cinder/exception.py
* NetApp: Rewrite user API discovery logic
* Remove unnecessary v3 VolumeController.__init__
* Fix v3/volumes.py VolumeController super(...) parameters
* DB: Optimize volume existence check
* Reorder DB API require_context decorators
* Remove API races on extend and volume_upload_image
* Manage existing volume with invalid host
* Remove CG db access in Storwize driver
* Specify a user-agent in Pure volume drivers
* Dell SC: find_volume failure in manage and retype
* 3PAR driver failure SR License missing in array
* Remove unnecessary created_at from ORM Message
* Fix uncaught NotFound exceptions
* Remove support for 1.x Backup RPC API
* Provide consistency to "Openstack-Api-Version" header
* Change OVOs project_id and user_id to StringField
* Use to_utf8() instead of safe_encode() in convert_str()
* Replace manually changing CONF options
* remove extra quota commit of manage snapshot
* Add replication v2.1 test cases
* Move initiator_data access to helper methods
* Add ability to filter by volume_glance_metadata
* Add Cheesecake APIs to policy.json file
* Add upload_image API role-based access policy
* Add snapshot_metadata operations to policy.json
* Mark the v1 API as deprecated
* Fix Lun ID 0 in HPE 3PAR driver
* Added 'volume:get_transfer' to policy.json file
* NetApp: Decouple capacity volume stats collection
* NetApp: Managing cDOT LUN by UUID fails
* VMware: Use _in_use() to check for in-use volumes
* Add devref for conditional updates
* Fix gate-cinder-tox-db-functional job
* Add ordering possibilities to conditional update
* Add unmanage volume for RBD driver
* Updated from global requirements
* VMware: Support for paraVirtual image adapter type
* Pass default executor to os-brick
* NetApp: E-Series driver using invalid host-types
* NetApp: Use Local Cache to Copy an Available Image
* Add provider_location to cloned volume
* Failback will enable the host that has been frozen
* Move and rename tempest_tests to cinder/tests/tempest
* Tests: lower case all fake uuid constants
* Tests: Fail if oslo.versionedobjects issues Invalid UUID warnings
* Removed extra line of code
* Fix uuid warnings in various api contrib unit tests
*  Fix snapshot test uuid warnings in api.contrib
* Fix volume test uuid warnings in api.contrib
* Fix vol type/spec uuid warnings in api.contrib
* Fix qos_manage uuid warnings in api.contrib tests
* Fix CG uuid warnings in api.contrib unit tests
* Fix admin_actions uuid warnings in api.contrib
* Fix uuid warnings from api.contrib backup tests
* Fix uuid warnings from test_db_api unit tests
* User messages API for error cases
* Imported Translations from Zanata
* Imported Translations from Zanata
* Assisted snapshot:  use Keystone Session with Nova Client
* Imported Translations from Zanata
* fix invalid uuid in emc extremio unit tests
* fix invalid uuid warnings from test_cmd
* Fix invalid uuids in tintri unit tests
* Fix uuid warnings from db unit tests
* Fix invalid uuids in EMC scaleio unit tests
* Tests: Fix invalid UUIDs in EMC VNX tests
* ibm flashsystem: Fixing hardcoded attribute
* Fix 20 typos on devref
* VMware: Remove TODO for port config option
* Remove XML API
* Microversion of Bootable filter in cinder list
* init_host offload to default to true
* Imported Translations from Zanata
* Updated from global requirements
* 3PAR: Remove metadata that tracks the instance id
* Updated from global requirements
* Handle TFlow short comings in SF driver
* Add failed_over detection to SolidFire driver
* Implement replicate_volume & failover on SolidFire
* Deprecate nas_ip and change this to nas_host
* Imported Translations from Zanata
* Implement Cluster Pairing for SolidFire Driver
* Fix minor typos in the migration devref
* Cleanup volume_attachment in case of reset-state attach_status
* Updated from global requirements
* Use messaging notifications transport instead of default
* Fix doc and source documentation errors and warning
* RBD: delete snapshots if missing in the backend
* Coding style issue
* Remove support for 1.x scheduler RPC API
* Launchpad Answers no longer used
* Fix RPC and Object version pinning on API
* Fix service version pinning on start
* Fix doc build if git is absent
* Updated from global requirements
* Tests: Define fake_constants as constants
* Doc: Remove incorrect run_tests.sh documentation
* fix invalid uuid warnings from test_quota
* Fix fake uuids in NetApp ESeries unit tests
* Fix invalid uuids in sheepdog unit tests
* Use utils.convert_str to convert HTTP header values
* Remove deprecated ISERTgtAdm
* Set backup import volume id to real uuid
* fix ConsistencyGroup volume_type_id field
* Updated from global requirements
* Storwize: Multiple management IP not raising exceptions
* Fix ExtraSpecsOpsTestCase sub unit tests
* check per_volume_gigabytes quota for cinder extend
* Imported Translations from Zanata
* Updated from global requirements
* Make cinder-all binary deprecated
* Add in-tree tempest tests
* Update SolidFire driver to store cluster info
* VMware: Reduce volume creation time
* Fix typos in Cinder files
* Fix driver.failover_host call in manager.py
* Remove "patch mock to raise for invalid assert calls"
* Add test for checking object compatibilities
* Update the Administrator guide links
* Update _usage_from_backup() method with versionedobjects
* Dell SC: Updated to utilize provider_id
* Updated from global requirements
* Sheepdog:make full use of all sheepdog nodes
* Enable str2size() to handle long int for i386
* Imported Translations from Zanata
* Hacking: Ignore tools/ for C303
* Pylint: refactor ignored message lists
* Brocade FCZM: Fix LOGOUT_PAGE reference
* Fix volume retype failure with on-demand policy
* Define context.roles with base class
* Fix invalid error message of volume create
* Stop using tpool with oslo_db
* Huawei: Do not do split if replication pair abnormal
* Storwize: fix unmapped multi-attached volume failure
* Cleanup DB schema after Mitaka
* Fix uuid warnings from api.v2 unit tests
* Dell SC: Checking volume size in create_volume_from_snapshot
* Fix uuid warnings from api.v1 unit tests
* Fix api/v1 unit test inconsistencies
* Add fake_cgsnapshot for unittest use
* Fix typos in Cinder files
* http header value must be a string
* python34 tests don't run without python3-dev
* Re-enable image to volume with failure test
* Dell Eqlx: Cloning volume does not honor new size
* Storwize: fix deadlock and major lock granularity issue
* Fix for NexentaEdge jsonrpc url formatting
* Support oversubscription for IBM Storwize/SVC

8.0.0
-----

* Huawei: Fix getting admin_metadata
* Imported Translations from Zanata
* NexentaStor4 iSCSI: convert blocksize to str
* Conditionally restore display_name
* NexentaStor drivers: resize volume if cloned image is larger
* rtstool surrounds IPv6 addresses by brackets
* Imported Translations from Zanata
* NexentaStor: Remove extra format string specifier
* Fix typos in Cinder files
* Imported Translations from Zanata
* XtremIO handle errors in terminate_connection:
* Imported Translations from Zanata
* Check hasattr before calling get in SolidFire
* Huawei: Fix getting admin_metadata
* Remove unused utils.find_config function
* Sheepdog:optimization of connection error handling
* DRBD: extend volume if larger than snapshot
* Imported Translations from Zanata
* Fix invalid uuids in rbd unit tests
* Dont query image metadata for empty volume list
* Remove entry_points from setup.cfg
* Don't suppress the path part of glance url
* Fix meaningless quota exceeded exception info
* Imported Translations from Zanata
* Don't disallow quota deletion if allocated < 0
* Added more options while uploading volume as image
* VMware: Support for non-default port
* Remove PyMySQL and psycopg2 from test-requirements.txt
* Imported Translations from Zanata
* Provide user friendly message for FK failure
* Fix misspelled word in help text
* Datera: resize volume if cloned image is larger
* Fix Brcd lookup service to use defined southbound protocol
* Docs: Add genconfig to devref toc
* Updated doc string
* Imported Translations from Zanata
* Report 2.0 as supported version of RPC APIs
* Fix volume RPC API methods related to backups
* Report 2.0 as supported version of RPC APIs
* NexentaStor5 iscsi: resize volume if cloned image is larger
* Imported Translations from Zanata
* EMC VMAX - Operations and timeout issues
* Imported Translations from Zanata
* Imported Translations from Zanata
* Fix the format problem of LOG in failover_host
* Dell SC: Error results moved to json
* Dell SC: create_cgsnapshot returning wrong structure
* Re-add policy check for get_snapshot
* Enable functional test for volume creation
* Remove bandit.yaml in favor of defaults
* NexentaEdge: resize volume if cloned image is larger
* Storwize: Set multiattach property per pool
* Fix volume RPC API methods related to backups
* Imported Translations from Zanata
* Imported Translations from Zanata
* Fix race condition when toggling SP
* Dell SC: create_cgsnapshot returning wrong structure
* Hitachi drivers: resize volume if cloned image is larger
* Huawei: Record and check LUN wwn
* Mark deprecated options correctly
* SMBFS: fix parsing volume type extra specs and metadata
* Update reno for stable/mitaka
* VMware: Bump driver version
* VMware: Bump driver version
* Imported Translations from Zanata
* VMware: Refactor unit tests
* Update .gitreview for stable/mitaka
* Huawei: Record and check LUN wwn

8.0.0.0rc1
----------

* Reserve 5 migrations for Mitaka backports
* Add update_host for backup in cinder-manager
* Fix formatting in vol/snap delete API messages
* Cleaned duplicate dictionary values
* Fix compatibility mode of backup jobs scheduling
* Add devref on rolling upgrades
* 3PAR fix create_cloned_volume for larger size
* VNX: Enhance migration start verification
* Check volume_id consistent when creating backup
* Fix race condition when toggling SP
* Huawei: Check when attach hypermetro volume
* Huawei: Check the QoS status before we use
* LeftHand: Add default SSH timeout and key values
* Pass correct source_id to _handle_bootable_volume_glance_meta()
* Alter wrong comment about param filters
* Use get_by_args instead of get_by_host_and_topic
* Fix format in cinder/volume/drivers/netapp/dataontap/block_base.py
* XIO: refactor _send_cmd to reduce the redundant
* Revert "VNX: Set timeout for naviseccli"
* NetApp E-Series: Volumes not added to consisgroup
* Fix volume migration VolumeType exception
* Fix retype failure when original has no volume type
* Add backup RPC API v2.0
* IBM XIV/DS8K: Implement Replication v2.1
* Huawei: Implement v2.1 replication
* Remove circular import to fix config generation
* Wrong comment line in quotas.py
* XtremIO handle errors in terminate_connection:
* Imported Translations from Zanata
* VNX: Set timeout for naviseccli
* VNX: Allow set migrate rate when migrating volumes
* Fix ScaleIO driver does not honor clone size
* Fix py34 error of indexing 'dict_keys' object
* Imported Translations from Zanata
* Fix error message when running genconfig
* Huawei: Creating hypermetro failed in the remote pool
* Delete deprecated configuration in NFS tests
* Imported Translations from Zanata
* Emit notifications for volume retype
* Fixup stats key for replication in init_host_with_pc
* EMC VMAX - SSl connection is not picking up values
* Add the key 'replication' and set the correct 'replication_status'
* register the config generator default hook with the right name
* Fix for Pure drivers not checking full client version
* Fixup for Pure drivers cheesecake replication setup
* Remove empty directories and unused files from unit tests
* Cleanup 3PAR/LeftHand failover_host exceptions
* Use googleapiclient import instead of apiclient
* Enable api.view.test_versions unit tests
* Allow clone volume with different size
* DRBD driver: resize volume if cloned image is larger
* Fix 500 error if 'offset' is out of range
* Add volume RPC API v2.0
* Imported Translations from Zanata
* typo: add a missing '}' in comment
* Fix up failover_host exceptions to preserve states
* Add release note for delete volume with snaps
* RBD: remove duplicate clone test
* Disallow quota deletes if default under usage
* EMC VMAX - SnapVX and other snapshot improvements
* Move replication_status update to init_with_rpc
* Lazy load a project quotas's default values
* Permit volume type operations for policy authorized users
* SMBFS: fix parsing volume type extra specs and metadata
* Host selection in backup service
* Add volume_type to volume object expected_attrs
* VNX: Update replication for v2.1
* Imported Translations from Zanata
* Pass new volume size when cloning (blockbridge)
* Storwize: Update replication to v2.1
* LeftHand: Create cloned volume didn't honor size
* Switch failover-host from rpc call to cast
* Dell SC: Active_backend_id wrong type
* Show qos_specs_id based on policy
* Remove remaining oslo-incubator code from Cinder
* Updated from global requirements
* Pass RBD order to clone call
* Remove "sqlite_clean_db" option
* Exclude test.py from sample conf
* Fix invalid UUID warnings for test_volume_*
* Huawei: Check before delete host
* rbd: Change capacity calculation from integer to float
* Fix failure with rbd on slow ceph clusters
* Remove those unnecessary statements "return True"
* Imported Translations from Zanata
* Run py34 tests with plain 'tox' command
* Report versions in cinder-manager service list
* Dell SC: create_cloned_volume didn't honor size
* Cleanup Mitaka release notes
* Dell SC: Incorrect values in REST API Login call
* Moved CORS middleware configuration into oslo-config-generator
* Add get_volume_stats for LoggingVolumeDriver
* Correcting thin provisioning behavior
* SMBFS: Fix initialize connection issues caused by in-use images
* NetApp: volume resize using clone fails with QoS
* VMware: Unit test refactoring
* Fixes creating volume issue for multiple management IPs
* Imported Translations from Zanata
* Add volumes table definition when migrating to 67
* Trim 5s+ from storwize unit tests
* Allow api_version_request.matches to accept a string
* microversion header for legacy endpoints removed
* Update quotas to handle domain acting as project
* Continue volume delete on encryption key delete errors
* Fix backup import
* Unset executable bit in release note
* DRBD: Policy-based waiting for completion
* Block subtractive operations in DB migrations
* Handle exceptions about snapshot in backup create
* Replace logging with oslo_log
* Support https keystone CA checking in volume quotas
* Imported Translations from Zanata
* Fixup release notes for v2 -> v2.1 replication impls
* support new HTTP microversion header
* Fix for glance_metadata during volume migration
* Readd iscsi_target table
* Imported Translations from Zanata
* Fix issue with Pure drivers delete_snapshot exception handling
* Add backend id to Pure Volume Driver trace logs
* Don't fail on clearing 3PAR object volume key
* Fix invalid uuid warnings in backup unit tests
* Update quota_utils with import for keystone_auth
* Fix invalid uuid warnings in test_volume.py
* Tintri image direct clone
* Use get_by_args instead of host_and_topic
* Remove a vol in error state from a CG
* Fix call to Barbican Secrets create()
* 3PAR use same LUN id for each export path
* Fix oslo.service config generation
* Update unittest for Storwize pool-aware-cinder-scheduler
* Huawei: Check the real size before extend volume
* Revert "Remove Cisco FC Zone Manager Driver"
* Make query to quota usage table order preserved
* Allow for Pure drivers to verify HTTPS requests
* Fix volume filtering for quoted display name

8.0.0.0b3
---------

* Use openstack.org URLs in README
* Add attach/detach doc to index
* Don't run test_volume.VolumeTestCase twice
* Fixes running error for storwize _run_ssh
* Dell SC: Support Replication V2.1
* Use OSprofiler options consolidated in lib itself
* Fix test_create_volume_flow test issue
* Fix test isolation issues related to versions
* Add missing requirements
* Convert huawei ISCSIDriver unit tests to RFC5737 addrs
* Changes in ScaleIO configurations options
* Storwize/SVC: Clone between different size volumes
* Huawei: Manage volume fails due to lower array version
* Fix exception during service update
* Huawei: Create snapshot have a log error
* EMC VMAX - Limit SG and MV to 64 characters
* Fix spelling mistake in docstring
* EMC VMAX - Recreating SG when it has been deleted
* VMAX-Replacing deprecated API EMCGetTargetEndpoints
* 3PAR: Update replication to v2.1
* LeftHand: Update replication to v2.1
* Update Pure replication to cheesecake
* Fixed logging for oslo versioned objects
* Move replication volume manager warnings to info
* Trim 50s from huawei ISCSIDriver unit tests
* Copy unit tests for StandardLogging fixture from Nova
* Add 'conf' param for TextGuruMeditation autorun setup
* Use is_int_like method from oslo_utils
* Fix sshpool.remove code
* Remove an useless and wrong call
* Copy StandardLogging fixture from Nova
* Add ability to failback for replication V2.1
* Storwize SVC multiple management IPs
* Updating Datera DataFabric Driver to v2 of Datera DataFabric API
* Capture warnings into logs
* Return BadRequest for invalid unicode names (continued)
* IBM Storwize with pool-aware-cinder-scheduler
* Fix HTTP sessions left open in Brocade zone driver
* Fix invalid uuid warnings in block device unit tests
* Fix invalid uuid warnings in scheduler unit tests
* Add necessary fields to volume creation
* Add scheduler RPC API v2.0
* Clean up replication v2.1 (Cheesecake) RPC API
* always use pip constraints
* Remove unused columns from Service ORM model
* CONF add suppress_requests_ssl_warnings
* Make nullable of fields in db model and object match
* Remove unused pngmath sphinx extension
* Delete volumes with snapshots
* Clarify glance_api_insecure help text
* NetApp: Fix SSH Client File Creation in Unit Test
* Trim 12s from disco unit tests
* Remove QoS settings from SolidFire attributes
* EMC VMAX - get iscsi ip from port in existing MV
* Misprint in policy.json
* Re-enable -1 child limits for nested quotas
* Support IP lookup of target portal DNS name
* Updated from global requirements
* Huawei: delete_snapshot need not return any value
* Match the ip more accurately in Huawei driver
* Huawei: Consider bandwidth when selecting port
* Add description when rename LUN in Huawei driver
* Huawei: Code cleanup
* Modify the number of params of hypermetro in HuaweiDriver
* EMC VMAX - Changing PercentSynced to CopyState in isSynched
* Add basic workflow of attach/detach to devref
* Change frozen error messages from _LE to _
* Replication v2.1 (Cheesecake)
* Change Fail to Failed in error messages
* NetApp: Add Consistency Group support for E-Series
* Return BadRequest for invalid Unicode names
* Check for service existance in capabilities API
* Enable all unit tests on Python 3.4
* Adding general notes about rolling upgrades
* Move deprecation release notes to correct section
* Tests: Don't assert on LOG.warn
* Return all target_wwpns for FC storwize
* Fix error message in cinder type-update
* Fix NoneType error in service_get_all
* Add os-brick rootwrap filter for privsep
* LeftHand: Updating minimum client version
* NetApp: Implement CGs for ONTAP Drivers
* Fix HNAS iSCSI driver attachment
* NetApp: Support iSCSI CHAP Uni-directional Auth
* Avoid hardcoding value from oslo library
* cinder-api-microversions code
* Port netapp dataontap driver to Python 3
* Scalable backup service - Liberty compatibility
* Huawei: Log the IP when login fails
* Huawei: Fix create volume with prefetch value error
* Huawei: Don't fail when port group does not exist
* Force target_lun to be int type to make os-brick happy
* Changed Nexenta default chunksize from 16k to 32k
* Volume manage/unmanage support to ZFSSA drivers
* Removed unreachable code
* Disable multi-attach for RBD
* Correct iscsi lun type
* Fix invalid uuid warnings in object unit tests
* Imported Translations from Zanata
* Fixed help message for AllocatedCapacityWeigher
* EMC VMAX - not cleaning up HW Resource WWPN initiators
* Huawei: Fixed url range
* Updated from global requirements
* Test: use assert_has_calls() instead
* Move anyjson to test-requirements
* Huawei: Judgement failure when creating hypermetro
* Remove useless get_replication_updates driver call
* [LVM] Restore target config during ensure_export
* 3PAR get host by WWN now handles mixed cases
* NetApp: E-Series remove snapshot limitations
* Fix race condition in RemoteFS create_snapshot_online
* Add SIGHUP handlers to reset RPC version pins
* Handle OverQuota exception during volume transfer
* Remove extra get_active_zoneset query from Brocade CLI
* Tintri image cache cleanup
* Huawei: Ensure the port is online
* Rtstool sets wrong exception message on save
* Test middleware test_faults to Python 3
* Split out NestedQuotas into a separate driver
* Revert changes to use ostestr
* doc: Fix wrong description about adding RESTful API
* Propoerly call oslo's Service stop and wait
* Remove unused kill method from Service
* Wait for periodic tasks to stop on exit
* Dell: Failed vol create could leave dead volumes
* Roll back reservations quota in RPC if necessary
* Scaling backup service
* EMC ScaleIO - fix bug in extend volume
* VMware: manage_existing for VMDK driver
* VMware: manage_existing_get_size for VMDK driver
* Delete unuseful code in Huawei driver
* Cleanup unused conf variables
* Port infortrend driver to Python 3
* Disable Rally backup-related scenarios
* Fix last Python 3 issues in zonemanager
* Port hgst driver to Python 3
* Port API v1 and v2 to Python 3
* Port API contribs to Python 3
* Port test_emc_vnx to Python 3
* Fix service-list filter
* Coho volume stats update
* Sheepdog: Fix malformed image url format
* Update quota when volume type renames
* Add restore_volume_id in backup
* Updated from global requirements
* Support for consistency groups in ScaleIO driver
* Use of metadata id instead of metadata name
* Fix 'asert' typo in unit test
* Fix dynamic import of CONF.volume_api_class
* Filter & goodness functions in NetApp drivers
* Manage/unmanage volume in ScaleIO driver
* HNAS driver: Fix SSH and cluster_admin_ip0 bug
* Remove duplicated code in volume manager and base driver
* Don't use Mock.called_once_with that does not exist
* EMC VMAX - necessary updates for CG changes
* RBD: use versioned objects
* Tests: Fix calls to non-existent assert methods
* Updated from global requirements
* Profiler: make it possible to run without loading osprofiler
* Profiler: don't call trace_cls if profiler is not enabled
* Tests: Set volume listen port to test_service_listen_port
* Remove Cisco FC Zone Manager Driver
* Add variable QoS to NetApp cDOT drivers
* Move integrated tests to 'functional' directory
* py3: Fix usage of JSON in API contrib
* Port utils.safe_minidom_parse_string() to Python 3
* Include allocated quota value in the quota reserve
* Log stack trace for middleware faults
* hacking: Fix false positive in C302 check
* Port backup drivers to Python 3
* Storwize: Implement v2 replication
* Volume create fails with FakeISCSIDriver
* Adds support for configuring zoning in a virtual fabric
* ScaleIO QoS Support
* Zfssaiscsi driver should not use 'default' initiator group
* Update db in CGSnapshot create
* 3PAR: Create consistency group from source CG
* Remove old client version checks from 3PAR driver
* Improve logging to debug invalid "extra_specs" entries
* Huawei: Implement v2 replication (managed)
* DRBD: Fix arguments for resize_volume DBus API call
* Port objects unit tests to Python 3
* Updated from global requirements
* VNX: Add 'None' check in parsing provider location
* NexentaStor5 iSCSI driver unit tests
* LeftHand: Implement un/manage snapshot support
* Updated from global requirements
* EMC VMAX - Method not being called for V3
* Allow for eradicating Pure volumes on Cinder delete
* HNAS driver: retry on Connection reset fix
* Fix issue in hacking with underscore imports
* DRBD: Compat for current DRBDmanage versions
* Fix variable scope issue in try-except
* Imported Translations from Zanata
* Bootable filter for listening volumes from CLI
* Clean uploading volume when c-vol restarts
* mock time.sleep in Broadcom unit test
* Don't create cgsnapshot if cg is empty
* Added osprofiler headers to cors middleware
* Imported Translations from Zanata
* Fix the replication spelling in message
* 3PAR fix driver to work with image cache
* Updated from global requirements
* Improve logging for volume detach
* Remove useless unit tests mock in Huawei driver
* Return updated volume type after updating
* Remove 'external=True' in Huawei driver
* Fix XtremIO multi cluster support
* EMC VMAX - Fix for last volume in VMAX3 storage group
* Filtering type extra-spec support to ZFSSA drivers
* Zfssaiscsi driver should return target_lun as int
* Pin RPC and object version to lowest running
* Report RPC and objects versions
* Add missing RPC calls versions to rpcapi modules
* Huawei: Balanced FC port selection when zoning
* VNX: Replication V2 support(managed)
* Adds HTTPS southbound connector for Brocade FC Zone Driver
* Replication V2 for Pure Storage
* Support ZeroMQ messaging driver in cinder
* Remove redundant definition of 'deleted'
* Fix update_consistencygroup log info
* Correct opt type for nexenta_chunksize/blocksize
* Huawei: Add manage/unmanage snapshot support
* Remove deprecated options from NFS driver
* Fixing HNAS XML parser
* Replace exit() by sys.exit()
* IBM XIV/DS8K: Implements Replication V2
* Support cinder_img_volume_type in image metadata
* Adds friendly zone name support
* LeftHand: Implement v2 replication (unmanaged)
* EMC VMAX - VMAX driver failing to remove zones
* Remove access_mode 'rw' setting in drivers
* Tests: Strengthen assertFalse assertions
* Fix laggard cisco FC zone client unit tests
* Fix xtremio slow unit tests
* Fix sluggish rbd unit tests
* Fix torpid coordinator unit tests
* Rework Storwize/SVC protocol to fix add_vdisk_copy
* NetApp ONTAP - Reapply API tracing
* Run flake8 also on cinder/common
* Replace assertEqual(*, None) with assertIsNone in tests
* Wrap the method to calculate virtual free capacity
* Add pagination support to consistency group

8.0.0.0b2
---------

* Fix NFS driver unit test docstring
* Adding action to policy.json
* fix NFS driver max_over_subscription_ratio typo
* Add pip-missing-reqs tox env
* Add missing requirements
* Added 'bootable volume' filter for non-admin user
* Move wsgi to oslo_service.wsgi
* Set LVM driver default overprovisioning ratio to 1.0
* Tegile tests: Change volume size to int
* VMware: Fix release notes
* FlashSystem reports error in _find_host_exhaustive()
* Huawei: Refactor driver for the second time
* Add cinder backup driver for Google Cloud Storage
* NexentaStor 5 iSCSI backend driver
* NexentaStor 5 NFS backend driver
* DRBD: Rename "dres" to avoid confusion with "res"
* EMC VMAX - Incorrect SG selected on an VMAX3 attach
* Activate sparse copy for Netapp
* Add Fujitsu ETERNUS DX Volume Driver (FC part)
* Imported Translations from Zanata
* XtremIO: FC initialize connection failed
* Updated from global requirements
* Disallow transferring volume in consistency group
* Reduce use of eval()
* Remote unused iscsi_targets table
* ITRI DISCO cinder driver
* NetApp eseries: report max_over_subscription_ratio correctly
* Python 3: Replace reduce and xrange with six.moves
* Infrastructure to use the DRBD transport for NOVA
* NetApp ONTAP: Fix extending volume beyond lun geometry
* Refactor Windows drivers using os-win
* Base iSCSI initiator validation
* Fix ChunkedBackupDriver _create_container
* XtremIO: Set the location of a CA certificate
* Huawei: Add manage/unmanage volume support
* Remove DB calls from Pure Volume Driver CG methods
* Dell SC: Adding logging to httpclient
* LeftHand: Implement v2 replication (managed)
* Enable trim/discard in SolidFire's driver
* API Middleware fault: Log exception type
* Re-add Nexenta drivers
* Remove invalid NetApp QoS keys
* Fix thin provisioning flags in NetApp drivers
* Return BadRequest for invalid Unicode names
* Handling Invalid argument iflag=direct in dd
* Execute mount.nfs check as root
* Report discard support for Dell SC connections
* Add ConsistencyGroupStatus enum field
* 3PAR: Adding volume checks to manage snapshot API
* Added Keystone and RequestID headers to CORS middleware
* Allow host and instance_uuid at attach
* Trival: Remove 'MANIFEST.in'
* Imported Translations from Zanata
* Add finish_volume_migration to volume object
* Fix tox -e fast8
* Updated from global requirements
* Removes the Violin 6000 FC and iSCSI drivers
* Dell SC: Implements Replication V2
* Storwize: Add force flag on vdisk mapping call
* Storwize/SVC: Volume manage using source-name
* Enable consisgroups in SolidFire driver
* Replace deprecated library function os.popen() with subprocess
* Constant defined for sqlAlchemy VARCHAR & INTEGER
* Fix image volume creation error
* Cleanup in backup reset status
* NetApp FC drivers should not set 'rw' access mode
* Change minimum 3PAR API version for replication
* Optimize 3PAR array ID retrieval
* Add metadata aliases to Volume object
* Add pagination support to volume type
* Re-enabled hacking checks for H105
* Don’t log warnings for image cache when disabled
* Fix grammatical mistake in defining articles
* Scality SOFS: don't always read /proc/mounts twice
* Add BackupStatus enum field
* Updated from global requirements
* Fix issue with flake8 check and full paths
* Fix race conditions in migration 061
* Replace use of mox with mock in test_nfs
* Updated "deleted" column of volume_type_access
* Add Fujitsu ETERNUS DX Volume Driver (again)
* Add backref relationships to ConsistencyGroup obj
* Misspelling in message
* Fix some warnings about 'unused variable' for XIO
* Updates consistency group for ibm svc driver
* Add volume driver for Tegile IntelliFlash array
* Fix to allow RBD delete an unprotected snapshot
* Remove the deprecated ibmnas driver
* Wrong usage of "a"
* VMware: optimize in get_cluster_refs
* Rebrand HP XP driver to now be HPE
* Fix creating volume by snapshot for GPFS driver
* Rename Huawei drivers
* Check min config requirements for rbd driver
* Remove API races from delete methods
* Remove API races from attach and detach methods
* Quota API is now compatible with keystone API v2
* Add pagination support to Qos specs
* Remove name_id when creating volume with cache enabled
* Imported Translations from Zanata
* Updated from global requirements
* Enhance the stats reported from the Pure Volume Drivers
* Allow replicated volumes to be recoverable
* Imported Translations from Zanata
* Retyping volume got error under max vol limit
* Add config option to enable reporting discard
* Storwize: Split up __init__ into separate files
* Fix volume upload failure with glance_api_version=2
* EMC VMAX - Extend Volume for VMAX3
* XtremIO add support for create CG from CG src
* Fix bugs caused by porting to python3
* Imported Translations from Zanata
* Disable capabilities based on 3PAR licenses
* Add empty initialize_connection method to PureBaseVolumeDriver
* Fix python 3.x import issues with pure.py
* Override osapi_volume_listen_port for test_workers
* Updated from global requirements
* replace deprecated oslo_messaging _impl_messaging
* Remove downgrade migrations
* Fix delete_snapshot error case in Pure driver
* 3PAR: Implement un/manage snapshot support
* Error handling for invalid SLO/Workload combo
* 3PAR: Implement v2 replication (unmanaged)
* Add serial number to eseries ASUP payload
* XtremIO: fix generic glance cache with XtremIO
* VMware: Add support for VVOL datastores
* Tooz locks
* Small refactoring in test_admin_actions.py
* Imported Translations from Zanata
* Making NFS _find_share efficient
* Change the format of some inconsistent docstring
* Preserve request id in Cinder logs
* Add volume_extensions:quotas:delete to policy.json
* Pass volume_id in request_spec for manage_existing
* VMware: Fix volume copy across vCenter datacenters
* Imported Translations from Zanata
* Modify VO so that obj.get always defaults to None
* Replace use of mox with mock in test_quotas
* Replace use of mox with mock in test_rbd
* Skip check whether volume is local if it's None
* Imported Translations from Zanata
* Implement refresh() for cinder objects
* EMC VMAX - get_short_host_name not called in find_device_number
* Move retype quota checks to API
* Implement snapshots-related features for Block Device Driver
* Refactor cinder.utils.is_valid_boolstr
* Add synchronization in Block Device driver
* Recalculate allocated value of parent project
* Updated from global requirements
* Volume migration: add 'name_id' as valid skippable field
* Fix invalid cache image-volume creation
* Imported Translations from Zanata
* Remove eventlet WSGI functionality
* Deprecated tox -downloadcache option removed
* Fix for showing default quotas to non-admin user
* VNX: Fix failure in SnapCopy feature
* Use wild card for passing env variable
* Recognize extra fields in CinderObjectDictCompat
* Imported Translations from Zanata
* VNX: Fix issue in deleting cg/cgsnapshot
* Add validation for volume_type of volume object
* Update Pure REST API supported version numbers in Pure driver
* Updated from global requirements
* Retype functionality in Tintri driver
* Fix non-migration swap with error
* Replace use of mox with mock in test_solidfire
* Check context before returning cached value
* 3PAR: Implement v2 replication (managed)
* Use Cinder API v2 for Rally scenarios
* Check backup service before backup delete
* Python 3: fix a lot of tests
* EMC VMAX - Fix for randomly selecting a portgroup
* Volume driver for Coho Data storage solutions
* XtremIO: fix iscsi chap discovery bug
* XtremIO: fix missing multiattach flag
* Fix StrOpts with integer defaults
* Dynamically Pull Out Option Sections
* Use the catalog to retrieve glance_api_servers
* Address potential races in SolidFire VAG
* Update migrate_volume API to use versionedobjects
* Storwize: add config option to control flash copy rate
* Remove version per M-1 release instructions
* Use proper config option to connect to keystone
* Robustify writing iscsi target persistence file

8.0.0.0b1
---------

* Adding devref about genconfig
* LIO: Handle initiator IQNs as case insensitive
* Fix dictionary key error
* VMware: Replace mox with mock
* VMware: Unit test refactoring (image to vol - 2/2)
* VMware: Unit test refactoring (image to vol - 1/2)
* Imported Translations from Zanata
* Remove deprecated LVM ISCSI and ISER Drivers
* Delete unused codes in rbd.retype
* NetApp: E-Series fix JSONDecodeError on first add
* Add Mitaka-1 release notes
* NetApp: Refactor E-Series tests
* xio: fix regression in authentication
* Add some missing fields to Volume object
* Imported Translations from Zanata
* Add retype in lvm driver
* Updated violin driver check for volume objects
* Take into consideration races in XtremIOClient3
* Optimize "open" method with context manager
* Updated from global requirements
* Sheepdog: Optimization of error handling
* Fix the bug of can't get the desired image info
* Cleanup orphaned code in sqlalchemy API
* Cleanup orphaned code from image and manager
* Cleanup orphaned code from brick LVM
* Cleanup orphaned code from ceph backup driver
* Force releasenotes warnings to be treated as errors
* Remove db access in VNX driver
* Fix quotas issue during volume transfer
* Declare multiattach is True in Dell Eqlx driver
* Nexenta Edge iSCSI backend driver
* RBD: Make snapshot_delete more robust
* Hacking Checks for assertTrue/IsNone()
* Remove netaddr useless requirement
* Improve metadata update operations
* Add atomic conditional updates to objects
* Revert "Add Scality SRB driver"
* VMware: Validate extra spec opt vmware:clone_type
* Update list_replication_targets
* Port zonemanager to Python 3
* Port key manager to Python 3
* Move oslo-incubator's scheduler module to cinder
* Remove stubs and add resource cleanup
* VMware: Skip unsupported datastore types
* Port IBM storewize_svc driver to Python 3
* Declare multiattach is True in RBD driver
* XtremIO fix attach readonly bug
* CG API should return volume type IDs
* EMC VMAX - Change naming convention for MV and SG for FAST
* Fix the bug of OSError when convert image
* Don't build two tox envs for pep8(-constraints)
* Add guidelines for release notes to devref
* Imported Translations from Zanata
* Imported Translations from Zanata
* Updated from global requirements
* Eager load columns in volume_get_active_by_window
* Backup snapshots
* LeftHand: Remove self.db assignment
* Deprecate *_multipath_enabled flag for IBM drivers
* Fix debug output for cinder-volume-usage-audit
* Add check_uptodate.sh --checkopts to "pep8"
* Move get_by_id to CinderObject
* Imported Translations from Zanata
* fast8: Skip git rm'd files
* Manage existing: fix volume object saving
* Fix swap_volume for case without migration
* Remove .mailmap file
* Remove db access from 3PAR and LH cg functions
* Additional VAG support for SolidFire
* Fix InstanceLocalityFilter scheduler filter
* Add a FakeGateDriver
* Fix metadata retrieval in GPFS driver
* Imported Translations from Zanata
* VNX: Fix metadata get overriden issue
* Added VAG support to SolidFire
* Refactor HP LeftHand driver to now be HPE
* Remove db access from XIV/DS8K CG functions
* Do not use api-paste.ini osprofiler options
* Remove duplicate keys from dictionary
* Bad exception clauses order
* Imported Translations from Zanata
* Check specific driver enabled in create_backup
* get_all_snapshots: Fix log message typo
* Updated from global requirements
* ScaleIO extend volume round up capacity
* Port HP 3PAR driver to Python 3
* Modify test_hpe3par to support random hash
* Imported Translations from Zanata
* Fix ScaleIO driver provisioning key
* Imported Translations from Zanata
* Remove the HP CLIQ proxy driver
* Retry on database deadlock on service_update method
* Downstream Fix for Genconfig
* Correct assertDictMatch argument order
* 3PAR Fix find_existing_vluns
* Port xio driver to Python 3
* Remove kombu as a dependency for Cinder
* Port EMC VMAX to Python 3
* Port EMC VNX CLI to Python 3
* Sheepdog: Fix a problem about multi backend
* Imported Translations from Zanata
* Update compression license check
* py3: Fix error handling in prophetstor driver
* Updated from global requirements
* Refactor HP 3PAR drivers to now be HPE
* add "unreleased" release notes page
* Add os-win to requirements.txt
* Update extend_volume API to use versionedobjects
* Update retype API to use versionedobjects
* Update get/delete_volume API to use versionedobjects
* Update create_volume API to use versionedobjects
* Test for object version hash changes
* Fix cinder objects unit test registration
* CG driver function should not access db
* Add test for snapshot filtering by project id
* Imported Translations from Zanata
* Use oslo_config new type PortOpt for port options
* Update CONTRIBUTING.md to CONTRIBUTING.rst
* CG creation should be scheduled on backend level
* Removal of deprecated NPIV option in Storwize
* Fix ZFSSA drivers' local cache bugs
* OpenStack typo
* Change nfs to NFS in the help strings of nfs.py
* Port zfssa driver to Python 3
* Port vzstorage to Python 3
* Port cinder.utils.monkey_patch() to Python 3
* XtremIO fix create CG from src flow
* Don't use default=None for config options
* Imported Translations from Zanata
* 3PAR drivers volume size conversion is incorrect
* Port vmware datastore to Python 3
* Use Service object instead of DB API directly
* Docstring fix in scheduler-stats
* Add LC_ALL=C to lvcreate, lvextend and pvresize
* Port cinder.hacking to Python 3
* Port test_tintri to Python 3
* Add reno for release notes management
* Imported Translations from Zanata
* Fix failure of unit test TestCinderAllCmd
* Execute mount.nfs check with absolute path
* Imported Translations from Zanata
* Update minimum tox version to 1.8
* Update cinder-manage man to match current options
* Replace warnings.warn in sqlalchemy-api
* Replace warnings.warn in glusterfs
* Using extra-specs in cloned vols for Nimble driver
* SheepdogDriver: Improve get_volume_stats operation
* Add retype logic in manage_existing for VNX
* Adds CORS support to Cinder
* Fix calling delete_zones method with a wrong argument
* Return volume_type extra specs based on policy
* Revert "Handle correct exception raised by python-novaclient"
* NetApp: Fix issue with updating E-Series password
* NetApp: Fix issue with E-Series volume expand
* Update register_opts hacking check to allow tuples
* Updated from global requirements
* optimize the copy_image_to_volume method of sheepdogdriver
* Fix UsedLimitsController's authorizer to soft
* Imported Translations from Zanata
* Handle correct exception raised by python-novaclient
* lvconvert missing from cinder volume.filters
* Support insecure NAS security options in Quobyte
* Brocade driver add_zone optimization
* Imported Translations from Zanata
* Add missing cgsnapshot field to Snapshot object
* Eager load snapshot_metadata in *snapshot_get_all
* Case sensitivity problem in cinder scheduler
* Add protocol to help of glance_api_servers option
* SMBFS: Fix retrieving total allocated size
* Make relationships in objects consistent
* Imported Translations from Zanata
* Remove the jointly loaded model in finish_volume_migration
* Update docs to generate Guru Meditation Report
* Add qos_specs_id to volume type show
* Fix NoneType Attribute error
* Support initialization state in Backup Manager
* Imported Translations from Zanata
* Add -constraints for CI jobs
* Fix typos about 'target_discovered'
* NetApp: Cleanup if E-Series volume create fails
* VMware: Unit test refactoring
* Cleanup for cinder tests with CGSnapshot
* Imported Translations from Zanata
* VMware: Enforce min vCenter version
* Add hypermetro support for Huawei driver
* Updated from global requirements
* devref doc: assorted fixes in "Unit Tests"
* LIO: Let delete_initiator succeed if iqn not found
* CGSnapshot Object
* Updates in consistency_group in xiv/ds8k driver
* Retype support for CloudByte iSCSI cinder driver
* Add retries for Cisco FCZM client CLI _cfg_save
* Updated from global requirements
* Remove unused gettextutils from oslo-incubator
* Wrong usage of "an" in the mesages:
* NetApp: E-Series fix deletion of missing volume
* Wrong usage of "an" in the mesages: an service
* VMware: Relocate volume only during no disk space
* Port Windows drivers to Python 3
* Use project id from volume when retyping volumes
* Fix typo in LIO terminate_connection error msg
* Update the devref for volume migration
* Implement update_migrated_volume for NFS driver
* Only use LOG.exception in exception handler
* Port API admin action tests to Python 3
* Port API types extra specs to Python 3
* Port API to Python 3
* Mark XML API as deprecated in Mitaka
* windows: don't use LOG.exception if not logging an exception
* Improve performance listing detail for volumes
* Move CloneableVD to common functions
* Fix updating only volume type is_public
* encryption_api_url requires a version
* Cleanup/move code in Storwize Driver
* Port WSGI tests to Python 3
* Fix method VolumeTypeList.get_all
* Use lvm_conf_file directory for LVM_SYSTEM_DIR value

7.0.0
-----

* Squashed commit of WebOb 1.5 and oslo.db fixes
* Change default Exception code to 500
* Dell SC: Disable REST verify warnings
* Update config format for replication_devices
* Fix log formatting for rbd driver
* Fix Status-Line in HTTP response
* Huawei driver handle volume exists error
* Updated from global requirements
* Tox fast8: use pep8 env dir
* Move ssh_utils tests to test_ssh_utils
* Volume extend error does not catch exception
* Fix test_misc for WebOb 1.5
* ScaleIO driver: update_migrated_volume
* Fix error string format for replication API calls
* Port IBM flashsystem to Python 3
* Port ceph driver to Python 3
* Provide better debug log when 'cinder manage' fails
* Remove references to Swift in chunked driver
* Add insecure option for swift backup
* ScaleIO: Fix protection_domain_id log message at init
* Port test_srb to Python 3
* Add fast format option for thick volume creation
* Imported Translations from Zanata
* Retype enhancement for EMC VNX cinder driver
* Updated from global requirements
* Verify volume is replication capable
* Add device identifier to replication device
* Port violin driver to Python 3
* Port EMC scaleio to Python 3
* Remove extra register_opts() calls in netapp eseries
* Add multi-initiator extra-spec for Nimble driver
* Fix SolidFire target composition
* Port targets test_iet_driver to Python 3
* Port image cache to Python 3
* py3: Run unit tests with ostestr on Python 3.4
* Add testresources and testscenarios used by oslo.db fixture
* Clone cg support in VNX driver
* Test_backup_swift: Don't leak notifications
* test_backup_nfs: Set volume id per test
* test_backup_swift: Set volume id per test
* Add backup_swift_auth_url to swift backup driver
* Dell Eqlx: Support over subscription in thin provisioning
* Hacking check for opt name registration
* Add ability to set prefix in SolidFire Volume name
* Updated from global requirements
* Fix broken format string in vol mgr log
* Detach volume on device validation failure
* Convert  Retry-After header parameter value to string
* Fix capacity report error in Huawei driver
* emc vmax driver: use integer division for Python 3
* VMAX Target iSCSI IP Address
* Updated from global requirements
* Delete a temporary volume in DB with admin context
* Fix update quota of subprojects
* Port test_quobyte to Python 3
* Remove unused 'deprecated' option from auth_strategy opt

7.0.0.0rc2
----------

* Fix VMAX live migration problem
* Imported Translations from Zanata
* Port netapp SSC Cmode to Python 3
* Port test_netapp to Python 3
* VMAX Truncate Storage Group Name
* HNAS iSCSI manage does not work with spaces
* Port scheduler host manager to Python 3
* Fix various Python 3 issues
* Fix volume throttling to Python 3
* Ensure replication functions check driver status
* Fix enable/disable_replication raise InvalidVolume
* Tests: print fake_notifier queue upon mismatch
* Cleanup orphaned code from cinder root directory
* Image cache tests: use fake_notifier
* Implement extend_volume method to Block Device driver
* Small optimization in Block Device driver
* DRBD: new option "drbdmanage_devs_on_controller"
* Obtain target authentication from database same as LIO target
* Dell SC: cgsnapshot-delete doesn't actually delete
* LVM: Make sparse_copy_volume private, use for capabilities
* Dell SC: cgsnapshot-delete doesn't actually delete
* Fix typo in cinder-config-generator.conf
* Port test_volume to Python 3
* Fix unreachable code pylint issues
* Huawei driver add check before use a QoS
* Report *real* free capacity in Huawei driver
* Fix update Huawei driver issue
* Fix Python 3 issues in wsgi
* py3: Port pure driver test to Python 3
* GlusterFS: extend volume to the right path
* Use pbr wsgi_scripts to install Cinder WSGI entry point
* Report *real* free capacity in Huawei driver
* Imported Translations from Zanata
* Fix Bad indentation pylint issues
* Show image metadata
* XtremIO fix remapping bug
* Revert use of netapp_lib from NetApp Drivers
* Fix volume related operation in CloudByte driver
* Add placholder for migration backports in Liberty
* Add placholder for migration backports in Liberty
* Revert use of netapp_lib from NetApp Drivers
* Remove the destination volume check in delete_volume
* Huawei driver add check before use a QoS
* Fix VMAX live migration problem
* Cleanup of Translations
* Missing configuration opts from cinder.sample.conf
* Use function capsulation in Huawei driver

7.0.0.0rc1
----------

* Open Mitaka development
* Create volume in cg enhancement in VNX driver
* Remove duplicate keys from dictionary
* Fix URL format in Huawei driver
* Setup LVM_SYSTEM_DIR earlier in LVM.__init()
* Add "fast8" tox env
* Allow c-vol backends to start when some backends fail to load
* Fix use of wrong storage pools for NetApp Drivers
* VMware: Remove VMDK driver for ESX server
* Use of ast for integers doesn't changes type
* Make rpc_client method private for VolumeCommands
* Ignore Forbidden error on quotas-get for nested projects
* Change ignore-errors to ignore_errors
* NetApp volume/snapshot delete performance fix
* Replace soft_delete in volume_type_access_remove
* Fix way of getting LUN id in Huawei driver
* Fixing create CG from Cgsnapshot bug in VNX driver
* Fix delete quota of subprojects
* Dynamically create cinder.conf.sample
* Updated from global requirements
* Fix MITM vulnerability for Brocade FC SAN lookup
* Imported Translations from Zanata
* Fix cinder-all binary
* NetApp: Fix volume extend with E-Series
* Fix netapp_enable_multiattach default for E-Series
* Check for None on service's updated_at
* Fix issue of volume after host-assisted migration
* Attaching enhancement for EMC VNX driver
* Tests: Split VolumeTestCase into separate classes
* Local img-cache files ignored for image transfers
* Snapmirror targets should not be reported as pools
* Change check method for 'all_tenants'
* Create a page of drivers with stevedore.sphinxext
* Enable certificate verification during image copy
* Fix NetApp clone from glance failure
* Storwize: Fix format string
* Fix usage of novaclient
* Check for empty attributes on SF volume
* Fix volume lookups in SolidFire template caching
* Don't rely on provider_id for resource deletion
* Fix Pure get pgroup volume snapshot name
* Dothill fix options access
* HPMSA fix access to common options
* Lenovo driver fix access to common opts
* Fixed missing log variable types
* VMware: Fix invalid product name
* Retrieve volume in update_migrated_volume
* Swap the decorator order for PureFCDriver methods
* Add ScaleIO Cinder driver commands
* SolidFire provider_id for snapshots on init
* LeftHand Add update_migrated_volume to drivers
* Huawei: fix multi REST-URLs bug
* Improve coverage for snapshot_get_by_host
* LVM: add the exception handling to volume copy
* Fix NetApp loop in clone of NFS backed images
* Hacking log format arg check
* backup init_host cleanup exception handling
* Making opt names consistent
* Fix QoS keys not being available to scheduler
* Add ConsistencyGroup object entries to linstack.py
* Pass in snapshot refs for host on provider_update
* Filter hosts with pool in snapshot_get_by_host
* Fix typos in comments
* Filter scheduler: Fix KeyError on invalid create request
* Updated from global requirements
* Return a tuple from SolidFire update_provider_info
* Add unmanage default implementation to VolumeDriver
* Correctly report multiattach in Pure drivers
* Add manage_existing and unmanage to BaseVD
* Add migrate_volume to BaseVD
* Update update_migrated_volume in VNX driver
* 3PAR Disable generic image volume cache
* Add updated_at into response of listing detail
* Add os-brick's scsi_id command to Cinder rootwrap
* Fix order of arguments in assertEqual
* Updated from global requirements
* Error message in update_migrated_volume was incorrect
* Remove empty rules from policies for API access
* Fix HDS HNAS driver logging password as plain text
* Add mechanism to update snapshot provider_id
* VMware: Remove global patching of open
* VMware: Skip ESX hosts in maintenance mode
* 3PAR Add update_migrated_volume to drivers
* Updated from global requirements
* Switch SVC driver to use lsportfc to determine FC target WWPNS
* Use consolidated update for failover_replication
* VMware: Fix exception messages
* Adds allow_availability_zone_fallback option to Cinder
* NetApp E-Series over-subscription support
* ZFSSA driver to return project 'available' space

7.0.0.0b3
---------

* Get full volume model in Replication manager API’s
* Fix problem of efficient volume copy for migration
* Generic image-volume cache
* Implement thin provisioning support for E-Series
* Remove useless response checks in SolidFire driver
* Sheepdog: Improve snapshot and clone operation
* Fix the virtual port support in VNX driver
* DotHill driver fix create_cloned_volume parent id
* 3PAR Fix create_cloned_volume source volume id
* Cloudbyte fix create_cloned_volume parent id
* Scheduler-based over-subscription for NFS drivers
* ScaleIO driver should use os-brick connector
* Add instructions on how to deploy API under Apache
* Sync volume versionedobject to ORM
* Check before add lun to QoS in Huawei driver
* Fix backup metadata import missing fields
* Remove the unnecassary volume_api.get(context, volume_id)
* Port image_utils to Python 3
* Port volume transfer to Python 3
* Service object
* Allow specified backend capabilities to be retrieved
* Remove deprecated options
* Add cinder.conf.sample to gitignore
* Add delete_snapshot and update_snapshot rules
* Handle KeyManager exception when deleting a volume
* Fix a merge problem in VMAX driver
* Don't require OpenSSL for unit tests
* Add pagination to backups
* Enhance FC zone support for Huawei driver
* Add support for file I/O volume migration
* Add debug logging before attaching volume in driver
* Detect addition of executable files
* Remove executable bits on files
* NetApp DOT block driver over-subscription support
* Cleanup for SnapshotObject
* Add additional SSC extra specs to E-Series driver
* Minor optimization
* Adding delete-wait-loop for CloudByte Volumes
* get_replication_updates call to driver is wrong
* Earlier authority check for create volume API
* Fix url in API response to get original
* Efficient volume copy for generic volume migration
* Volume status management during migration
* Clean up line continuation in Storwize driver
* LeftHand: Adding Consistency Group Support
* 3PAR update driver to store stats
* Remove driver.set_execute()
* Skip intermittent VMDK tests
* Rework Scality SOFS driver to use RemoteFS class
* Adds framework for get_capabilities() feature
* Implement AutoSupport for NetApp E-Series driver
* Add retries to delete a volume in the RBD driver
* Add support for volume groups and netapp_raid_type
* Dell SC: init_volume stale volume info fix
* Validate filters in snapshot*, backup* in db.api
* Fix volume copy for 'virtual' volumes in DotHill
* Imported Translations from Transifex
* Use version convert methods from oslo.utils
* Implement manage/unmanage snapshot in Pure drivers
* Reduce runtime of E-Series iSCSI tests
* Cinder Nested Quota Driver
* Add manage/unmanage volume support for Nimble
* Python 3 incompatible expression fix
* Local cache feature of Oracle ZFSSA drivers
* Replace urllib.unquote with urllib.parse.unquote
* Remove unused dependency discover
* Update volume status AFTER terminate_connection is done
* Add unit test for backup get_all
* Incremental backup improvements for L
* Sheepdog: improve create and delete operation
* Implement function to manage/unmanage snapshots
* Sheepdog: Add class for dog command executor
* Dont eager load volume type specs on volume list
* Filter out extra-specs from type get for non-admin
* Prevent that all backup objects are deleted
* Add pagination to snapshots
* Parameter osapi_max_limit is always used by default
* Update NetApp Drivers to use netapp_lib
* Extend unit tests for backup get_all
* Fix nimble storage volume stats reporting
* TemporaryImages to inspect image before conversion
* Efficient image transfer for Glance cinder store
* adds user_id to check_is_admin
* Fix backup list all_tenants=0 filtering for admin
* Add Cinder API wsgi application
* Add consistency group tests to test_volume_rpcapi
* Cinder replication V2
* force_detach terminate_connection needs connector
* Assisted volume migration for Oracle ZFSSA drivers
* Add https options and minor code changes
* Fix bad except clauses order
* Add volume retype support for Huawei driver
* Fix URLs to admin-guide-cloud
* Nested Quota Driver: Get Project Hierarchy
* Check sio_storage_pools in check_for_setup_error
* Fix description for "Barbarism of editting a file"
* Dell SC: Added logging for the find_wwns functions
* Add missing space to logged error in create volume
* Cleaning up CONF.register_opts() in compute/__init__.py
* Update provider_id column on SolidFire init
* Add ability to update provider_id during init
* Fix _LI() to _LW() in LOG.warning message
* Remove the method delete_volume_admin_metadata
* Support efficient non-disruptive volume backup in VNX
* Validate value when user update quota
* Add SolidFire svip to config options
* Return multiple iSCSI portals in VNX Cinder driver
* Avoid returning volume metadata in DotHill driver
* Small cleanups in BaseVD/VolumeDriver
* Port 3PAR drivers to use ABCMeta driver model
* Updated from global requirements
* Switch to the oslo_utils.fileutils
* Parse out SolidFire account from api response
* Dell SC: Better exception handling in init_conn
* Port test_nfs to Python 3
* Corrects the order of AssertEquals params in Quobyte tests
* Adds the random option to cinder retry function
* Extra specs may not be in volume types
* VMware: Fix re-attach volume error for VC 5.1
* Remove duplicate keys from dictionary
* LeftHand driver is ignoring reserved_percentage
* Update devref unit tests doc
* Tests: Fix zfssa TestRestClientURL.test_request
* Test whether sample config generation works
* Revert "mark oslo.vmware as optional dependency"
* Register the volume_opts config options in remotefs.py
* Create CG needs extra specs
* Configure space reservation on NetApp Data ONTAP
* Dell SC: Fix error causing missed log message
* Rename free_virtual in capacity filter
* Make migration's volume source deletion async
* Add the ability to update type public status
* Adds manage/unmanage methods for HNAS drivers
* Update deprecated version of novaclient
* Add version columns to services table
* 3PAR: Adding Consistency Group Support
* Remove unused function volume_type_encryption_get
* Refactor to remove duplicate code
* Correct comment to be consistent with code
* Allow 0 length name
* Add volume migration support for Huawei driver
* Cleanup for cinder tests with ConsistencyGroups
* VMware: Change inventory folder hierarchy
* Adapt SnapshotController to view builder
* Add backup/restore methods to Sheepdog driver
* Use min and max on IntOpt option types
* Over subscription for HP 3PAR drivers
* Allow CG without snapshot to be deleted
* Tintri snapshot id
* Add volume type support to Datera
* Fix Pure create volume from cgsnapshot
* Implement Clone CG in Pure Volume Drivers
* Dell Eqlx: Use generic option ssh_timeout
* Make X-IO volume driver wait for delete volume to complete
* Reduced file size to prevent timeout
* Update SolidFire driver to pass newer flake8
* 3PAR: Adding performance metrics to volume status
* Don't use context.elevated to get volume
* Enable cinder-manage to remove services
* VMware: Bump driver version
* Fix backup init_host volume cleanup
* VMware: Deprecate vCenter version less than 5.1
* Updated from global requirements
* Small clean up in volume object
* Move import and export backup metadata to object
* On Volume list only retrieve needed data from DB
* Return volume name from backup_restore
* Switch Pure volume drivers to use Snapshot Objects
* Don't return Exception when volume is detached
* Use Requests HTTP library and URL safe names
* Remove RetypeVD class, fix NFS driver retype
* Fix Python 3 issues in Windows tests
* Add objects.register_all() to cinder-all command
* GPFS volume encryption-at-rest support
* VMware: Set virtual disk UUID to volume ID
* Add oslo.vmware into test-requirements
* Add multipath support to 3PAR iSCSI driver
* Prevent volume already in CG to be added to another
* LVM Thin Provisioning auto-detect
* Fix HNAS iSCSI 32 targets limitation error
* Remove unused fake objects in vmdk test module
* VMware: Add volume ID in vCenter's volume config
* Enhance PureISCSIDriver multipath support
* Add unit test cases for the capacity scheduler
* Fix argument order for assertEqual in tests
* Fix order of parms in assertEqual for scheduler ut
* VNX driver needs extra params for create cg from src
* Prevent creating encrypted volume with image
* EMC VMAX Create CG from CG Snapshot
* mark oslo.vmware as optional dependency
* ConsistencyGroup Object
* Validate string, integer limit for input parameter
* Validate name and description string
* Handle missing temp volume and snapshot during cleanup
* Updated from global requirements
* Validate 'is_public' when creating volume type
* Remove StorPool Driver
* Ignore InsecureReq warning in SolidFire Driver
* Attach snapshot - driver only
* Remove bad tests for the VMAX driver
* Update authorization actions for services API
* Fix missing parameters in driver CG interface
* Remove incorrect URLs from jenkins.rst
* Fix list comparison for empty list
* Snap copy feature for EMC VNX Cinder driver
* Tests: Fix os.path.exists mock (emc_vnxdirect)
* Add connector object to create_export
* Correct usage of assertEqual for boolean values
* Remove unit test migration logging
* Add support '--all-tenants' for cinder backup-list
* Corrected order of parameters in docstring
* Fix wrong exception usage in cinder exception classes
* Fix RestURL to storage backend in Huawei driver
* Sync scheduler module from oslo-incubator
* VNX driver needs to return snapshot objects
* Revert "Revert First version of Cinder driver for Quobyte"
* Enhance unit tests for zfssa drivers
* VMware: Remove unused constants
* Fix volume limit exceeded exception
* Refactor api.v2.volumes unit tests
* Dell SC: Add check of current value on retype
* Update snap-quota to unlimited in Nimble driver
* Add more Rally scenarios to run
* Updated from global requirements
* Fix PEP476 & format message of Oracle ZFSSA drivers
* Add SmartX support for Huawei driver
* Enhance deletion efficiency when backup init host
* Fix order of arguments in assertEqual
* Add multiple pools support to VMAX driver
* Fix status comparison for attached volume backup
* Updated from global requirements
* NetApp SSC job will be run periodically
* RBD: use user-configured value for chunk size
* Over subscription for HP LeftHand iSCSI driver
* Use prefix for SolidFire template account
* Fix multi-line docstrings to meet hacking rules
* sqlalchemy exception kills FixedIntervalLoopingCall thread
* VMware: Fix protocol in backend stats
* Fix error message in cinder/api/v2/volumes.py
* Fix concurrent attaches on HNAS iSCSI driver
* GlusterFS: Using 'fallocate' instead of 'dd'
* Fixing notify message of manage_existing flow
* Clone CG
* Fix get default quota values for subprojects
* Add deactivate step to extend_lv
* Fix exception on uploading a volume to image with glance v2 API
* Set VERSION on the Nimble driver

7.0.0.0b2
---------

* Log which service is down
* Move update_migrated_volume() to BaseVD
* GlusterFS backup driver
* Posix backup driver
* Add mock cases for IBM FlashSystem
* Add discard to connection properties
* Remove deprecated config options for Liberty
* RBD: use user-configured value for max_clone_depth
* Updated from global requirements
* Fix lvm manage existing volume
* Add entry create and cast tasks to manage workflow
* Fix cleanup_temp_volume_snapshots for missing vol
* Remove unused context parameter
* Adding NFS support to the GPFS Driver
* Remove deprecated SimpleScheduler
* Fix doc string definitions
* Port StorwizeSVCDriver to use ABCMeta driver model
* Add extra spec capability for Nimble Cinder Driver
* XtremIO support for iscsi discovery auth
* Add bandit for security static analysis testing
* typos(?) in create_snapshots_in_db
* Add multiple pools support for Huawei driver
* Port XIVDS8K Driver to use ABCMeta driver model
* Fix Python 3 issues in Hitachi HNAS tests
* Port remotefs driver to Python 3
* Port IBM driver to Python 3
* Clean up volume_types logging
* NetApp ESeries: fix delete of non-existent volume
* Refactoring of manager's create_volume flow
* Remove unused arguments from c-vol's create_volume
* Updated from global requirements
* Add I/T mapping check for IBM FlashSystem
* Remove simple scheduler which is deprecated since Juno
* LVM: Support efficient data copy for LVM driver
* Implement retype for Pure drivers
* Dell SC: Add support for driver retype
* EMC VMAX Modify CG
* XtremIO volume driver consistency group support
* Add Cinder internal tenant support
* VMware:Replace vCenter calls with oslo.vmware calls
* Rename filename from il8n.rst to i18n.rst
* Non-disruptive backup
* DRBD: Rename a constant to a better name
* Remove resource lock operation for HBSD
* Dell SC: Fix legacy bug, init_conn bug and REST API bug
* Dell SC: Fix Consistency Group issues
* Add drivers list generator
* Fix 033 add encryption unique key migration
* Add CHAP support for Huawei driver
* Move volume.api test to correct location
* Remove logging statements from migrations
* DRBD: Define a separate prefix for snapshots
* Prevent missing Purity hosts from raising errors
* Revert "Remove X-IO volume driver"
* Filter cgsnapshots data on the DB side
* Refactor Huawei Volume driver
* Add volume_attachment to volume usage notifications
* Graceful shutdown WSGI/RPC server
* Backups: allow name to be specified during restore
* Set default policy for "volume:get"
* Add iSCSI multipath support for Huawei driver
* Fix 3PAR driver handling of existing VLUNs
* Don’t log warnings in Pure initialize_connection
* scality: add export and name keys to os-initialize_connection info
* Add delete/update_volume_metadata policy rules
* Remove "volume:services" rule from policy.json
* Report capability of multiattach for FlashSystem
* Handle volume not found on zfssa volume delete
* Raise BadRequest for invalid replication status
* Add unit tests for cinder.api.v2.volumes
* Raise HTTP exception for backup not found
* Port NetApp NFS drivers to use ABC driver model
* Removing OpenvStorage for no CI
* Remove unused serialize_args method
* Remove obsolete API from documentation
* Tests: test_volume mock conversion
* Fix restore point if backup base is diff-format in ceph
* Add white list support for target ports in VNX driver
* Preserve mock side_effect’s in test_pure
* StorPool: clean up the last uses of str.format()
* Removing archaic references
* Remove useless logging from unit tests
* cinder list fails with 'name' sort key
* Storwize_svc_npiv_compatibility_mode default value change
* Remove unused parameter in PureFCDriver _connect
* Cleanup unused method fake_get_target
* Set driver version in Sheepdog driver
* Updated from global requirements
* Fix saving tz aware datetimes in Versioned Objects
* set/unset volume image metadata
* Fix not implemented wording in update_migrated_volume
* Add support for force-delete backups
* Improve 3PAR driver VLUN creation and deletion
* Remove hacking check N327
* Fix tests failing in gate
* Fix properties extracting from image with glance api v2
* Support SMI-S provider v8.0.3 in VMAX driver
* Add ability to override OpenStack privileged user auth url
* VMEM v6000: Fix export verify routines
* Port Tintri driver to ABC driver model
* Fix block_device driver to behave as documented
* NetApp E-Series: Add debug tracing
* Set encrypted key in connection_info during initialize
* Nested Quota: Set default values to subproject
* Dell SC: Add support for ManageableVD
* Fix NetApp cDOT driver use of Glance locations
* Fix missing pool name in consistency group
* NetApp ONTAP: Add debug tracing
* Add tracing facility for drivers
* Fix error message in Pure driver with correct text
* Notify the transfer volume action in cinder
* Storwize Driver zone removing
* Dell SC: Add support for consistency groups
* Remove duplicate volume.filters entry
* Port NetApp E-Series iSCSI driver to ABC model
* Fix getting out-of-date volume operation state issue for VNX
* Separate FlashSystem FC and iSCSI common code
* Update expected error message from lvs
* Fix HBSD horcm driver with oslo.concurrency 2.1.0
* Remove X-IO volume driver
* RemoteFS: Fix the offline snapshot delete operation
* Implement the update_migrated_volume for the drivers
* Avoid race condition at snapshot deletion stage
* Fix Python 3 issues in cmd
* Port image/glance.py to Python 3
* Switch to oslo.reports
* Validate maximum limit for quota
* Updated from global requirements
* Fix block eventlet threads on rbd calls
* RemoteFS: Reporting configured reserved_percentage in _update_volume_stats
* GlusterFS: support extending a volume that has snapshots
* Port dothill to Python 3
* Fix backup.rpcapi to pass object backup
* Fix typo in solidfire driver option
* Mock socket.gethostbyaddr in test_v7000_fcp
* Replace missed basestring by six for python3 compatability
* Return 404 if volume type encryption is not found
* Updated from global requirements
* smbfs: fix invalid check for smbfs_used_ratio correctness
* Remove lio_initiator_iqns config option
* Move HDS drivers to Hitachi folder
* Fix Python 3 issues in targets unit tests
* Port drbdmanagedrv driver to Python 3
* Port test_db_api to Python 3
* Port hitachi driver to Python 3
* Fix getting wwpn information in infortrend driver for DS4000
* Do not allow to modify access for public volume type
* Add dependency check in RBD delete_snapshot
* Port huawei driver to Python 3
* XtremIO driver fix array snapshot problem
* Fix cinder.conf.sample generation
* Handle attachment of second volume
* VMware: Create volume backing in specific clusters
* Use versionutils from oslo.log
* Correct overquota error message
* Updated from global requirements
* Fix timeout issue in EMC VNX driver unit test
* Remove oslo logging from backup unit tests
* Add notifications about snapshot.update.*
* Sync the latest fileutils module from oslo-incubator
* Port NetApp DATAONTAP blocks drivers to ABC model
* Fix 'no actual-pathname' NetApp API error
* Use right oslo.service entry points
* Use symbol for error code in VNX cinder driver
* Storwize driver report capability for multiattach
* Filter snapshots data on the DB side
* Change generic NotFound to specific exception
* Storwize: add the missing stops in the end of the messages
* Ensure 'WSGIService' derives from oslo_service base class
* Switch to oslo.service
* Fix library includes for config generator
* Revert First version of Cinder driver for Quobyte
* Fix cinder-manage volume delete cmd
* Fix Python 3 issues in the blockbridge driver
* Fix Python 3 issues in the swift backup driver
* Fix Python 3 issues in ceph and rbd drivers
* Fix Python 3 issues in backup
* Remove generate_glance_url
* Fix manage_existing function in infortrend driver
* Add unit tests for the capacity filter
* Modify template account creation in SolidFire drvr
* Tests: Fix assertRaisesRegexp deprecation warnings

7.0.0.0b1
---------

* Harden scheduler.rpcapi unit tests
* Fix backups.rpcapi to pass objects over RPC
* Fix weird change of volume status in re-scheduling
* Fix tox -e py34
* Add exception catch in report_state for DBError
* Updated from global requirements
* Dell SC: Enable use of Storage Profiles
* Use elevated context for backup destroy
* Fix Cinder Objects unit tests
* rbd: add volume_id to connection_info in initialize_connection
* Fix Datera driver export call
* Add iscsi_target_flags configuration option
* Adds the Violin Memory V7000 series FC driver
* Remove the hardcoded concurrency limit for ostestr
* Revert "Disable backup progress notifications for unit tests"
* Nested Quota : Create allocated column in cinder.quotas
* Handle incorrect '--config-dir' param
* Get updated volume status in begin_detaching
* Tests: Make fake_notifier per-instance
* Validate outermost request body element name consistently
* Add missing argument to delete_keys method
* Port LeftHand driver to use ABCMeta driver model
* Add Virtuozzo Storage Volume Driver
* Disable profiler for unit tests
* Use a hard-coded project_id in racy cinder.tests.unit.test_volume tests
* Validate bool value using strutils.bool_from_string method
* Incorrect exception caught in qos-specs create api
* VMware: Remove unused methods
* Scality SOFS: enhance how the remoteFS mount is detected
* Backup object
* Add missing Jinja2 to requirements.txt
* Storwize: remove the useless method check_copy_ok
* Update version for Liberty

7.0.0a0
-------

* ScaleIO: Fix broken format string
* Sync 'report' from oslo-incubator
* Ceph driver support retries on rados_connect_timeout
* Dell SC Removed _find_domain and associated tests
* LVM add multiattach flag capability
* Add volume drivers for Infortrend Storage
* XtremIO Volume driver requests, multipath
* Updated from global requirements
* Adds FC and ISCSI Cinder drivers for Lenovo Storage Arrays
* Adds FC and ISCSI Cinder drivers for HPMSA Storage Arrays
* Replace basestring with six.string_types
* Fix broken export commands on block_device driver
* Switch to oslo.policy 0.3.0
* Add config option to set max_volume_size_limit
* Fix LIO target helper when missing targetcli
* Move DRBD tests into tests/unit
* Volume driver for HP XP storage
* Replace xrange() with six.moves.range()
* Drop L suffix from long integers
* Pass proxy environment variables to tox
* Re-add DRBD driver
* Refactor API create_volume flow
* Introduce Guru Meditation Reports into Cinder
* Adds FC and ISCSI Cinder drivers for DotHill Storage Arrays
* Get rid of oslo-incubator copy of middleware
* SQL scripts should not manage transactions
* Targets tests: Clean up long lines
* Update 3PAR user config help strings
* Disallow backing files when uploading volumes to image
* Remove WritableLogger wrapper
* Get StringIO from six for Python 3 compatibility
* Fix Python 3 issues in utils
* Update SolidFire to use target driver model
* Wait until service thread is done on service stop
* Add cinder volume driver for Blockbridge EPS
* 3PAR enable multiattach capability reporting
* Replace dit.itervalues() with dict.values()
* Rewrite code merging two dictionaries
* Replace dict(obj.iteritems() with dict(obj)
* Replace dict.iteritems() with dict.items()
* san driver: don't use relative Python import
* Implement Cinder Volume driver for HGST Solutions
* Volume manager should set filter_function and goodness_function
* Tintri driver to manage existing backend storage objects
* Replace it.next() with next(it) for py3 compat
* Use six to fix imports on Python 3
* NetApp E-Series: Add Fibre Channel Support
* NetApp E-Series: Refactor class structure for FC
* NetApp E-Series driver: Remove caching logic
* Use six.reraise() for Python 3 compatibility
* Updated from global requirements
* Add secondary account capability to SolidFire
* Replace urllib and urllib2 with six.moves.urllib
* Replace unicode with six.text_type
* Use correct rtslib namespace for newer versions
* Dispose DB connections between backend proc starts
* EMC ScaleIO Cinder Driver
* RemoteFS: Fix doc for locked_volume_id_operation
* Re-integrate Oracle iSCSI Cinder driver
* Dell SC: Expanded comments and update var names
* Re-add the StorPool distributed storage driver
* Add iSCSI protocol support for IBM FlashSystem
* Fixes 3PAR snapshot failure with optional params
* ConsistencyGroup: Return 400 instead of 500 for invalid body
* Port remote_fs driver to use new driver model
* Make VNX Cinder Driver aware of VNX Pool Full Threshold
* Add 'source-id' and 'source-name' support in VNX driver
* Revert "Adds drivers for DotHill Storage Arrays."
* Dell SC: Added support for alternate iscsi portals
* Dell: Added verify cert option for REST calls
* Handle ineffective backup compression
* Prophetstor driver needs to return snapshot objects
* Complete switch to snapshot objects
* DriverFilter: don't check volume_backend_name
* Add Pure Storage FibreChannel driver
* Fix exception parameter name
* Move Dothill tests out of root test directory
* Fix remaining memory issues with nfs backup unit tests
* Don't send heartbeats if Manager reports a problem
* Changes in rally-jobs/README.rst
* Removed explicit return from __init__ method
* Return provider_id in SolidFire model update
* Deprecate the HPLeftHandISCSIDriver CLIQ driver
* Allow provisioning to reach max oversubscription
* Port ProphetStor driver to use ABCMeta driver model
* Clean up unused exceptions
* Refactor scheduler's create_volume flow
* Adds FC and ISCSI Cinder drivers for DotHill Storage Arrays
* Bump SolidFire version number
* Dell SC: update_volume_stats could use uninitialized vars
* Disable backup progress notifications for unit tests
* Tintri Cinder Volume driver
* Fix assertRaisesRegexp deprecation warnings in UT
* Refactor PureISCSIDriver into base and iSCSI classes
* Add missing unit test for goodness weigher
* Non-admin user to query volume filter by az
* Fix cinder concurrency issues on rtstool
* Use SolidFire snapshots for Cinder snapshots
* Switch get_all_snapshots to use objects
* rbd driver in cinder does not manage glance images multi-location
* Notification with volume and snapshot metadata
* Remove pretty_tox and use ostestr
* Add volume ID to fake volumes in Gluster tests
* Fix capacity filter to allow oversubscription
* EMC VMAX Manage/Unmanage Volume
* Add chap support to CloudByte cinder driver
* Multiple pools support enhancement in VNX cinder driver
* Remove un-used import at test_volume_transfer.py
* NetApp FC driver shims missing manage/unmanage
* Updating cmd/manage.py get_arg_string() argument parser and adding unit test
* Fix expression-not-assigned pylint issues
* Add standard QoS spec support to cDOT drivers
* Avoid LUN ID collisions in NetApp iSCSI drivers
* VMware: insecure option should be exposed
* Create iSCSI lio portals with right IPs and port
* Create consistgroup from cgsnapshot support in VNX driver
* Stop using deprecated timeutils.isotime()
* Fix response when querying host detail by host name
* Fix wrong response with version details
* Display NOTIFICATIONS on assert failure
* Brocade driver not parsing zone data correctly
* Fix issues with extra specs in VMAX driver
* Don't use dict.iterkeys()
* Address 0x712d8e0e error in VNX Cinder Driver
* Leverage dict comprehension in PEP-0274
* Add missing '-o' CLI option to VNX Cinder Driver
* Validate name and description for volume type
* Leave sqlalchemy convert to boolean to the DB SQL type to use
* Switch from MySQL-python to PyMySQL
* Add ability for drivers to copy data preserving sparseness
* Remove HDS HUS iSCSI driver
* Updated from global requirements
* Use nfs_oversub_ratio when reporting pool capacity
* LVM: Pass volume size in MiB to copy_volume() during volume migration
* LVM: Support efficient data copy using "dd" for create_cloned_volume
* Fix a problem with FAST support in VMAX driver
* Remove use of deprecated LOG.warn
* Fix incorrect reraising of exceptions
* Switch to oslo_versionedobjects
* Cinder os-force_detach api returns 500
* Check volume_backend in retype
* Fix overwrite of params in SF image cache update
* Dell SC driver honoring folder name after volume creation
* Check type match on create from source/snap
* Add patch for consistency group update in ProphetStor driver
* Logging not using oslo.i18n guidelines (openstack)
* Remove unused context parameter
* Replace suds test dependency with suds-jurko
* Fix missing translations for log messages
* Remove Brick from cinder codebase
* Follow i18n guidelines in LIO target
* Windows SMBFS: Fix image resize errors during volume creation
* Windows iSCSI: Add CHAP authentication support
* NFS Backup: Correcting backup_sha_block_size_bytes help message
* Fix common misspellings
* GlusterFS: Renaming test case to test_mount_glusterfs
* Add new exception to retryables in SolidFire driver
* Convert mox to mock: tests/compute/test_service.py
* FlashSystem reports error while running tests with multi-thread
* Dell: Added support for update_migrated_volume
* Fix FakeISCSIDriver and FakeISERDriver
* Add volume status to error messages in backup create flow
* Bad link in API version details response
* Fix xxx=\n pep8 errors in volume_utils.py
* Log command failure details before raising ISCSITargetDetachFailed
* Eqlx: Fixes the retries on Network Connection Error
* Rename Datera test to test_datera for discovery
* Allow rexports for targets with Datera
* Add os-brick to cinder requirements.txt
* Fix the KeyError in CloudByte iSCSI cinder driver
* LIO: Enable iSER for IPv6
* LIO: Use rtslib property instead of private method
* Fix missing translations for log messages
* Cinder os-attach api returns 500
* cinder os-detach api returns 500
* HDS HNAS Driver fails when FS unhealthy
* Logging not using oslo.i18n guidelines (zonemgr)
* Fix broken add_iscsi_conn log message
* Fix unit tests spam output
* Preserve usage and reservations on quota deletion
* Fix 'driver is uninitialize' typo
* Removing sleep between when a command is sent and 'YES' is sent
* Windows iSCSI: remove ensure_export
* tests: replace mox by mox3, clean out mox usage
* Catch additional type conversion errors
* Tests: Remove sleep from NFS tests
* Port block_device driver to use new driver model
* VMware: Enable vCenter certificate verification
* Fix typo in log messages and comments
* Clean up failed clones in VMAX driver
* Correct directories check for N327 hacking check
* Fake out sleeps in unit tests
* Fix range check for NFS used ratio
* Move logging sample to use oslo_log
* Targets test refactoring
* Revert state if attachment already exists
* Add retry to lvm delete
* Admin extends tenant's volume but change admin's quota
* Drop use of 'oslo' namespace package
* Add Multi-connection support to XIV
* VNX Cinder driver Over Subscription Support
* Fix namespace issue in generate_sample.sh
* Add hacking check for str and unicode in exceptions
* Fix volume creation from image with allowed_direct_url_schemes
* Change default of option volume_driver to LVMVolumeDriver
* GlusterFS: Support over subscription in thin provisioning
* Remove unnecessary checks for encrypted types
* Add test case for volume_encryption_metadata_get
* Updated from global requirements
* Port rbd driver to use new driver model
* Don't truncate osapi_volume_link prefixes
* Fixed issue with mismatched config in VMAX driver

2015.1.0
--------

* Add external genconfig calls
* Create initiator id for VMAX iSCSI driver
* Remove deprecated methods in VNX driver
* Remove unused find_attribute_or_element()
* 3PAR don't log version numbers every stats update
* Sync oslo service module
* Add external genconfig calls
* Enable use of filter_function in PureISCIDriver
* NetApp E-Series: Fix instance live-migration with attached volumes
* Add resource tag to logging in volume.manager.py
* VMware: Handle concurrent inventory folder create
* Leverage timeutils, drop strtime() usage
* GlusterFS: Using mount method in RemoteFsClient
* Remove redundant code from VNX Cinder Driver
* Remove force check from copy_volume_to_image
* Logging not using oslo.i18n guidelines (scheduler)
* service child process normal SIGTERM exit
* service child process normal SIGTERM exit
* Move unit tests into dedicated directory
* Dell SC driver calls out the wrong REST API version
* Move RBD calls to a separate threads
* Windows SMBFS: fix volume extend
* Fix a wrong argument of create method
* Fix tiny typo: compatability => compatibility
* Reserve 5 migrations for Kilo backports
* RBD: Add missing Ceph customized cluster name support
* Standardize logging in volume.api.py
* Release Import of Translations from Transifex
* Fix fetch_to_volume_format if vhd is requested
* Windows: Improve vhdutils error messages
* SMBFS: Add minimum qemu-img version requirement
* VolMgr: reschedule only when filter_properties has retry
* Storwize driver should only report active wwpn port
* update .gitreview for stable/kilo
* Mask passwords with iscsiadm commands
* Add support for customized cluster name
* Updated from global requirements
* SMBFS: Lock on a per-volume basis
* Windows SMBFS: fix volume extend
* Complete the doc/README.rst instructions to build docs
* Verify all quotas before updating the database
* Add locking to PureISCSIDriver around creating Purity Host objects
* Include boot properties from glance v2 images
* Add CA cert option to backups swift driver
* Fix a wrong argument of create method
* Add locking to PureISCSIDriver around creating Purity Host objects
* Reworked Dell SC iSCSI target portal return
* Fix LUN misalignment issue with NetApp iSCSI drivers
* Remove the export creation during volume creation for migration
* Fix assertEqual in test_volume.py in correct order of params
* VNX Cinder Driver should report 0 free_capacity_gb in some scenarios
* Include boot properties from glance v2 images
* Logging not using oslo.i18n guidelines (brick)
* set default auth_strategy to keystone

2015.1.0rc1
-----------

* Open Liberty development
* Removed sleep before 'YES' is sent to confim an operation
* Update openstack-common reference in openstack/common/README
* GlusterFS: Returning provider location of volume from snapshot
* Fixes snapshot creation failure in CloudByte driver
* Delete the temporary volume if migration fails
* Revert "Removing Windows drivers"
* Correct cinder hacking check numbering
* Add hacking check for print() statements
* Rbd update volume stats in wrong way
* Add missing copy_volume_to_image method to Sheepdog driver
* Partial Revert "Removing Huawei drivers"
* Create initiator id if not exist in VMAX driver
* Fixed encrypted property for 3PAR FC and iSCSI drivers
* Partial Revert "Removing ZFSSA driver"
* Mock wait_for_volume_removal in test_brick_connector
* Dell SC driver has insufficient iscsi logging
* VMware: Skip vSAN for preallocated image download
* Enable H238 hacking rule
* Use six.text_type instead of unicode
* Fix ISCSIDriver initialized connection volume type
* Fix multipath device discovery when UFN is enabled
* Fix missing clone_image API support for sheepdog driver
* More error handling on EMC VNX migration failure
* Set volume_attachment to [] for the temporary volume creation
* Add volume:update rule to policy.json
* Fix always false condition in glance wrapper
* Only use operational LIFs for iscsi target details
* Revert "Removing Netapp FC drivers for no reported CI"
* Get volume from db again before updating it's status
* Catch more general exception in manager's create_volume
* Fix broken fetch_to_volume_format log message
* Tests: Fix v6000 test failure with random hash seed
* Check volume status in detach db api
* Fix wrong command for _rescan_multipath
* Storwize: Replication status still active when primary copy is offline
* VMware: Fix instance_uuid access in volume retype
* Logging not using oslo.i18n guidelines
* Remove LP bug ref in remove_iscsi_device
* Fix potential access to missing key
* Brick: Fix race in removing iSCSI device
* VMware: Improve invalid container error message
* Fix the format of the system name in VMAX driver
* Hitachi: Fix access to volume instance_uuid
* VMware: Fix ImageNotAuthorized during copy volume
* Fix: Boot from image with HNAS iSCSI
* SMBFS: Fix missing volume provider location
* Enhance VNX Cinder volume creation logic
* Properly use obj_extra_fields in objects
* Create unit tests for volume objects
* Fix incorrect invocation of _add_to_threadpool
* VMware: Fixed usage of volume instance_uuid
* Change volume and snapshot stuck creating to error
* Imported Translations from Transifex
* Fixed access to instance_uuid in retype
* Ensure initialize_connection in targets pass multipath parameter
* Eager load volume extra specs
* Be safe with getting attachment
* Added the missing attachment to detach_volume
* Make lio iSCSI changes persistent to avoid lost
* Sort list of cinder_object.changes
* Move to hacking 0.10
* Syncing versionutils from oslo-incubator
* Properly remove host object from ISE
* Dell Storage Center API change fails init_conn
* Windows iSCSI: fix volume clone
* Enable request-id in cinder API logs
* Use cached values for stats on query failures for vmem drivers
* The value of netapp_storage_protocol should default to none
* Change leftover oslo.* to oslo_*
* Updated from global requirements
* Fix: Synchronise Quobyte Share mounting
* Fix typo in cinder/cinder/volume/drivers/emc_vmax
* Update file doc string for pure.py
* update oslo policy to remove policy.d log spam
* Fix QoSSpecManageApiTest to work in parallel

2015.1.0b3
----------

* Remove chap secret DEBUG logging in PureISCSIDriver
* Removing Windows drivers for no reported CI
* Fix logging mistake in swift backup driver
* Removing Zadara driver for no reported CI
* Removing Huawei drivers for no reported CI
* Removing Netapp FC drivers for no reported CI
* Removing Fujitsu driver for no reported CI
* Removing DRBD driver for no reported CI
* Removing FusionIO driver for no reported CI
* Removing Nexenta driver for no reported CI
* Removing Symantec NFS driver for no reported CI
* Removing StorPool driver for no reported CI
* Removing ZFSSA driver for no reported CI
* Make the 3PAR drivers honor the pool in create
* Removing HP MSA driver for no reported CI
* Removing Coraid driver for no reported CI
* Add retry to create resource in Datera driver
* Logging not using oslo.i18n guidelines
* Tests: Fix az test failure when PYTHONHASHSEED != 0
* Change datetime.now() to timeutils.utcnow() from oslo_utils
* Fixes nits in check_no_contextlib_nested
* Fix logging to catch original exceptions and tracebacks
* Remove error messages from multipath command output before parsing
* Return updated volume object to the caller of _attach_volume()
* Fix SAN generic driver ssh whitespaced commands
* EMC: Fix use of "_" as variable name
* Reduce configured file size for nfs backup unit tests
* tests: remove useless variable
* Revert "Datera's export to avoid deprecated keys"
* Don't override extra specs with config in VMAX
* Check license before clone in VMAX driver
* Fixing mount when state_path is configured with a final '/'
* Verify all quotas before updating the database
* Update Violin REST client library name
* Remove the reference of volume['instance_uuid']in VNX driver
* Increase LeftHand driver minimum client version
* Decrement remaining retries after failed REST call
* VMware: Fail immediately for images in a container
* Make unused iscsi_num_targets, iser_num_targets configs as deprecated
* Raise exception for invalid mock assert calls
* Mocked utils.execute for broken tests
* Huawei driver check before associating LUN to a LUN group
* Windows: Fixes wintypes import issue in vhdutils
* Fix typos in LVMVolumeDriver
* Add minimum qemu-img version check functions
* Implement IET target driver
* Fix unit tests for multiattach patch
* Fixed a concurrency issue in VMAX driver
* Fix LVM thin pool creation race
* Added provider_id to volume and snapshot object
* Fix ArgsAlreadyParsedError in emc_vnx_cli.py
* Fix typo in log message
* remotefs: Fix doc string for _create_snapshot
* Fix a typo in sf_template_account_name help
* Move to the oslo.middleware library
* Remove use of contextlib.nested
* Remove strutils from oslo-incubator
* Add waiting for the driver to SchedulerManager
* Fix retype return value in volume driver base class
* Fix retype arguments in volume driver base class
* Fix sqlalchemy reuse in multi-backend children
* Fix Cinder logs to show authentication error in RBD driver
* Update hacking check for oslo_log
* Add is_ready method to scheduler driver
* Fix for  inconsistent cinder-services state change
* Fix HNAS iSCSI driver error on LUN creation
* Datera driver looks for lun-0 instead lun-1 now
* Use oslo.log instead of oslo-incubator
* Remove the useless next link for volumes, transfers and backups
* Unset auth token before trying to login to Datera
* NFS backup driver
* Sort snapshots in create CG from CG snapshot
* Add multiattach capabilities injection
* Tests: Harden fake_notifier asserts
* Error trying to delete snapshots on Hitachi driver
* Remove global mocking from test_pure.py
* Allow scheduler to receive volume stats when starting service
* VMware: Fix exception logging
* Adjust Cinder to support FCP on System z systems
* Refactor Swift backup driver and introduce chunking driver
* Namespace updates for _i18n and imageutils & fileutils
* Dell FC driver inheritance order causing failures
* Add volume multi attach support
* Add project_id to barbican keymgr wrapper
* Fixes VNX NotImplementedError of unmanage
* Replace assertEqual(True, *) -> assertTrue(*)
* Update Datera's export to avoid deprecated keys
* Improve error handling in refactored Tgt driver
* Adds pool aware scheduling for HNAS drivers
* PureISCSIDriver consistency group updates
* HP lefthand driver filter and evalautor function
* Fix the unicode encode error when create volume
* Add consistency group support for XIV/DS8K cinder driver proxy
* Don't fail target_delete if ACL's don't exist
* Change log level for no object attribute found
* Add Manage/Unmanage support to NetApp NFS drivers
* Use snapshot object in create_volume flow
* Fix "rtsllib" -> "rtslib" typos
* Fix some issues with pool name sent to SVC
* Fix allocated_capacity tracking when rescheduling
* HP 3par driver filter and evaluator function
* Add support to incremental backups in cinder
* Convert all eqlx tests from mox to mock
* Fixed the order of mock decorators in VMAX driver
* Adds SSH communication to HNAS drivers
* Add CHAP support to PureISCSIDriver
* Make objects behave more like our old dictionaries
* Two choices for iscsi_helper is missing
* Update Datera's Authentication method
* Simplify cxt test_create_export() unit test
* CG Modification Support in EMC VNX Cinder Driver
* Dell SC API change fails snapshot creation
* Adding manage/unmanage support for LeftHand driver
* More validation logic for VNX CG creation
* Change default value of gpfs_images_share_mode to None
* Add DB table for driver specific data
* Move oslo.messaging to the oslo_messaging namespace
* Create Consistency Group from CG Snapshot API
* Modify Consistency Group API
* Remove useless storage_availability_zone import
* Failover to alternative iSCSI portals on login failure
* Update volume type name for volume type API
* Add config option to override url for versions
* Snapshot and volume objects
* Cinder objects base
* Dell Storage Center Driver API bug
* Password config options should be marked secret
* Clear migration_status from a destination volume if migration fails
* RBD: Query volume features from ceph.conf
* i18n Compatibility in VMAX driver
* Correct a few changes in the VMAX driver
* Fix HNAS driver parsing errors
* RBD: remove non-layering support for antiquated versions
* Fixed errors in docstrings in the VMAX driver
* SMBFS: Fix retrieving the volume path and format
* More validation logic for VNX CG creation
* Add flash cache policy to 3PAR driver
* Update v1 deprecation warnings
* Fixes the import for Lefthand driver
* NetApp eseries implementation for manage/unmanage
* Replication status periodic task optimization
* XtreamIO version 4.0 support
* Change max_over_subscription_ratio default value
* Use Unique SCST Group names in SCST cinder helper driver
* Add CHAP persistence to SCST target helper
* Fix for infinity capacity reporting in EQL driver
* Use iscsi_helper instead of target_helper on logs
* Import only modules: H302
* Revert "Remove retry_deactivation directive on lvremove"
* Over subscription for Pure Storage iSCSI driver
* Use oslo_config choices support
* Custom zone name prefix not being used by brcd driver
* cinder-manage man update
* GET volumes API sorting REST/volume/DB updates
* GET volumes API sorting enhancements common utilities
* FCZM fix reading of cinder config entries
* Sync scheduler.filters module from oslo-incubator
* Limit volume copy bandwidth per backend
* Generic filter support for volume queries
* Remove warnings for long vgs and lvs calls
* Use subunit-trace to enable output during unit test runs
* VMware: Relocate volume to compliant datastore
* VMware:Use datastore selection logic in new module
* VMware: Refactor initialize_connection unit tests
* Fix exceptions logging in TgtAdm
* Sync 'versionutils' module from oslo-incubator
* Sync 'threadgroup' from oslo-incubator
* Update 'systemd' module from oslo-incubator
* Sync 'service' module from oslo-incubator
* Sync 'loopingcall' module from oslo-incubator
* Sync the 'fileutils' module from oslo-incubator
* Sync 'eventlet_backdoor' module from oslo-incubator
* Remove unused 'test' module from oslo-incubator
* IBM GPFS Consistency Group Implementation
* Fixed 3PAR driver load balancing during migration
* NetApp E-series: Allow scheduling by disk
* Make Interval and Retries Configurable for VMAX
* Pass region name to Nova client
* Remove retry_deactivation directive on lvremove
* Manage/unmanage impl for NetApp ONTAP iscsi driver
* Fix argument order in assertEqual: tests/test_service.py
* Fix some message nits in the ZoneManager
* Implement refresh as kwargs in get_volume_stats
* Dell sc driver iscsi multipath enhancement
* Tests: Fix cxt target tests opening files
* LVM: Fix thin provisioning and mirrors stats reporting
* Fix exception error on HNAS drivers
* Fix comments style according to the Hacking Rules
* Passing privileged user to create nova assisted snapshots
* Fix return value inconsistency in VNX Driver
* Fixed typo
* Pool-aware scheduler support in EMC VNX Cinder driver
* Fix extraneous comma that breaks docbook generation
* Sync policy module from oslo-incubator
* Dell Storage Center: Add retries to API calls
* EQLX: Consolidate CHAP config options
* Add support for chiscsi iscsi helper
* Fix logging guideline violations in volume/api.py
* Remove useless requirement on wsgiref
* Snapshot of bootable volume goes in error state
* Sync periodic_task module from oslo-incubator
* Tests: Don't require binding to port 4444
* Tests: Remove TestWSGIService.test_reset_pool_size_to_default
* Tests: Remove randomness from NFS mount tests
* Change exception message in volume api
* Refactoring for export functions in Target object
* Add iSCSI SCST Target support to cinder
* EMC VMAX driver Kilo update
* Fix Scality SRB driver security concerns
* Fixes total_capacity_gb value in CloudByte driver
* EMC VNX Cinder Driver iSCSI multipath enhancement
* Add dedup provisioning to 3PAR drivers
* Provided requirements are meant to be immutable
* Remove optional parameter from lun mapping call
* quobyte: remove dependency to xattr
* Don't fail target_delete if target doesn't exist
* Remove custom lazy loading
* DRBD: Use correct function object after DBus disconnect
* Split volume driver into ABC classes
* Mock out the wait routine in the VMAX driver
* Limit ram and disk used by ceph backup tests
* Fix detach volume from host problem in VMAX driver
* fix typo in config.py
* Update hacking ignore list
* VMware: Delay string interpolation in log messages
* VMware: Integrate VMDK driver with oslo.vmware
* Enhance iSCSI multipath support
* Dell Storage Center Unit Test Updates for Kilo
* Updated from global requirements
* Update eqlx driver help text
* Add extra library oslo.concurrency to oslo.config.generator.rc

2015.1.0b2
----------

* Support over subscription in thin provisioning
* Change oslo.* to oslo_*
* Lefthand driver fails to attach a cloned volume
* Purge deleted rows
* Make PureISCSIDriver iSCSI port discovery more flexible
* EMC VNX Cinder Driver Update
* Make storwize debug log more readable
* Fixes the EQL driver CI tests AttributeError
* Add manage/unmanage methods for Hitachi Block Storage Driver
* RemoteFS: Use nas_ip and nas_share_path options
* Scality SOFS : Use ensure_tree from fileutils
* Tests: Don't sleep for looping calls (eqlx)
* Enable use of an /etc/cinder/lvm.conf file
* Roll back if VMAX masking view not created
* Tests: Don't sleep for looping calls
* Windows iSCSI driver: Fixes copy disk method exception handling
* VMware: Fix missing target resource pool
* Revert "Implement Huawei SDSHypervisor driver"
* Remove the solaris volume driver
* Fix SSHPoolTestCase to work in parallel
* Drop deprecated namespace for oslo.rootwrap
* Fixes attribute content checking
* Imported Translations from Transifex
* Support iSER driver within the ISCSITarget flow
* HP3Par: Set snapCPG when managing existing volumes
* Fixed misspelling in solidfire.py
* Adds unit tests for HNAS backend
* Failed to discovery when iscsi multipath and CHAP both enabled
* Add retry for tgtadm update when tgt exists
* Add completion logging for snapshots and volumes
* Fix configratuion of rally jobs
* Create SolidFire Template account on init
* Updated from global requirements
* Add debug message for lvremove after udev settle
* IBM Storwize driver Consistency Group Implementation
* Use get_my_ipv4 from oslo.utils
* TgtAdm: Fix _recreate_backing_lun logging
* Revert "Create SolidFire Template account on init"
* HP 3PAR modules have bad log messages
* Remove useless and unused request_utils
* Create SolidFire Template account on init
* Fetch_to_volume_format calls copy_volume using wrong parameter
* Changed pvs separator from ':' to '|' to support names with ':'
* Raise correct exception when validate_connector failed
* Add provisioned_capacity
* Move 3 Fujitsu ETERNUS DX related file
* Add retry to lvm snapshot create
* Add a generic retry decorator to cinder/utils
* Use uuidutils from oslo.utils
* Remove unnecessary method: _ensure_iscsi_targets() in tgt.py
* Raise correct exception if deleting of LIO iSCSI target is failed
* Cleanup unused DB APIs, part I
* Remove argparse from requirements
* Update tests for Quobyte Cinder drv from mox->mock
* Fixes a small issue in find_autodoc_modules.sh
* Fix the eqlx driver to retry on ssh timeout
* Add retrying lib from global requirements
* Remove usage of taskflow 'utils.misc' module
* Move oslo.serialization to oslo_serialization namespace
* HP 3PAR modules do not follow coding guidelines
* Improve debug logging of Dell Storage Center driver
* Fix _usage_from_snapshot in volume.utils
* VMware:Fix error creating vCenter inventory folder
* New Cinder volume driver for openvstorage
* Fix cinder-manage shell ipython
* Shrink down customized logging listener
* Prevent deleting volumes in a consistency group
* Fix bug in rbd driver: the cloned volume size is wrong
* Fix HNAS driver confusing error message (iSCSI driver)
* Updated from global requirements
* Ensure lazy translation is disabled properly
* DRBD: remove a wrong comma, it creates a tuple
* Move oslo.utils to oslo_utils namespace
* Make test_create_delete_snapshot more robust
* Add policy_dirs conf fixture
* DRBD: Log an error if libraries can't be loaded
* Fix the iSER legacy usage in the new targets flow
* Move oslo.config to oslo_config namespace
* Add support for manage/unmanage volume commands to PureISCSIDriver
* Scality: Lock around SOFS mount to avoid a race
* Set 'driver_volume_type' to 'gpfs'
* Verify the instance's existance in the VMAX driver
* Updated from global requirements
* Switch the PureISCSIDriver over to using the purestorage pypi module
* Fix zfssa driver volume attach to work with latest zfssa software
* Updated from global requirements
* Move oslo.db to oslo_db namespace
* Fix eqlx endless loop when server closes the connection
* Increase unit test coverage in hacking test
* Fixed server name being retained after detach in LeftHand
* Fixes misspelled words in Cinder
* Imported Translations from Transifex
* Add mock for cinder-rtstool call in tests.targets.test_lio_driver
* Skip LIO target unit tests until mocked
* Fix LOG formatting in api initialize_connection
* TgtAdm: Don't change CHAP username/password on live migration
* Deal with PEP-0476 certificate chaining checking
* Add hacking check for oslo namespace usage
* Remove locks from LeftHand driver
* Fix bug in tgt conf for volume
* Use is_valid_ipv6 from oslo.utils
* Use lockutils.set_defaults to set lock_path in test
* Fix bug in sheepdog driver: the wrong volume size
* Add loopingcalls for Huawei storage system driver
* Implement clone_image caching on SolidFire
* Add migration tests for PostgreSQL
* Garbage Remains when Attached Volume is Migrated with NFS Driver
* Update README.rst to current state
* Remove unused variables from ensure_export()
* Fix incorrect usage of get_flow in volume.manager
* Fix iscsi_write_cache setting for iscsi targets
* Add debug messaging for tgt already exists
* Clean up QoSSpecManageApiTest setup
* Add more rally benchmarks related to Cinder
* Use cinder.utils.execute directly
* Deal with tgt already exists errors
* Fix drbd driver to load without 3'rd party libs
* i18n fixes for PureISCSIDriver
* cinder-rtstool: should use acl.node_wwn
* LVM: Add terminate_connection call for Target Objects
* Add an instance-locality filter
* Adds cinder iscsi driver for CloudByte storage
* Add driver filter and evaluator for scheduler
* Remove import of private _lazy module
* Fix argument order in assertEqual: tests/test_nfs.py
* Fix the continuation line indent to pass flake8
* Capitalize the first letter in log messages
* Fix argument order in assertEqual: tests/test_glusterfs.py
* Use assertRaisesRegexp() in test_srb.py
* The DRBD(manage) Cinder volume driver
* Make ProphetStor drivers compliant with logging standards
* Transition LVM Driver to use Target Objects
* Replace oslo-incubator with oslo_context
* Create proxy volume driver
* Fix handling of serialized data in filtering of volumes
* Convert mox to mock: tests/test_glusterfs.py
* Remove check on db_exc.DBError
* Add specific docs build option to tox
* Imported Translations from Transifex
* Add a privileged user for OpenStack services
* Add support to PureISCSIDriver for Consistency Groups
* Expand the description of extra_capabilities
* Fix broken StorPool driver
* Brick LVM: Remove self.lv_list
* Revert "Outputs the message about failing to bind
* Replace the NetApp driver proxy layer with a proper factory
* Quobyte Driver Exception Cleanup
* Handle the volume not found case in the VMAX driver
* Fix format errors in brick/iscsi LOG messages
* Add unit tests for NetApp do_setup methods
* Outputs the message about failing to bind to IPv6
* NetApp E-series: Do not log passwords in requests
* Set iet_conf to nonexistent file in unit test
* Fix issue with passing lists in filters
* Rename oslo.concurrency to oslo_concurrency
* Add a provider_id column to Volumes and Snapshots
* Mock leaked _execute() calls in driver tests
* Sync request_utils module from oslo-incubator
* Sync periodic_task module from oslo-incubator
* Persist volume uuid on VMAX array
* Fixed a problem in terminate_connection in VMAX driver
* Sync the latest middleware module from oslo-incubator
* LVM: Volume is deleted unexpectedly during volume migration
* RBD: use image_conversion_dir for image operations
* Sync the latest loopingcall module from oslo-incubator
* Sync install_venv_common from oslo-incubator
* Sync latest imageutils from oslo-incubator
* rtstool on Ubuntu installs in /usr/local/bin
* encryption_id needs to be non-nullable
* Mock calls to rpm and dpkg from NetApp unit tests
* Fix files in Cinder with execute bit set
* Add error handling to _connect function in PureISCSIDriver
* Fix typo that escaped review in connector.py
* Fix 3PAR host persona mapping to match WSAPI
* Punctuation and Copyright changes
* Make 3PAR drivers compliant with logging standards
* Fixing 3PAR connection name cache error
* Remove redundant args for clone_image method
* Add Oracle ZFSSA NFS Cinder Driver Support
* Fix HNAS driver initialization

2015.1.0b1
----------

* Make GPFS driver compliant with logging standards
* Updated from global requirements
* Fixed wait for job completion in VMAX driver
* Logging updates to properly use ',' instead of '%'
* Add support for Purity Protection Groups to PureISCSIDriver
* Catch ImageNotFound exception when deleting rbd volume
* Isolate Cinder Attach and Connect in Base Driver
* Uncouple scheduler stats from volume creation
* Fibrechannel and iSCSI for Violin Memory 6000 Series Arrays
* Add Scality SRB driver
* Update volume driver for Huawei storage system
* Implement Huawei SDSHypervisor driver
* Implement Huawei SDSHypervisor connector
* Added volume type description for volume type API
* Added UUID as primary key for Encryption model
* Fix 3PAR driver hang on SSH calls
* Delete default volume size 100M in drivers
* Send the notifications to the Ceilometer for backup service
* Add the StorPool block storage driver
* Update global requirements
* Remove commented out code from cinder/test.py
* Fix HNAS driver confusing error message
* Remove iscsi_helper calls from base iscsi driver
* Add unit test for commit 22abe9081
* Add Support for Dell Storage Center
* Ensure that lun_id is an int for NetApp Drivers
* Symantec NFS cinder driver
* DB migration tests
* Convert mox to mock: tests/compute/test_nova.py
* Correct default service_name for nova_catalog*_info config option
* FlashSystem Code Cleanup
* FibreChannel drivers for NetApp Data ONTAP storage controllers
* First version of Cinder driver for Quobyte USP
* Fix use of invalid variable in tgt exists check
* Remove an unused variable in volume/manager.py
* Brick: fix bug in tgt conf for volume
* Convert test_image_utils tests to mock
* Report better capacity info for a limitless 3par cpg
* VMware: Fix datastore selection with single host
* Add support for backup encryption metadata
* Improve use of temporary_file and temporary_dir
* RemoteFS: Move Nova snapshot code into RemoteFSSnapDriver
* Implementing the use of _L’x’/i18n markers
* Fixes intermittent NFS driver mount failure
* Updated from global requirements
* Use pbr entry_points to setup the cinder scripts
* ZFSSA iSCSI driver should support extra specs
* Remove the cinder.conf.sample file
* Fix for typo in Purity Host create/delete methods in PureISCSIDriver
* Fix a clone volume problem in VMAX driver
* Updated from global requirements
* Fix 3PAR driver attach error when host name missing
* NetApp fix vol migration unusability
* Updated from global requirements
* Allow HostState to handle empty capabilities
* Inherit RequestContext from oslo
* Imported Translations from Transifex
* Workflow documentation is now in infra-manual
* Remove the check_uptodate conf checks
* Improve unit tests for cinder/volume/utils.py
* Remove lio_initiator_iqns
* Bring cinder up-to-date with new oslo libraries
* VMware: Add missing storage profile requirement
* Use object.property instead of object.dump()['property']
* NetApp 7mode NFS driver doesn't honor netapp_vfiler option
* Revert "Fix Brocade FC SAN lookup MITM vulnerability"
* Add ability to zfssa driver to create multiple initiator groups
* Improve testing of cinder/utils.py
* Fix rpc initialization of cinder-manager volume
* Fix 3PAR drivers attempt to locate existing host
* Volume type access extension
* Remove driver compatibility in volume manager
* Don't use _execute directly in brick/iscsi
* Deal with tgt already exists errors
* Fix find_autodoc_modules.sh to support OSX
* Raise exception if invalid IP is specified
* Fix check_ssh_injection in cinder/utils
* Fix _get_disk_of_partition edgecase in utils
* Adding volume driver for X-IO ISE
* Remove Python 2.6 backwards compatibility code
* Imported Translations from Transifex
* Get the 'consumer' in a correct way for retyping with qos-specs
* PureISCSIDriver:Handle delete called on already deleted volume
* Add limited retype support for rbd
* Add iSCSI Target objects as independent objects
* Remove Python 2.6 classifier
* Implementing the use of _L’x’/i18n markers
* Match mock.patch decorator with appropriate param
* Correct misspelled words
* Brick LVM: LV not found logging and error handling
* etc: replace NullHandler by Python one
* Don't use module importutils from oslo-incubator
* Removing locks from 3PAR FC and iSCSI drivers
* Update rally job files
* Fix calls to assert_called_once in unit tests
* Refactoring to allow addition of NetApp FibreChannel drivers
* Add ability to create volume from image by image name
* Fix exception message formatting
* VMware: Set target ESX host for backing VM clone
* Create "image_conversion_dir" before creating temporary file
* Convert the DateTime into ISO8601 format for Ceilometer
* Imported Translations from Transifex
* Remove module timeutils
* NetApp NFS and iSCSI: move zapi client logic into modules
* Context cleanup
* ProphetStor with pool aware cinder scheduler
* Updated from global requirements
* Imported Translations from Transifex
* Fix messages in EMC VMAX driver with no translation
* Scality SOFS: implement volume backup and restore
* Fixup regressions in PureISCSIDriver log statements
* Implementing the use of _L’x’/i18n markers
* Remove module jsonutils
* Sync policy from oslo-incubator
* Don't use module excutils from oslo-incubator
* Sync latest versionutils from oslo-incubator
* GlusterFS: Lock on a per-volume basis
* Defining the variable "tmp" before try block
* PureISCSIDriver needs to disconnect hosts before deleting volumes
* context.elevated() should use copy.deepcopy()
* Added missing rules in policy.json
* Fix message translations for MSA common class
* Switch Cinder to use oslo.concurrency
* Use oslo.utils
* Remove code for deprecated extension path
* Imported Translations from Transifex
* Update prerequisite packages in development docs
* Change CHAP secret default length
* Implementing the use of _L’x’/i18n markers
* Switch to oslo.serialization
* Fix typo in SolidFire xDBVersionMismatch label
* Fix a problem in creating consistency group in ProphetStor driver
* Updated from global requirements
* Disable Cgsnapshot APIs by default
* Invalid GlusterFS share format error
* allow image_id for imageRef in create volume API v2
* Changing PureISCSIDriver to use % string formatting instead of .format
* Update cinder.conf.sample to fix max db conn retries
* CiscoFCSanLookupService passing command as string
* Documentation Bug fix committed
* Add i18n _LX tags for relevant log levels in EQLX driver
* Bump Req timeout to 30 seconds in SolidFire Driver
* Remove cinder/compute/aggregate_states.py
* Remove deprecation warnings relating to api-paste
* Mock isfile in test_ssh_missing_hosts_key_file
* Implementing the use of _L’x’/i18n markers
* Scality driver:use self.configuration instead of CONF
* Mock cinder.wsgi.Server in TestWSGIService
* Explicitly close requests obj in SolidFire Driver
* Remove Mock class monkey patching
* Add volume attribute support to volume created using clone, snapshot
* Stop stacktracing on QuotaErrors
* Stop stacktracing on InvalidInput exceptions
* Add automatic creation and deletion of Purity hosts for PureISCSIDriver
* Mox -> Mock for test_block_device.py
* Fix Brocade FC SAN lookup MITM vulnerability
* Implementing the use of _L’x’/i18n markers
* Imported Translations from Transifex
* Updated from global requirements
* Fix the LV NotFound situation for thin-type LVM
* Fix wrapper to work with barbicanclient 3.0.1
* Retry remove iscsi target
* Adding support for 'source-id' in 3PAR manage
* Remove test_barbican from keymgr tests
* Implementing the use of _L’x’/i18n markers
* Capture exception when delete a volume detached
* Add cinder support for IBM FlashSystem
* Use urllib.urlencode instead of dict_to_query_str
* Disable python-barbicanclient 3.0.0 version
* Activate pep8 check that _ is imported
* LIO: Fix UnboundLocalError in ensure_export
* Amend unused variables to assist pylint testing
* Brick LVM: Rename get_all_volumes, further optimize
* Fix wrong arg number for _fix_id_migration issue
* Cleanly override config in tests
* Add debug output indicating provider_location
* Use look up service for auto zoning
* Fix for debugging c-vol in PyCharm
* CiscoFCSanLookupSerive uses extra argument in init
* Fix SolidFire inaccurate model on migrated vols
* Eventlet green threads not released back to pool
* Add ability to update migration info on backend
* Reserve 5 migrations for backports
* Verify the full interface of the context object
* IBM Storwize: Improve error message
* Imported Translations from Transifex
* LioAdm: Delete initiator from targets on terminate_connection
* NFS Security Enhancements: allows secure NFS environment setup
* Brick LVM: Optimize get_volume
* TgtAdm: Don't change CHAP username/password on live migration
* Update volume-type's quota when extending volume
* Cinder api service doesn't handle SIGHUP properly
* Handle DBConnectionError instead of Exception
* Remove outdated _ as a builting from pylintrc
* ProphetStor driver consistency group support
* Turn on Flake-8 Complexity Checking
* Log a warning when getting lvs and vgs takes longer than 60 seconds
* Add client_socket_timeout option
* IBM Storwize driver: Add local variable assignment to "ctxt"
* Updated from global requirements
* Multipath commands with error messages in stdout fail to parse
* NetApp fix to set non default server port in api
* Correct the message string

2014.2
------

* Fix LVM iSCSI driver tgtadm CHAP authentication
* Export cinder volumes only if the status is 'in-use'
* Fix LVM iSCSI driver tgtadm CHAP authentication
* Export cinder volumes only if the status is 'in-use'
* Revert "Relocate volume to compliant datastore"
* Remove vol_type_id cast to str
* Move SolidFire driver from httplib to requests
* check the configuration item glance_num_retries
* VMware: Fix initialization of datastore selector
* Imported Translations from Transifex
* Fix exception handling on test_delete_nonexistent_volume
* check the configuration eqlx_cli_max_retries
* Revert "Relocate volume to compliant datastore"
* Remove deprecated use of gettextutils import _
* Fix NetApp AutoSupport Shortcomings
* HP 3PAR: Don't ignore extra-specs snap_cpg when missing cpg
* 3PAR migrate without losing type settings
* 3PAR with pool-aware-cinder-scheduler
* Fix display name change during backup restore
* gitignore /.*
* Fixes docstring typos (Cinder)

2014.2.rc2
----------

* Remove useless sslutils from openstack.common
* Truncate fail_reason to column length
* Fix eqlx CLI output parsing on bad input
* Eqlx fix NoSuchOptError for volume_name_template on clone
* VMware: Bump driver version
* Updated translations
* NetApp fix eseries unit test mock clean
* Make sure device support Direct before setting
* Make sure device support Direct before setting
* Eseries warn if multipath is not set for img xfer
* GlusterFS: Remove unneeded conf import
* ZFSSA iSCSI vol create fails with vol type option
* Handle eqlx SSH connection close on abort
* ZFSSA iSCSI driver cannot add multple initiators to a group
* Fix race condition in ISCSIConnector _disconnect_volume_multipath_iscsi
* Deprecate / obsolete NetApp volume extra specs
* IBM Storwize driver: Retype the volume with correct empty QoS
* Fixed Typo from modfied to modified
* Updated from global requirements
* Sync latest processutils from oslo-incubator
* Imported Translations from Transifex
* Updated from global requirements
* coraid: allow setting default repository
* Sync latest processutils from oslo-incubator
* Windows SMBFS: Handle volume_name in _qemu_img_info
* Refuse invalid qcow2 backing files
* Windows SMBFS: Handle volume_name in _qemu_img_info
* Refuse invalid qcow2 backing files
* Clarify InvalidInput exception when the size is missing
* Handle eqlx SSH connection close on abort
* Deprecate / obsolete NetApp volume extra specs
* Fix race condition in ISCSIConnector _disconnect_volume_multipath_iscsi
* ZFSSA iSCSI driver cannot add multple initiators to a group
* ZFSSA iSCSI vol create fails with vol type option
* Open Kilo development

2014.2.rc1
----------

* Fix race condition in ISCSIConnector disconnect_volume
* Adds openSUSE support for developer documentation
* IBM Storwize driver: Retype the volume with correct empty QoS
* VMware:Unquote folder name for folder exists check
* VMware: cinder-volume create_session fail at retry
* Fixing format for log messages
* Update /etc/cinder/cinder.conf.sample for memcache
* VMware: Relocate volume to compliant datastore
* Fix parameter miss in test_snapshot_metadata test case
* Failed to re-detach volume when volume detached
* Imported Translations from Transifex
* IBM Storwize:Failed to retype from non-type to replication enable
* Fix unnecessary WSGI worker warning at API startup
* Remove XenAPI driver
* Add required spaces in log messages
* Fix ssh_host_key_file default in help and config.sample.conf
* Downgrade 'infinite' and 'unknown' capacity in weigher
* Remove unused py33 tox env
* Add unit test to cinder cgsnapshot api
* DB migration 25->24 failed when dropping column
* Allow scheduler pool information to be retrieved
* Increase the 3PAR hostname length
* Timeout triggers failures running tempest for ZFSSA driver
* NetApp fix for default host type in eseries
* HP 3PAR drivers should not claim to have 'infinite' space
* Add tests for consistency groups DB migration
* Verify requested size in volume.api create
* Typo "asscoiated" should be "associated"
* NetApp fix eseries unit test mock clean
* Updated from global requirements
* Set socket options in correct way
* HP 3PAR: Allow retype when the old snapshot CPG (3PAR pool) is None
* NetApp fix for controller preferred path
* VMware: Add storage profile related unit tests
* Check replication status failed for non-replication
* VMware: Implement retype for VMDK driver
* VMware: Improve datastore selection logic
* Sync latest strutils from oslo-incubator for mask_password fix
* Remove executable bits on various files
* Fix a problem with 'volume list' when 'all_tenants=0'
* IBMNAS: Remove call to set r/w permissions to all
* Updated from global requirements
* Getting iscsi_ip_address from cinder.conf
* Handle config file with newlines and whitespaces
* Volume types need to be specified when creating CG
* Stop using intersphinx
* Netapp drivers support for pool-aware scheduling
* coraid: fix snapshot deletion
* SQL scripts should not manage transactions
* Add reset-state function for backups
* Add test case for volume_types.py
* Block sqlalchemy-migrate 0.9.2
* Destroy Datera export target after detach
* EMC VNX Direct Driver Consistency Group support
* Update oslo.config and oslo.messaging requirements
* Fixes Windows Volume Driver upload volume fails
* Log an error on nfs mount failure
* Sync service.py and its dependencies to Cinder
* HP 3PAR configurable ssh-host-key-policy
* Fix confusing exception message in NetApp iscsi driver
* Delete consistency group failed
* Fixing leaking sessions in 3PAR on attach/detach
* Add Windows SMB Volume Driver
* Netapp: fix multiple copies of cinder-volume
* Add SMB Volume Driver
* Fix possible race condition for accept transfer
* Imported Translations from Transifex
* Mock glance client object in version unit tests
* Revert iSCSI Target objects as independent objects
* Use right body for test_create_missing_specs_name
* remove object in wsgi LOG.info
* Don't clear _mounted_shares list in remoteFS while updating
* Some tcp configuration paramters are ignored
* Add filter to volume transfer REST api
* Fix help for running specified unit tests
* Deprecate the V1 API
* Set default pool value to system in gpfs driver
* Fixes Cinder fails to upload volume to vhd image
* Unit test for restore with different hosts

2014.2.b3
---------

* During a restore send the restore request to the right host
* Add Datera driver for Cinder
* warn against sorting requirements
* VMware: Remove redundant extend disk API call
* VMware: Implement backup/restore for VMDK driver
* Update the HP 3PAR default persona
* Fixed Typo - from hypens to hyphens
* Fixed typo from 'the the' to 'the'
* Fix running unit tests with coverage
* Support Volume Backup Quota
* Volume Replication implementation for IBM Storwize/SVC
* Add Fujitsu ETERNUS DX support
* Pool-aware Scheduler Support
* Small typos
* Add QoS support to IBM Storwize driver
* Fix unnecessary snap of glance image, with non-raw images
* Driver for Fusion-io ioControl Hybrid array
* Make ssh-host-key-policy configurable
* Add Cisco FC Zoning plugin to the FC ZoneManager
* Typo
* Ignore pylint error 'hashlib' has no shaxxx member
* Update oslo policy and its dependencies
* Avoid using the disk cache on volume initialisation
* Introduce Hitachi storage volume driver
* XtremIO cinder iSCSI & FC volume drivers for Juno
* Consistency Groups
* Add retype method to xiv/ds8k driver interface
* Fixes terminate_connection live migration issue
* Fixing 3PAR excessive FC port usage
* Sync latest processutils from oslo-incubator
* Sync latest strutils from oslo-incubator
* Mock processutils.execute properly in test_ibmnas
* VMware: Disable suds caching
* Adds volume replication methods to xiv/ds8k driver interface
* Pass an empty context to the notifier
* Add Oracle ZFS Storage Appliance ISCSI Driver
* Add support in Cinder for volume replication - driver approach
* EMC VMAX Driver Juno Update
* Fix duplicate teardown to allow tox upgrade
* Revert test_rootwrap_filter to avoid python2.6 test failure
* Improve Cinder API internal cache interface
* Allow backup-to-swift to take swift URL from service catalogue
* Integrate OSprofiler and Cinder
* Fix variable name in api/v<n>/snapshot.py
* Honor volume:get policy
* Extending IBMNAS driver to support NFS based GPFS storage system
* GlusterFS: Use image_utils for tempfile creation
* Modify error code compatible with Mac OS
* Cache snapshots in request for extension
* Remove redundant temporary_chown from IetAdm
* Failed to initialize connection
* Mock out image source file in image_utils tests
* Provide a quick way to run flake8
* Ignore No value passed for parameter 'dml' message
* Create RemoteFSSnapDriver class
* VMware: Handle exceptions raised by image update
* Adds barbican keymgr wrapper
* Imported Translations from Transifex
* Catch vol not found in SolidFire transfer
* Fix LOG string formatting in image_utils
* Change the froce delete volume flage to True
* Update ref used for notifications
* HP 3PAR manage_existing with volume-type support
* Add iSCSI Target objects as independent objects
* Rewrite ionice command filter using ChainingRegExpFilter
* Use abstract class for the backup driver interface
* Put result in quotes
* Fix exception handling in PureISCSIDriver
* Catch DBDuplicateEntry instead of IntegrityError
* Enable import group hacking rule
* Actually encode the SolidFire json dump result
* Sync latest oslo-incubator log for debug fixes
* Enable F402 checks and fix violations
* Prevent tenant viewing volumes owed by another
* VMware: Check snapshot and rename backing
* Fix bad indentation in netapp and san.hp volume drivers
* Ignore HTTP_PROXY during test requests
* Issue one SQL statement per execute() call
* Add ProphetStor DPL Storage server volume driver for Cinder
* Add timer info for copy operations
* Make manage.py usable
* Enable H104, F841 hacking rule and fix violations
* Adds CA cert file path option for glance connections
* Enable Swift backup driver for auth 2.0
* Updated HACKING.rst so that it is accurate
* Update help strings
* Add hacking check for use of LOG.audit
* Imported Translations from Transifex
* Use oslo.i18n
* Add CHAP support for 3PAR ISCSI
* EMC: Fix minor issue in VNX driver and unit tests
* fix a small typo in development.environment.rst
* Do not translate debug messages
* Fixing LeftHand live migration error
* Improve regex for _ import hacking check
* General cleanup of unused objects
* RPC client lazy initialization
* Fix snapshot id for snapshot_destroy
* Use auth_token from keystonemiddleware
* Fixes wrong usage of mock.assert_not_called()
* Fix error log level in restore-backup routine
* Add retry_on_deadlock to db update methods
* Fix unit test test_import_record_with_verify
* Change the exception type for Storwize/SVC driver
* VMware: Update default task_poll_interval value
* Change logging level AUDIT to INFO
* Fix solidfire accept_transfer
* VMware: Volume from non-streamOptimized image
* Enable checks for E711, E712 and E713
* Add note that some checks are disabled on purpose
* VMware:Disk type conversion during clone backing
* VMware:Support for attaching disk to backing
* Change 3PAR delete message when volume is busy
* Move generate_password into volume utils
* Move SSHPool into ssh_utils.py
* Fixes migrate_volume_completion
* Change corrupted spelling mistakes
* EMC VNX Direct Driver Update for Juno
* Storwize/SVC can not get the right host
* Skip incompatible test on OSX
* Have task/flow logging go to a separate log file
* fix atom link in XML Version API
* Update ref used for notifications
* Fix glance metadata SQL query performance
* Add return of updated object on update from DB
* fixing the iSER transport protocol when using LVMISERDriver
* Add hacking check for vim headers
* Get updated model info on volume transfer
* Introduce iSCSI driver for Pure Storage FlashArray
* Further cleanup of reservations index
* Sync log from oslo-incubator for isEnabledFor fix
* Modify the index migration slightly for backport
* Remove cinder-clear-rabbit-queues
* Remove cinder-rpc-zmq-receiver
* Remove reattach function in cinder-manage
* Set python hash seed to 0 in tox.ini
* HP 3PAR retype implementation
* Add index for reservations on (deleted, expire)
* Remove Hyper-V dependency in the Windows Cinder Volume Driver
* Fix no handlers could be found issue
* Add storageHost content to volume messages
* Add hacking check for explicit import of _
* Make manage/unmanage admin only
* Avoid OSError in get_blkdev_major_minor with network filesystems
* VMware:Support for create disk and disk descriptor
* Implement import/export for SolidFire Driver

2014.2.b2
---------

* Implements new 'bootable' option for manage existing volume
* Add hacking test
* Fixes Cinder volume upload to image on windows
* Add explicit import of _ to hp_3par_fc and iscsi
* Adds storwize_svc_npiv_compatibility_mode flag to Storwize/SVC driver
* Switch to use oslo.db
* Add additional explicit imports of _ where needed
* Fix failure of source volume deletion in migrate_volume_completion
* Remove hard coded reference from gettextutils.py
* Enable lazy translation for Cinder
* Explicitly import _() in Cinder code
* Fix performance issues with brocade zone driver
* Don't leave snapshots on the floor
* Add some log info for NoValidHost
* Use immutable default values for args
* Update cinder generate_sample script
* XIV volume manage/unmanage support
* Add affinity/anti-affinity filters
* Bump oslo.rootwrap to 1.3.0.0a1 for Cinder
* Mock out time.sleep in storwize unit tests
* Fix the section name in CONTRIBUTING.rst
* Cinder-api service throws error on SIGHUP signal
* Clean up base Volume Driver
* Fixes EqualLogic volume live migration
* Correct misspelled word
* Remove definition of Python Source Code Encodings
* Fixed some typos in the cinder codebase
* Sync gettextutils.py from oslo-incubator
* Use PyCrypto to generate randomness passwords
* Remove $sqlite_db from default database connection
* Sync processutils and log from oslo
* Configure write cache option of tgtd iscsi driver
* Enhance docstring for iscsi_helper
* Updated from global requirements
* Ensure FC ZoneManager is called
* Remove cinder.context warning logging
* sync periodic_task fix from incubator
* Slow down Storwize driver initialization
* Updated from global requirements
* Imported Translations from Transifex
* Imported Translations from Transifex
* volume_image_metadata missing from volume list
* Correct lvm_mirrors help message
* Ceph rbd volume manage/unmanage support
* Enable E121,E122,E123,E126,E128 hacking rules
* Replace tearDown with addCleanup - Part 3
* Fix begin_detach logic
* Use (# of CPUs) osapi_volume_workers by default
* Restore osapi_volume_workers config option
* Fix host option isn't set when using multiple backend
* Add optional_args to fix Volume Import failure
* 3PAR Only remove FC Zone on last volume detach
* Ensure rbd connect exception is properly caught
* Add cinder-manage cmd to update host column
* Add cinder volume driver support for Nimble Storage
* Sync processutils from oslo with deps
* Synced jsonutils from oslo-incubator
* Enable hacking rule E111,E112,E113
* Bump minimum hacking version to 0.9.2
* Only warn about deprecation warnings once
* Fix dropped exception for create_export in vol manager
* Misuse of i18n log translation to output error message
* Support Volume Num Weighter
* Fix docstring for snapshots API
* Don't use ModelBase.save() inside of transaction
* Fix unsaved exception in backup/drivers
* 3PAR volume manage/unmanage support
* Add cgroups related commands to rootwrap filters
* Use a task subclass instead of a functor + task wrapper
* Fix BrcdFCSANlookupService to iterate multiple switches
* GlusterFS: Handle deletion of snapshot with no backing file
* Fixed data copy issue of volume/driver.py
* Make rbd driver string encoding checks consistent
* Remove check_volume_az_zone functor and associated passing
* Minor cleanups in test_volume
* Fix retyping attached volumes requiring migration
* Update _resize_volume_file() to support appropriate permissions
* test_storwize_vdisk_copy_ops fails if green thread context switch
* VMware:Fix params for copy-image-to-volume
* VMware: Optional create backing parameters
* Fixes cinder volume from snapshot on Windows
* Fixes cinder volume create on Windows Server 2012 R2
* Fixes cinder volume from image on Windows
* Use oslo-incubator module units
* Attach log listeners to other engines
* Adding filter options to backup list
* Remove global conf settings from iscsi helper
* Add genconfig tox job for sample config file generation
* Fix nfs_shares config file parsing of spaces
* GlusterFS: Various unit test improvements
* vmware: Force chunked transfer for upload-to-image
* Sync the latest common db code from oslo
* Fix order dependency of admin metadata
* GlusterFS tests: Mock out compute, don't load novaclient
* Updated from global requirements
* debug level logs should not be translated
* Implement extend volume in NFS driver
* Fixes an issue with 'dd' bug from Illumos repo
* Handle the case where az is disabled/removed
* I/O rate limit for volume copy with qemu-img convert
* I/O rate limit for volume copy with dd
* glusterfs: Honor mount options when restarting cinder service
* Add keyword argument missing at some exc.HTTPError subclass
* Made provision for providing optional arguments
* Removes unecessary call to rbd.Image
* Add task/flow listener support around the volume api flow
* Retry lvremove with ignore_suspended_devices
* Allow reset-state on attach and migration fields
* Implements HDS-Cinder HNAS Drivers
* vmware: Fixes VMDK volume incompatibility issue
* Remove unused oslo module and adjust opentstack-common.conf

2014.2.b1
---------

* Copy custom properties to image from volume
* Add strip size support to rbd driver
* Fix log capturing fixture
* Fix Brocade FC driver's use of the fc_fabric_names
* LIO: Don't add ACL for local initiator name
* Delete image on upload-to-image failure
* Ensure flushing of IO prior to removing FC device
* Fixed the comment spelling error - voumes to volumes
* Remove Quota Exception Stack Traces from Cinder Logs
* Use os.urandom in volume transfer
* Remove check_{attach,detach} from volumes API
* Make begin_detaching fail if volume not "in-use"
* hp_lefthand_rest_proxy no handler for logger during tests
* 3PAR volume detach with host in a host set
* Update cinder.conf
* Sync periodic_task from oslo-incubator
* Remove second get call to list/show volumes
* Fix a message format error in migration cleanup
* Add support for z/VM driver
* Handle volumes no longer existing in resume delete
* Fix ISER scan retry option
* Only create volume with an active image
* Updated from global requirements
* Ensure metadata is saved before updating volume status
* Add XML deserializer for qos_manage delete_keys API
* Use error instead of warning to log mount exc
* Allow host config to be overriden in backend
* Remove all mostly untranslated PO files
* Updated from global requirements
* Remove create_from* functor jump table
* SSHPool in utils should allow customized host key missing policy
* Check whether O_DIRECT is supported to iflag and oflag separately
* Set volume usage audit period to not NoneType
* BrcdFCSanLookupService should allow customize host key and policy
* NetApp fix eseries concurrent vol map failure
* NetApp fix attach fail for already mapped volume
* Imported Translations from Transifex
* Convert SolidFire Capacity response to GiB
* eliminate the need for hplefthandclient in tests
* Fix solaris_execute in SolarisISCSIDriver
* Fix for solidfire driver to use reserved_percentage
* Fix retyping volume that has volume type None
* eliminate the need for hp3parclient in tests
* Add missing methods to FakeISCSIDriver
* Add mailmap entry
* Fix wrong exception reference
* Limit formatting routes when adding resources
* Use oslo network utils function to set tcp_keepalive
* Properly initialize rpc in cinder-volume-usage-audit
* Add exception handling for copy_volume_to_image()
* NetApp NFS: Do not reference dst_img_local before assignment
* Remove explicit dependency on amqplib
* Fixes an issue with 3PAR attach
* Ensure that lun_id is an int
* Implement validate_connector in FibreChannelDriver
* Fix broken version responses
* Fix double "the" in Cinder quota warning
* CinderException args to strings when exceptions
* Fixed 3PAR driver issue finding correct vlun
* Storwize/SVC driver detach volume failed
* Add disabled kwarg to service_get_all_by_topic
* Add rally job
* Improve consistency of help strings
* Remove unused volume instance_uuid methods
* Cinder list does not filter admin metadata
* Specify lld in tgt config backends
* Replace tearDown with addCleanup - Part 2
* Keep volume available if retype fails due to quota
* Remove unused 3PAR driver method
* Fix bad indentation in tests
* Add set-bootable command
* Fix handling multiple WWPNs on preferred FC node
* Fallback to None on missing Glance image attrs
* Remove old driver mappings from Havana
* Adjust sample config for keystoneclient 0.8.0 release
* Remove unused reservation methods from db.api
* Re-raise exceptions in upload-to-image
* Update Cinder dev doc
* vmware: Fix problems with VIM API retry logic
* Create volume fail when image id is ""
* Use cached db object in volume_mig_status ext
* Add exception catch if Storwize/SVC driver failed when retyping
* Replace tearDown with addCleanup - Part 5
* Replace tearDown with addCleanup - Part 4
* Enable flake8 H303,H304 checking
* Storwize/SVC driver crashes when check volume copy status
* Switch over to FixedIntervalLoopingCall
* Correct metadata ordering issue in tests
* driver.create/remove_export() require elevated context
* Inform about instance_uuid in volume usage notification
* Check for silent failure of tgtadm remove
* GlusterFS: Delete active snapshot file on volume delete
* Fixes HP LeftHand driver with Paramiko 1.13.0
* Fixes cinder error state volume delete on Windows
* Added unit test cases for _is_share_eligible in NFS driver
* Log initialize_connection error before remove_export
* Force detach should only be an admin api
* Updated from global requirements
* Change iogrp property when retyping for Storwize/SVC
* Check that all po/pot files are valid
* Allow deprecated volume update keys in v2
* _translate_from_glance() can cause an unnecessary HTTP request
* Adds ionice command permutations to rootwrap filters
* Append nas_opts to IBMNAS_NFSDriver configuration
* Enable flake8 F841 checking
* GET details REST API next link missing 'details'
* GlusterFS: Delete volume-<uuid>.info file when volume is deleted
* Fix Jenkins translation jobs
* Fixes HostTestCase failures due to slow test run
* Imported Translations from Transifex
* Updated from global requirements
* Fixes cinder volume delete on Windows
* Fixes cinder volume attach on Windows
* Open Juno development

2014.1.rc1
----------

* Imported Translations from Transifex
* Changes to correct name of missing NetApp license
* NetApp cmode nfs: Fix QOS extra spec
* NetApp cmode iscsi: Fix QOS extra spec
* Fixes a problem in attach volume in EMC driver
* Update config generator from OSLO
* Pass the mirrorlog option as two arguments
* Import request_id middleware bug fix from oslo
* Netapp iscsi: allow snapshots with unspecified block range
* Serialize the notification payload
* Disable oslo.messaging debug logs
* Updated from global requirements
* Update tests to use CONF.set_override
* Adds xiv_chap to xiv/ds8k driver configuration
* vmware: Use SessionIsActive to find stale session
* init_host should be called before RPC consumer is created
* Add RequestContextSerializer for rpc notifications
* Allow NetApp iSCSI driver to sub-clone large volumes
* Can't force-create snapshot by an non-exist error volume
* Remove rootwrap module
* Simplify test force delete snapshot unit test
* ceph backup driver: improve log messages
* resolve KeyError for IBM Storwize/SVC driver
* vmware: Remove deprecation warning from VC driver
* Remove unused method from NetApp iscsi driver
* vmware: Remove pbm_default_policy config option
* VMware: Implement vmdk extend_volume
* Fix create_export/remove_export in driver.py
* Imported Translations from Transifex
* vmware:Ignore inaccessible/inMaintenance datastore
* Ensure name is utf-8 when deleting rbd vol or snap
* Use six.moves.urllib.parse instead of urlparse
* Use the error_out_volume from flow common instead
* Revert "Re-enable lazy translation"
* Sync latest Oslo code for imageutils
* Don't send untextified exc to webob
* Imported Translations from Transifex
* Updated from global requirements
* Use debug level logging during unit tests
* Sync log.py from oslo-incubator
* Fixed some FCZM unit tests hacking issues
* Add missing config values for vmwware_vmdk test
* cinder-rtstool imports a not existing module
* get volumes with limit and filters does not work
* Fixes cinder-volume service startup on Windows
* Fixed nova VM live migration issue with 3PAR
* Adding domain to context
* Switch over to oslosphinx
* Add libffi-dev to list of packages to install in dev env
* VMware: Take the volume size from the user input
* Fix exception message of CoraidESMConfigureError
* vmware: Mark VMware ESX vmdk driver as deprecated
* Fixes ssh-injection error while using chap authentication
* Generate config samples for oslo.messaging
* Add conversion types in some strings
* Port to oslo.messaging
* Updated from global requirements
* get volumes API does not handle limit=0
* EMC SMI-S delete snapshot unit test takes too long
* 3PAR: Support extend volume based on snapshot
* Fixed spelling error - accomodate to accommodate
* GPFS unit tests: increased coverage, uses mock
* Clean Up EMC VNX Direct Driver in Cinder
* gpfs driver: fix logging problems
* Convert cinder utils tests to use mock
* Include next link when default limit is reached
* Re-enable lazy translation
* Sync latest Oslo config code for i18n
* Fix HP LeftHand Performance issue with AO
* NetApp implementation for copy offload in clustered nfs driver

2014.1.b3
---------

* Remove str() from LOG.* and exceptions
* Storwize volume manage/unmanage support
* Volume manage/unmanage support
* Add user defined extra capabilities
* remove _check_container_exists from Swift backup driver
* Add initiator_target_map for IBM Storwize/SVC
* Fix HP LeftHand migration with snapshots
* Updated from global requirements
* Fix docstring ordering
* Typo corrections for test files in cinder
* vmware: PBM wsdl file configuration
* vmware: default global pbm policy configuration
* vmware: check datastore availability during create
* vmware: Storage policy based volume placement
* Add EMC VNX Direct Driver in Cinder
* gpfs volume driver backup file access fixes
* Check if snapshot is deleted cleanly
* Restrict rootwrap find filter for IBM NAS and GPFS
* Add initiator target map in EMC SMI-S FC driver
* GlusterFS: Set permissions on qcow2 snapshot files
* Make EMC SMI-S driver unit tests faster
* change time.sleep to use loopingcall
* Change RBD delete failure log level to warn
* Updated from global requirements
* Update Oslo wiki link in README
* Add versioning output for the FC Zone Manager
* Fix volume stats with multiple LeftHand clusters
* Export and import backup service metadata
* Don't clear host_state_map when scheduling
* Add volume metadata backup suport to swift driver
* Add optional ionice to volume clearing process
* Quota delete operation in cinder
* Restrict rootwrap find filter for NetAppNFS driver
* GlusterFS: Increase snapshot delete job timeout to two hours
* Segment LUN clones in NetApp iSCSI
* updating testing readme with more current information
* Remove unused variable
* Python 3: replace "im_self" by "__self__"
* Update FibreChannel Zone Manager config
* Change warning message in NetApp driver for vsadmin creds
* 3PAR: Fix extend volume GiB to MiB
* TSM backup driver changes to support file backup
* Fix silly error in comment
* 3PAR: Create volume from snapshot with larger size
* Fix free_capacity reporting in SolidFire driver
* Fix test_delete_should_not_.. to assert something
* Replace assertEqual(None, *) with assertIsNone in tests
* Replace tearDown with addCleanup
* Use six.StringIO instead of StringIO.StringIO
* Implement retype in IBM GPFS Driver and refactor
* 3PAR: Delete missing snapshot stuck in error_del
* Added 3par initiator target map for FCZM
* Fix race in test_delete_backup
* Driver for IBM SONAS and Storwize V7000 Unified
* Fix webob.exc.HTTPForbidden parameter miss
* Add snapshot related data to limits api
* Storwize/SVC: Change volume copy task to async
* Fix FC connection handling in the storwize driver
* Sync log.py from oslo
* Replace httplib.HTTPSConnection in unittests
* Add support for FC zone lifecycle management
* Give a way to save why a service has been disabled
* Remove old driver mapping deprecation
* 3PAR: Backend assisted volume migrate
* Add HP MSA Fiber Channel driver
* Ensure return for db api functions
* HP LeftHand Backend assisted volume migrate
* Add support for qos_specs feature to 3PAR drivers
* Add x-openstack-request-id to cinder responses
* Update 3PAR drivers to pass cert test
* Remove unused function
* Use len instead of for-loop to get the end index
* Ensures NetApp iSCSI driver correctly compares int values for size
* Sync request_id, request_utils for cinder
* IBM XIV and DS8000 Driver reorganizing (IBM dir)
* Sync oslo imageutils, strutils to cinder
* GPFS:  Implement volume backup and restore
* Fix missing package dependency for requests
* test_volume unittest fails if ran only this module
* Fix invalid facilities documented in rootwrap.conf
* Use six.moves cStringIO instead of cStringIO
* NetApp api fix structure conversion methods
* Add support for backing up volume metadata
* Imported Translations from Transifex
* Replace assertEqual(None, *) with assertIsNone in tests
* Add encrypted flag to volumes
* Implement retype in HP LeftHand driver
* Cast the quota set values to integer before checking their validity
* Remove rabbit_notifier (Sync notifier with oslo d6e1ba7)
* Remove dependent module py3kcompat
* Add EMC SMI-S FC Driver in Cinder
* Fix wrong example of "nova_endpoint_template"
* NetApp eseries iscsi driver implementation
* Update gpfs driver volume creation process
* Deactivate LV before removing
* VMware: changing volumeops tests from mox to mock
* Remove unused exception
* Add searchDepth when getClusterInfo called
* Check type argument on create from source and snap
* Rename Openstack to OpenStack
* Removes use of timeutils.set_time_override
* Removed unused context in _extend_snapshot method
* Remove unused methods
* Storwize/SVC: Check wwpn not None
* Changes to cast variable as integer as XML API fails
* Ceph backup driver tidyup
* Move create_, remove_ and ensure_export from drivers
* New HP LeftHand array iSCSI driver
* GlusterFS: Fix create/restore backup
* Allow operators to customize max header size
* Fixup persistence file not found on tgt remove
* Remove tox locale overrides
* Add method for unit tests to set logging level
* Brick support for pNFS
* Storwize/SVC: Fix races in host-related functions
* Fix cinder-backup volume restore with ceph driver
* Dont set error_extending status on API extend call
* Fix misspellings in cinder
* Fixes cinder failed to create/restore a backup with NFS driver
* Brick fix BrickException message formatting
* lvm: unhandled exception when migrating volume
* Implement retype in SolidFire driver
* Validate the quota in the API layer for volume extend
* Rename self.tgtadm to self.target_helper
* Fix LVM migrate_volume tests
* Brick connector fix for GlusterFS
* Updated from global requirements
* vmware: intermittent failure in test_vmware_vmdk
* RBD unit test improvements
* Move clear_volume back to it's own method
* Don't use shred for volume_clear=zero
* Nexenta iSCSI driver: fixed volume_migration
* Move clear_volume method to volume.utils
* Add update support to volume type encryption
* LVM: log thin pool name and size upon creation
* Remove create_export from volume create
* vmdk: To add missing time unit in driver option
* Update SolidFire Driver to use cinder's units
* Update cinder.conf.sample for new keystone client
* LVM: remove redundant casts to float
* On create_volume flow get rid of host parameter
* Imported Translations from Transifex
* Allow spaces in host names in the storwize driver
* Remove a catching exception during delete_volume
* Remove SSH code from 3PAR drivers
* Remove unused task from manager create_volume flow
* Add support for special char in volume metadata
* Brick LVM: Handle space info as numeric types
* Set a sane default for state_path
* Fixes incorrect key in dictionary
* Stop volume_type_encryption creation when in use
* Revert initialize_connection changes
* Convert ceph backup unit tests from mox to mock
* VolumeManager: initialize even if a volume can't be found
* Add create_iscsi_target stub to TargetAdmin
* 3PAR iSCSI volumes attach to single nsp
* Extra_spec containing '/' can't be deleted
* LVM: Robustify skipactivation detection
* Make sure report_interval is less than service_down_time
* Redundant check in os-migrate_volume_completion
* Updated error messages for volume clone
* Imported Translations from Transifex
* Updated from global requirements
* Fix up the way we do iqn variable in unit test
* Catch new iscsi exception
* Delete volume transfer in volume_destroy function
* Create structure of flows' packages
* Fix docstring and remove unused variable
* GlusterFS: Fix deadlock in volume clone
* Enable multi-process for API service
* Sync RPC module from Oslo
* Sync common modules from Oslo
* Sync py3kcompat, sslutils, versionutils from Oslo
* Sync gettextutils from Oslo
* Storwize driver cleanup
* Add support for retype in Storwize/SVC driver
* Add notifier events to cinder volume rename, reset-state

2014.1.b2
---------

* Convert RBD unit tests to use mock instead of mox
* Fixed inconsistency in iqn
* Update HACKING.rst with regard to mock usage
* Remove unused method 'is_key_value_present()'
* Remove unused config options
* Remove unused exceptions
* Do not show quota of removed volume types in Default Quotas panel
* Fix up calculating space info for mirrored volumes
* Rename __init__.py to create_volume.py
* Use oslo.rootwrap library instead of local copy
* Fix UnboundLocalError in TgtAdm.update_iscsi_target
* Update host on driver retype
* Remove unused variable in restore_backup method
* Ensure hostnames are converted to IP for comparison
* Add Backup Service to 'cinder-all' script
* Remove env from rootwrap filter
* Allow user to specify audit period
* Fix exception log msg in attach volume method
* Fix import log_handler error with publish_errors set
* Use a mirrored mirror log
* Added missing accept_transfer to FC
* Register EMC config options globally
* Fix os.getlogin() problem with no tty
* Updates for version list to show correct references
* Fix cross-import bug in cinder.db.sqlalchemy.api
* Pull Bug #1263122 fix for service module from Oslo
* Pull latest scheduler change from Oslo
* Use loopingcall from openstack-common
* Use a *args pass-in instead of a list one
* Remove unused variable in os-extend api
* GlusterFS: Synchronize additional operations
* Move driver initialization check into the method
* Update cinder.conf.sample for keystoneclient change
* Transfer creation doesn't support 'name' via xml
* Change default policy for volume_extension:volume_tenant_attribute
* Print driver exception on retype
* Drop Chance/SimpleScheduler Implementation
* Fix sqlalchemy bug in transfer_get_all_by_project
* Fix sheepdog copy_image_to_volume method
* NFS/GlusterFS: Skip incorrectly formatted shares
* Remove unused message from iogrp_data setup
* Remove legacy config option 'connection_type'
* Modify default prefix for solidfire account
* Add time_type dictionary to test_migrations
* 3PAR: Raise Ex when del snapshot with depend vol
* Add bool_type dictionary to test_migrations
* Hiding postgresql password in connection string
* Fixed a problem in iSCSI multipath
* Fix the invalid argument of webob.exc.HTTPBadRequest
* Add ability to modify volume type
* Fix downgrade in 002_quota_class.py for MySQL
* Removed deprecated config option hp3par_domain
* Fix Brick LVM test command parsing
* Update V2 API to return detailed volume information on create
* LVM: Fix "intialized" typo in warning msg
* Imported Translations from Transifex
* removed unused context in check_*** methods
* add 'force' verification in _volume_upload_image
* Raise max header size to accommodate large tokens
* LVM: update iscsi target on volume attach
* LVM: Activate Thin Pool LV upon initialization
* GlusterFS: Use correct base argument when deleting attached snaps
* Switch to Oslo's config generator
* Removed copyright from empty files
* Remove unused fake_flags
* Replace Simple/Chance Scheduler with FilterScheduler
* Reduce the redundant variable declarations
* Imported Translations from Transifex
* Remove vim header
* Redundant size check in volume restore api
* Add AllocatedCapacityWeigher
* Imported Translations from Transifex
* Adding helpful URL links to README.rst and HACKING.rst
* Handle terminate_connection() exception in volume manager
* Empty files shouldn't contain copyright nor license
* Bugfix missing foreign key removal for mysql
* Fix spelling errors
* Imported Translations from Transifex
* Add additional metadata as key-value pairs in 3PAR
* Handle initialize_connection() exception in volume manager
* Output Strings of bin/*.py should support i18n
* Add qos_specs support to solidfire driver
* Service launcher method docstring corrected
* Fix QoS information in initialize_connection() result
* Fix and enable gating on F401
* Only reverify backing lun when create backing lun
* Set volume_dd_blocksize configurable on per-driver basis
* Add exception logging if flow creation fails
* Remove dynamic default on sf_account_prefix
* make delete recovery messages debug level
* Remove unused code from volume manager (reset_stats)
* Pylint fixes for GlusterFS driver
* Pylint fixes for Brick iSCSI/LVM
* 3PAR FC: add ability to add WWNs to host
* Imported Translations from Transifex
* Adjust import order according to PEP8 imports rule
* Do not clone non-raw images in rbd backend
* Adds unit tests for drivers.rbd.RBDImageIOWrapper
* [Netapp/Nexenta] Move registration of config options
* Fix and enable gating on H402
* LVM: Activate source snap LV when cloning from volume
* Remove test that was no longer used for long
* make help text more meaningful for cinder docs
* Switch create volume commands to Taskflow 0.1.1
* Use mock for scheduler tests
* Remove LANG=C from rootwrap invocations
* Add the driver name to get stats log output
* Remove hashbang (#!) at beginning of python modules
* Fix KeyError while generating a WSGI response
* Updated from global requirements
* Lazy log the fixed_key warnings
* Add disabled_reason field to services table
* Catch TypeError when new_size is None on extend
* Sync matchmaker_ring.py from oslo-incubator
* Add RBD test for volume not existing during delete
* Sync rpc fix from oslo-incubator
* Returns thin pool free space calculated from actual usage
* Brick LVM: Set C locale when gathering PV info
* LVM migration: Check if name is equal to dest_vg
* Convert lvm_mirrors to int
* LVM migrate: Use keywords for the brick instance
* LVM: Create thin pools of adequate size
* GlusterFS: Remove glusterfs_disk_util option
* Catch ImageBusy exception when deleting rbd volume
* Adds lock for create from vol/snap to avoid race conditions
* Fix docstring for snapshot_metadata controller
* Fixes case insensitive for resp body
* VMDK:Using host mount info for datastore selection
* Fixes case insensitive for resp body

2014.1.b1
---------

* All API controllers inherit from wsgi.Controller
* delete.start/delete.end notification for hostless
* Fix typo/misspelled words
* Update hacking to hacking>=0.8.0,<0.9
* Add more logging to migrate_volume_completion
* Use model_query() in db.*****_destroy
* Change method name to test_get_volume_stats
* Adjust RBD delete log level
* Bump to sqlalchemy-migrate 0.8.2
* Add unit tests for volume reserve and unreserve
* Don't stop volume service for failed re-export operations
* GlusterFS: Complete snapshot_delete when info doesn't exist
* Fix typo in cinder
* Imported Translations from Transifex
* Add attach/detach notifications
* Removes dublicated assert from test_migrations.py
* Use assertAlmostEqual instead of failUnlessAlmostEqual in unit tests
* Fixing check order for empty body in get_body()
* Updates .gitignore
* Remove unused import and CinderNode sqlalchemy model
* Fix suppressed exceptions for migration downgrade
* Fix the wrong verification for 'readonly'
* Parse out '@' in volume['host'] to do discovery
* Add volume migration code to Nexenta iSCSI volume driver
* Handle NotFound exception in snapshots API code
* Add chance weigher to scheduler
* Redundant body validation for volume_upload_image
* Imported Translations from Transifex
* Fix Storwize terminate_connection with no host
* Fix _update_volume_stats typos
* Remove the redundant judgment for 'restore'
* Make volume_glance_metadata_create compat with DB2
* GlusterFS: Set correct permissions for volume file created via clone
* GlusterFS: Ensure Cinder can write to shares
* The param 'readonly' is incorrect checked
* Fix docstring for Snapshot model
* Make sure report_interval is less than service_down_time
* Ensure 'status' in update_snapshot_status
* Update openstack/common/periodic_task
* Initialize and terminate connection raise 500 err
* Fix docstring for _migrate_volume_completion
* Migrate volume should check para "host" in request
* Continue to delete volumes that DNE in rbd backend
* Pull latest service module from Oslo
* Add greenthread.sleep() to parent wait()
* Fix ./run_tests.sh -V --virtual-env-name
* Pass the size when fetching image in xenapi driver
* Remove unused code in test_admin_actions.py
* Add support for extend volume in GPFS vol driver
* Remove dead code from test_get_volume_stats()
* Remove suffixes from LVM brick test vgs output
* Subclass vendor specific exceptions
* Don't do glance v2 calls when config is set to v1
* LVM: Activate source LV before cloning from it
* Add default quota class into DB during migration
* To fix test_get_dss_rp in test_vmware_vmdk.py
* Fix typo in cinder.volume.API
* NetApp fix for vsadmin role failure for ssc
* Create snapshot throws 500 Internal Error
* Fixes inappropriate error message
* NetApp fix free space as zero during 1st vol stats update
* Add valid check and unit tests on quota class
* GlusterFS: Synchronize operations that manipulate qcow2 data
* Check only our VG name when testing if VG exists
* Update quota-set throw 500 error
* Using HttpNfcLease to transfer vmdk files
* Adds extend volume to Dell EqualLogic Driver
* Remove the use of common.uuidutils.gen_uuid
* Imported Translations from Transifex
* Do not allow bad keys while updating quota
* Use cached volumes in REST API extensions
* Enable object caching in cinder REST API requests
* Nexenta iSCSI driver: extend volume stats of _update_volume_stats
* Fail when image is bigger than the volume
* Update URL for global HACKING document and remove duplicate section
* Retrieve volume image metadata using single query
* Add call to retrieve image metadata for volumes in bulk
* Do not remove volume silently if GPFS is unmounted
* Report zero capacity if GPFS is unmounted
* Nexenta NFS driver refactoring
* RequestContext initialization failed in cinder
* Nexenta: Remove snapshot after volume-clone deletion
* Don't use deprecated module commands
* Remove dup of LVMISCSIDriver in LVMISERDriver
* Remove duplication of ISCSIDriver in ISERDriver
* Support volume_readonly_update using XML format
* Fix typo in test_check_ssh_injection_on error test
* Remove lvm-thin pool_size config option
* Examine if GPFS is mounted before writing data
* Imported Translations from Transifex
* Remove unused db calls to fetch original metadata
* replace u\2013 char with dash
* Sync log from oslo
* Add tests for LVM -cow clearing
* clean up numeric expressions in test
* Fixes typo in method name _notify_voloume_type_error
* Allow spaces in quoted SSH command arguments
* Use pipe between ceph backup diff export/import
* Imported Translations from Transifex
* Add missing space to num_iser_scan_tries text
* Add cinder.db.migration.db_initial_version()
* remove rundundant lockfile requirement
* Imported Translations from Transifex
* Revert "Brick connector fix for NFS drivers"
* Update my mailmap
* GlusterFS: set correct filename when cloning volume
* Handle NotFound exceptions in API
* Unit test fails in pbuilder environment
* Updated from global requirements
* Check if dir exists before calling listdir
* Rename "rtstool" to "cinder-rtstool", add dep
* Downgrade target create failure mesg to warning
* Nexenta iSCSI driver: Refactor create_cloned_volume
* VMware: Registering vmdk opts in global space
* Brick connector revised fix for NFS drivers
* Nexenta drivers ignore "does not exist" exception
* Add openstack/common/crypto from OSLO
* Fix volume transfer href issue
* Remove duplication of brick.iscsi in brick.iser
* Drop auth_token configs for api-paste.ini
* NetApp unit test fail fix for http_proxy
* Revert "remove cinder-rtstool because of rtslib dep"
* Let GPFS driver to rename snapshot with root permission
* Imported Translations from Transifex
* NetApp fix for 7mode iscsi volume stats
* Brick connector fix for NFS drivers
* NetApp fix ssc volume filtering inconsistency
* Updated from global requirements
* NetApp fix mirrored stats
* NetApp fix for compression and dedup stats
* Fix generate conf script can't handle multistropt
* Add auth_token settings to cinder.conf.sample
* Add extend_volume for Huawei drivers
* Update openstack/common/notifier
* Imported Translations from Transifex
* Apply six for metaclass
* Provide gettext _ in missing locations
* Nexenta NFS driver: caching for appliance volroot
* Cinder extension to add used resources in absolute limits
* Fix Huawei HVS driver AttributeError
* Storwize: Fix iogrp availability check
* Imported Translations from Transifex
* Uses oslo.imageutils
* Don't zero out thin provisioned LV's on delete
* Fix lvm.extend_volume to pass Gig suffix
* Nexenta NFS volume driver folder auto sharing
* FK lookup failures during migration
* Initialize shares variables for RemoteFsDriver(s)
* Fix indentation errors in drivers
* Imported Translations from Transifex
* Fix Huawei drivers to support other host OSs
* Fix all occurences of H404 Hacking warning
* Imported Translations from Transifex
* VMware: Fixed upload-to-image for available volume
* Refactor Nexenta iSCSI driver
* Remove unused 'initiator' imports
* Fix tests to work in debug mode
* Updated from global requirements
* Remove whitespace from cfg options
* Remove option count from sample configuration
* improves lvm version parsing for customised builds
* Fix typo in cinder.volume.drivers.nexenta.__init__
* Remove obsolete redhat-eventlet.patch
* long flashcopy operation may block volume service
* Support Huawei driver upgrade from grizzly to havana
* Imported Translations from Transifex
* VMware: Disallow snapshot of attached volume
* Clean up comparison assertions
* Utilizes assertIsNone and assertIsNotNone
* Nexenta volume drivers: refactor NexentaJSONProxy
* remove unused methods in driver.Scheduler
* Imported Translations from Transifex
* Nexenta iSCSI driver fix _lu_exists
* Ignore H803 from Hacking
* Drop conf_key_mgr warning message!
* VMware: Re-create session for RetrievePropertiesEx
* use cinder utils.get_root_helper
* Provide user with more information on quota fail
* Cleanup and more tests for db.api methods
* Fix broken solidfire create-snapshot
* Clean CONF out of brick iser
* Open Icehouse development
* Imported Translations from Transifex
* Add key manager implementation with static key
* Remove need for CONF acces in brick iscsi
* Quotas roll back failure of create volume task
* Remove incorrect class in cinder.conf.sample
* Fixes incorrect class path in logging_sample.conf
* Storwize SVC driver hostname can't start with number
* After commiting quota we should avoid certain reverts
* Remove CONF from brick remotefs
* Pass through args and kwargs in brick connectors
* Clean CONF out of brick initiator
* Update Babel from Openstack Requirements
* Disable lazy translation
* Improve gpfs config flag help text readability
* Check for backing lun on iscsi target create
* usedevelop in tox
* Fixes ceph backup import errors
* Add XML response tests for qos specs manage ext
* v2 api - return bootable attr value on volume list
* Fixes backup with multiple volume backend
* Dont retry if target creation succeeds
* VMware ESX: Fixes vol clone & clone from snapshot
* Create volume revert fails for non admin user
* VMware: Usng RetrvProprtisEx & does multi ESX scan
* Fix XML serializer for QoS Specs extension
* Fix Huawei HVS driver attaching volume error
* Add debug logging for targets
* Add support for querying the quotas usage
* Validate force_host_copy API param for migration
* Imported Translations from Transifex
* Update OpenStack Style Commandments link
* Set vol driver initialized before deleting volumes
* Add error logs for Huawei driver
* Clean CONF out of brick exception
* Fix translation of CinderExceptions in REST API
* Allow upgrade from Grizzly with ThinLVMVolumeDriver
* Use module units for some drivers
* Get host group id when Huawei driver initializing
* Fix mandatory and optional args for create_volume
* Pass correct args to vol_rpc create_volume calls
* Fix processutils.execute errors on windows
* Sync gettextutils from oslo
* LVM volume_clear: error on unexpected inputs
* Revert "Fix volume_rpcapi calls for chance/simple scheds"
* Fix finish_volume_migration() on SQLAlchemy 0.8.x
* VMware: Handles no datastores case
* Fixes some typos in cinder
* Update rootwrap with code from oslo
* Specific /usr/local/bin/hus-cmd rootwrap filter
* Allow v2 Volume API to create volume with type name
* Imported Translations from Transifex
* Fix volume_rpcapi calls for chance/simple scheds
* Require assisted_volume_snapshots from novaclient
* Fix over-indent in compute/nova
* Add sg_scan filter to rootwrap
* Add extend to reference LVM driver
* Fix issues with failed lvremove
* GlusterFS: Copy snap from correct source file
* GlusterFS: Use image_utils for qemu-img calls
* Remove default root_helper of sudo for remotefs
* Add a retry to create_iscsi_target for LVM
* Fix HP3PAR iSCSI path connection
* Added mapper for update_all on snapshot_metadata
* Add volume metadata to v2
* Enforce driver is initialized
* Added mapper for snapshot_metadata
* Fix type change in bootable setting of volume view
* Add logging to prior to raising exceptions
* GPFS Driver missing clone depth limit for snapshots
* remove VolumeNotFoundForInstance class
* Sync gettextutils from oslo
* Use built-in print() instead of print statement
* Fixes vol restore discard final bytes unzeroed
* Fixes call GlanceConnectionFailed in invalid ARG
* Fixes call VolumeNotFound in the invalid argument
* Soft delete tmp migration volume
* Fix __init__ methods of brick initiator connectors
* Fix secure delete for thick LVM snapshots
* assertEquals is deprecated, use assertEqual
* Storwize/SVC: Optional CHAP authentication
* Fix huawei driver test issues
* fix wrong desciption of monkey_patch config
* Allow display_name for v2 snapshot-update
* Pass down root_helper in more cases
* Set rootwrap_config path to rootwrap.conf
* Do not use qemu-img --backing-chain or --output=json
* VMware driver: Fix for invalid datastore selection
* Fixes ceph volume restore to larger image than source
* Imported Translations from Transifex
* nms.folder.create_with_opts not supported on Nexenta 3.1.4.2
* Use $state_path/conversion for image_conversion_dir default
* Improves the parsing way of ssh returns
* Fixes the use of exception.InvalidInput with the wrong arguments
* Remove unused exceptions
* Fix client connection leaks in HP3PAR drivers
* Add default_availability_zone configuration option to cinder
* Imported Translations from Transifex
* Turn db model object into a primitive object to avoid error
* Catch generic exceptions
* Add delete support for volume type encryption
* Adds Dell EqualLogic volume driver for Cinder
* Fixing UnicodeEncodeError against volume creating function
* Fix deleting qos specs key
* Move novaclient to requirements.txt
* fix missing unit in log message
* Add check for qemu-img to image_utils fetch_to_raw
* Changed header from LLC to Foundation based on trademark policies
* Fixed erroneous force full copy in ceph backup driver
* Call to_primitive on volumes.rpcapi.create_volume
* Fix typo in cinder.tests.test_create_volume_flow
* Fix Qos Specs association corner case
* Fixes pep8 violation in nova
* Fix bug in Nexenta NFS driver _do_create_volume
* Restrict Volume type deletion with volumes assoc
* Replace assertEquals with assertEqual - 2/2
* Check cinder-backup service before "backing-up"
* Do not attempt vg.update on uninitialized vg
* Replace assertEquals with assertEqual - 1/2
* Add support for LocalConnector type in brick
* Remove unused/redundant methods in cinder/test.py
* Fix error casting value to float in lvm.py
* Fixes misuse of assertTrue in test scripts
* Utilizes assertIsNotNone
* Utilize assertIsInstance
* Remove deprecated assert_() usage
* Fix brick remotefs dependency on cinder
* Remove quota fetch race condition
* Synchronize extend_volume methods in 3PAR drivers
* Added copy-on-write support for all RBD cloning

2013.2.b3
---------

* fix log string in conversion type
* VMDK copy_image_to_volume and copy_volume_to_image
* Validate VV Set exists in 3PAR drivers
* This adds a README to brick
* Fix tuple usage error
* Fixes brick Nova pep8 violation for lvm.py
* fix inconsistent i18n log message
* QEMU-assisted-snapshots for GlusterFS volumes
* Add view builder to QoS specs API extension
* Add features to Zadara Storage Cinder driver
* Use tempfile and cleanup in windows unit test
* Adds Nexenta NFS driver
* Set vg_thin_pool to pool name instead of pool_path
* Fixes cinder-volume service startup on Windows
* extract 'limits.' to constant for ratelimiting logic
* Send notifications when extending volume
* Fix errors in volume usage audit script
* New update_snapshot_status API
* Add volume driver for Huawei HVS storage system
* Increase test coverage for cinder.utils
* Add Fibre Channel drivers for Huawei storage systems
* Refactor huawei Dorado array iSCSI driver
* Refactor Huawei iSCSI driver
* Enable gating on F811
* Add support for Havana missing features in Windows driver
* Add venv wrapper for check_uptodate.sh
* Clone volume with right size with SolidFire
* Fixes bug to allow for encrypted volume deletion
* Sync rpc fix from oslo-incubator
* Move comment back to right place
* copy_image_to_volume for Nexenta volume driver
* Fix pep8 violation in backup
* Utilizes assertIn and assertNotIn
* Implements APIs for VMDK driver
* Remove _create_volume function from several tests
* Don't need to init testr explicitly
* Add missing LH SAN driver features for Havana
* Multi storage backend support for Nexenta driver
* Fix typo in bin/cinder-volume-usage-audit
* Remove unused methods from cinder.utils
* Increase test coverage for cinder.image.image_utils
* Add kwargs to create_volume in tests/utils.py
* Update the version for the FC and iSCSI driver
* Pass MB size on copy_volume_data call copy_volume
* Adding Read-Only volume attaching support to Cinder
* Add NFS/GlusterFS support to brick library
* Pass db into driver as constructor's parameter
* Modified 3PAR drives to support 3parclient 2.0.0
* Move create_volume flow to a subfolder
* Import order cleanup
* Migrate manage script needs import of db session module
* Migration for attached volumes
* Add optimized volume migration to Storwize/SVC
* Fix quota update validation for non-int types
* Imported Translations from Transifex
* Removes exception instance creation on execute()
* Fix except in lvm.py
* Add automated check of conf sample
* Remove deprecated code from Nexenta Exception class
* Sync up with global requirements
* Extend volume for GlusterFS
* Offline snapshots for GlusterFS volumes
* Ensure that qpid connection is closed (from oslo)
* Imported Translations from Transifex
* Test WWNs with basestring
* Imported Translations from Transifex
* Remove print statement in db api test
* Ignore stmf target must be offline exception
* Sync execute() related exceptions with oslo
* The DB migration shouldn't populate types table
* Use a new rest client for every Coraid ESM command
* Remove unused methods from LVM driver
* Storwize/SVC: allow setting of I/O group
* Implement QoS support for volumes
* Move the frequently injection task to the base folder
* Move root task class to base file
* Backup driver for IBM Tivoli Storage manager (TSM)
* Dont crash service if sf cluster isnt available
* 3PAR driver add missing domain check on QOS cmd
* Remove unused methods from cinder.utils
* Refactor cinder/tests/test_volume.py
* Unified Volume Driver for IBM XIV and IBM DS8K
* Adds brick helpers to cinder utils
* Fix python 3 pep8 errors for print
* Fix incorrect msgstr's to avoid translation errors
* GPFS use clone_image for creating volumes
* 3PAR driver terminate connection host validation
* Re-enable a lot of cinder scheduler tests
* emit warning while running flake8 without virtual env
* Set bootable flag for volume cloned from image
* Remove unused methods from cinder.utils
* Clean up the sqlalchemy migrate manage.py script
* Allow to delete a volume in error_extending status
* Update Brick to use executor
* flake8 H202 error in test_image_utils.py
* Removes ssh_execute in utils.py
* Fix volume_glance_metadata deletion
* Use system locale when Accept-Language header is not provided
* Generic backup_volume and restore_backup functions
* Relax policy so owner can access encryption info
* Fix Fibre Channel attach for single WWN
* Make the SolidFire driver api port configurable
* Add accept_transfer to solidfire driver
* Added need info to accept_transfer
* Allow volume create from source unless in error status
* Avoid serializing CinderExceptions before they are translated
* Add root_helper param to get_connector_properties
* Standardize on ID for log messages
* Reduce hidden effects of sqlalchemy objects
* Removed need for domain in 3PAR drivers
* Allow Cinder to call Nova client
* Use FakeLoopingCall instead of the real one
* Fix some pylint error in Coraid Driver
* Storwize/SVC: More error logging
* Remove strcmp_const_time
* Refactor LVM driver to use Brick VG utility
* Added missing import
* Fixes SSH injection threat in 3PAR driver
* Implement missing Coraid Driver functionality for Havana
* Increase test coverage brick/initiator/connector
* Fix SSH injection threat in 3PAR driver
* refactor/unify driver version strings
* Refactor Nexenta driver
* Update Nexenta ISCSI volume driver authors
* Extract ISCSI tries option into connector module
* Externalize error messages in the v2 API
* Add more asserts to the limiter unit tests to test the RateLimit
* Replace os.unlink with delete_if_exists
* No need to declare the exception conf
* Add support for encrypted volumes
* Add tests for cinder/brick/initiator/connector
* Tidy up the SSH call to avoid injection attacks for HP's driver
* Raise exception when Glance metadata not found
* Interprete scoped key as nested tags
* Adding the -online option to the 3PAR clone
* Fixes some unseen flake8 violations
* Fixes volume clone from volume
* Fixes docstring formats in connector.py
* Fixes files with wrong bitmode
* Add unit tests for cinder/api/contrib/quotas
* remove Brick deps on cinder.exception
* Remove Brick iser dependency on cinder
* Fix handling ImageUnacceptable in create_volume
* Use native methods for list manipulation
* Fix signature of _create_volume() in ThinLVMVolumeDriver
* Add H233 to ignores in tox.ini
* Imported Translations from Transifex
* Add support for volume cloning to Nexenta driver
* Fix ratelimiting
* GPFS support for various volume attributes
* Upgrade Scality driver to match minimum features
* Ignore purge_props for v2 Glance api and fix upload
* Add support for API message localization
* 3PAR drivers creating incorrect comment data
* Imported Translations from Transifex
* Use utils.safe_minidom_parse_string in extensions
* Move resource usage sync functions to db backend
* Imported Translations from Transifex
* Refactoring of create_volume to use taskflow
* Add minimum features in HDS driver (for Havana & Icehouse)
* Ignore stmf target must be offline exception
* Added glance_request_timeout config option
* Set lock_path in tests
* 3PAR volumes created from snaps failed to attach
* Add test for brick.local_dev.lvm
* Imported Translations from Transifex
* Remove Brick's iscsi dependency on cinder
* Remove locals() from iser
* Move volume_clear and clear_size opts up to driver
* Imported Translations from Transifex
* Set the concurrent connections on the 3PAR array
* Create key manager interface
* Remove usage of obsolete oslo.exception
* Fixes create rbd volume from image v1 glance api
* Imported Translations from Transifex
* Remove Storage Manager from cinder-manage
* Remove cinder.exception from Brick
* Add bin directory to flake8 when not in venv
* Add support for volume extension to Nexenta Systems volume driver
* GPFS Verify min release level for mmclone command
* Sync gettextutils from oslo
* Add eclipse project files to .gitignore
* Remove unnecessary metadata from the 3PAR drivers
* Adding support for iSER transport protocol
* NetApp fix clone image compatibility issue with ssc
* Set bootable flag for volume serializer
* Fix chown fail for nfs file without necessary permission
* Add new persona value in the 3PAR driver
* Update driver version to 1.1
* Fix NetApp iscsi drivers for cinder backup
* Fix pep8 and pylint violation in Nexenta volume driver
* Test tools barfs on reusage of 'id' attribute
* Ignore "volume does not exist error"
* Call get_session() only when necessary
* Fix volume_create()/snapshot_create() DB methods
* Execute DB API methods in a single transaction
* Improve DB API test coverage
* Fix check for mount.nfs helper installation
* Imported Translations from Transifex
* Remove xen storage manager tables
* Remove unused migration_* methods from db api
* Factorize code between nfs.py and glusterfs.py
* NetApp fix create vol different size than snapshot
* LVM / Block Device Drivers: Fix duplicated flags
* tox.ini: Change sitepackages to False
* Tidy up the SSH call to avoid injection attacks in storwize_svc
* NetApp check for 7 mode controller version
* Storwize/SVC: Use reserved percentage from conf
* Imported Translations from Transifex
* Pop out 'offset' and 'limit' before use for filter
* Imported Translations from Transifex
* Fix running of migrations tests by Jenkins gate
* Update to latest oslo rootwrap
* Make unicode-to-utf8 conversion universal in ceph backup driver
* Add more info to delete error message
* Update references with new Mailing List location
* Allow connect by FC-only or iSCSI-only systems
* NetApp NFS efficient clone_image impl
* Removed the dep on cinder.utils
* Fix the multi-backend storge issue for ZMQ
* NetApp storage service feature support
* Imported Translations from Transifex
* Create volume from snapshot must be in the same AZ as snapshot
* Using volume name property instead of using template and id
* Fix unit suffix and add no_suffix option
* GPFS stub calls to truncate and dd in unit tests
* Storwize/SVC: Use VolumeDriver's copy vol<->image
* Implements extend volume feature in HP 3PAR driver
* use encode('utf8') instead of str()
* Imported Translations from Transifex
* Migration for detached volumes with no snaps
* Fix cinder error for deprecated Netapp drivers
* get_snapshot should populate the snapshot metadata
* Adding driver minimum features and volume stats to dev doc
* Update RBD driver to be compliant with HACKING
* GPFS convert glance image to raw only when needed
* Fix oslo.config.cfg.NoSuchOptError when running individual tests
* Fixes RBD driver docstring format issues
* fix name 'update_volume_status' to 'update_volume_stats'
* use 'exc_info=1' instead of import traceback
* Fix further Hacking 0.6.x warnings
* Add create & attach times to SolidFire attributes
* Implement extend volume for Storwize/SVC
* Cleanup README.rst
* Fix volumes search by metadata
* Add test for volume status check when extending
* 3PAR Driver modifications to support QOS
* Make Storwize/SVC tests work without simulator
* Revert hardening of Storwize/SVC SSH commands
* Clone_image method added image_id as parameter
* Added incremental backup support to Ceph backup driver
* Sync gettextutils from oslo
* Imported Translations from Transifex
* Fix duplicate config options
* Move copy_volume function to volume/utils.py
* Fixes default value of use_default_quota_class
* Imported Translations from Transifex
* Delete snapshot metadata when snapshot is deleted
* Tidy up the SSH call to avoid injection attacks in storwize_svc
* Fix extend_volume error handling
* Fixes race condition in LVMVolumeDriver create_cloned_volume method
* Checks the volume_clear flag and just return if it is none

2013.2.b2
---------

* Fixes Opt type of use_multipath_for_image_xfer
* Fixes Opt types in cinder/backup/drivers/ceph.py
* Fix indent in cincer/volume/configuration.py
* Implement validate_connector for Storwize/SVC
* Fix error when QuotaUsage.updated_at is NULL
* Rename SolidFire driver for consistency
* Add Brick Fibre Channel attach/detach support
* Increase timeout period for clone volume
* Be sure to check deleted types on quota update
* CoraidDriver: Allow volumes in error state to be deleted
* Adds multiple iSCSI port support to 3PAR
* Implement extend volume functionality in Sheepdog
* Mark methods used in class only with prefix "_"
* Add te field user_id into the volume detailed information
* Catch additional connect fail cases
* Clean up Huawei tmp files from tests
* Add flag argument to 'cinder-manage config list'
* Imported Translations from Transifex
* Add generic block device driver
* Use base ISCSI driver to fulfill some driver requirements
* Cleanup and make HACKING.rst DRYer
* Clone_image should return dict of vol properties, clone status
* Update requirements from openstack/requirements
* Refactor SSHPool.get() to use Pool.get()
* Enable zero the snapshot when delete snapshot in LVMVolumeDriver
* Fixes ceph-backup failure if original volume deleted
* Implement extend volume functionality in Rbd
* Handle errors raised by extend_volume
* Minor reorg for (array resource usage and backend options naming)
* Check enabled backup service before rpc request
* Fixed Ceph backup librbd segfault
* Add support to import images into sheepdog volumes
* Add tests for cinder/api/urlmap.py
* remove improper assert usage
* Enable setting blocksize on volumes
*     cinder.api: Replace 'locals()' with explicit values
* Update upper bound of keystoneclient version
* Fix missing volume_name_template flag
* Change check-detach to reject more states
* Implement extend volume functionality in SolidFire
* Add unit tests for cinder/api/versions
* Make String column creation compatible with SQLAlchemy 0.8
* Remove suds requirement
* Add support for storing volumes on GPFS
* Consist terminate_connection function signature
* SolidFire API RequestID is useless
* Add ability to specify SolidFire API version
* Refactor reschedule in exception handling of volume manager
* Don't pass 'session' arg to public DB API methods
* Add interface class for backup drivers
* Prevent wrongly privilege escalation of a context
* Move brick initiator tests to brick subdirectory
* Fix extent size issue when creating thin pool
* Sync install_venv_common from oslo
* Fix a few Sphinx warnings
* Ignore files created by Sphinx build
* Use oslo.sphinx and remove local copy of doc theme
* Add unit tests for cinder/api/contrib/volume_actions
* Scheduler should not select down volume managers
* Add check for snapshot to Brick LVM
* Fix typo 'Flase' -> 'False'
* Rename cinder.flags to cinder.common.config
* Add execute wrapper to brick LVM code
* Imported Translations from Transifex
* CoraidDriver: Create_volume_from_snapshot of a different size
* Make os-services API extension consistent
* Imported Translations from Transifex
* Removes 3PAR domain option from cinder config file
* Skip brick_initiator test in virtual environments
* Added Cinder volume backup to Ceph support
* Handle ECONNREFUSED exception in SolidFire driver
* Add os-availability-zone extension
* Run flake8 also on cinder/*/openstack
* Imported Translations from Transifex
* Quotas by Volume Type
* xenapi: implement xenserver image to volume
* Save some more image attributes to volume_glance_metadata
* Fix check_for_setup_error for sheepdog driver
* Add Brick iSCSI attach/detach
* Added volume backup and restore to Ceph RBD driver
* Fix service alive information in os-services extension
* Calculate count for customized dd blocksize
* Content-length missing in put_object
* Replace glance_metadata check with bootable column
* Imported Translations from Transifex
* Avoid winning the useless use of cat award
* Fix up trivial H103 license check mismatches
* Register used CONF entries in cinder.api.common.py
* Fix and enable gating on H401
* Do not raise NEW exceptions
*         cinder.[brick,db,image] Replace 'locals()'
* Update kombu requirement
* Remove usage of locals() for formatting from cinder.tests.*
* Adds create_from_volume test cases
* Use list comprehensions when possible
* NetApp:iSCSI drivers reserved percent need to change to 0
* Add support for swift user/key authentication
* Refactor the backup method of SwiftBackupService
* Imported Translations from Transifex
* NetApp unified driver implementation
* Add _create_volume to ThinLVMVolumeDriver
* Add the project name into CinderKeystoneContext
* Add build directory to flake8 ignore dirs
* Add missing extend volume test (rpcapi)
* fix error class path in logging sample
* Modify check for volume-type-id to a get w/default
* Don't perform retry_execute in certain cases
* Adding host attaching support to Cinder
* Update attach status when instance id invalid
* Fix and enable gating on H403
* Use Python 3.x compatible except construct
* cinder.backup: Replace 'locals()' with explicit values
* cinder/.: replace 'locals()' with explicit values
* Editable default quota support for cinder
* Imported Translations from Transifex
* Use common.processutils.execute
* Remove usage of locals() for formatting from cinder.volume.*
* cinder.schedule: Replace 'locals()' with explicit values
* Imported Translations from Transifex
* Remove the 'migrate' option from cinder-manage
* Use Python 3.x compatible octal numbers
* Use Python 3.x compatible except: construct
* Update and add notifiers in create volume
* Imported Translations from Transifex
* Fix up the test framework
* Raise an error if iSCSI is not supported
* Remove usage of locals() for formatting from cinder.api.*
* Implement capability to extend existing volume
* Replace utils.to_bytes() with strutils.to_bytes()
* Flatten Volume from Snapshot
* Imported Translations from Transifex
* Replace FLAGS with cfg.CONF in volume
* Replace FLAGS with cfg.CONF in other modules, unless tests
* Elevate volume/snap "is busy" log message for volume/snap_delete
* Imported Translations from Transifex
* Fixes 3PAR drivers terminate_connection issue
* Added policy check for backup operations
* Update to the latest stevedore
* Fix various Sphinx warnings
* Fix some unittest cases failed on osx
* Fix the after subscription size checks
* Re-set default sql_connection and sqlite_db
* Remove explicit distribute depend
* Add missing exception from volume/api.py
* Allow disabling ssl compression for glance client
* Add availability zone checking in the api service
* Add missing attributes to xml deserializer for volume request
* Integrate oslo's periodic tasks
* Fix LVM logging error
* Remove direct call to utils.execute
* Add policy checking for transfer create/accept
* Replace FLAGS with cfg.CONF in tests
* Replace FLAGS with cfg.CONF in api
* Start using Pyflakes
* Add the iscsi device check and exception processing
* Minor Logic bug in NFS Driver
* Imported Translations from Transifex
* Fix 'undefined symbol conn' error
* NFS drivers don't honor vm size with volume from an image
* Add missing tests for backup_* methods
* Replace functions in utils with oslo.fileutils
* Remove E12 errors from tox.ini Flake ignores
* Unset all stubs before running other cleanups
* Fix config registration in cinder volume drivers
* Elevate acceptors context on accept reserve udpate
* Removing service_* options from authtoken
* Add call to vol driver when accepting a transfer
* Imported Translations from Transifex
* Implement DB migration for volume transfer BP
* Replace FLAGS with cfg.CONF in db
* Add missing tests for iscsi_* methods
* Log iSCSI target output on error
* Re-write of the cinder-manage man page
* Replace FLAGS with cfg.CONF in scheduler
* python3: Introduce py33 to tox.ini
* Fix AttributeError typo
* Fix path for pylint Gate
* Fixed method db.api.reservation_expire
* Handle IPv6 specifid glance servers gracefully
* HDS Cinder Driver. Rev #1
* Imported Translations from Transifex
* Add error reporting to generate_sample.sh on import failure
* Updating HACKING to disallow the use of locals()
* Prevent force delete if the volume is attached
* InvalidUUID can not be raised
* Fix incorrect authorization rule in quota contrib api
* Rename requires files to standard names
* rbd: simplify configuration and use librbd and librados
* Update 3PAR driver session management
* Fix typos
* Add testrepository to git ignores
* Fix incorrect copyright
* Add missing tests for cinder.db.api.quota_
* Return 404 from delete of extra spec if not found
* Fix incorrect status for volume clone from image
* Imported Translations from Transifex
* Support for NFS shares with spaces in path
* Fixes 3PAR Host already exists error
* Ensure that pbr>=0.5.10 is installed
* Add missing tests for cinder.db.api
* Remove execute permissions from test files
* Migrate to Oslo DB code

2013.2.b1
---------

* Catch and report errors from copy image to volume
* test_glance.py: Stub out _get_member_model as well
* rbd: send ceph monitor addresses with connection info
* Don't set signing_dir by default
* Remove cinder_emc_config.xml.sample
* Update cloned volumes QoS settings
* Fix 'Inheritance-based rule deprecated' log warning
* Added '%' before snapshot variable
* Hack run_tests.sh to work with single tests again
* Imported Translations from Transifex
* Don't throw ValueError for invalid volume id
* ModifyVolume attributes on Clone
* Improve "service is down or disabled" warning message
* Add "_" builtin method for config generation
* Replace custom skip_ methods
* Migrate base test class to testtools
* Fix ownership transfer when cloning with SolidFire
* Make NFS share selection more intelligent
* Add common Oslo DB code to the source tree
* Add the service_state into test_schedule_happy_day
* Implement scheduler hints for API v2
* Update log.py and jsonutils.py from oslo-incubator
* Added a test for bad limit param
* Added test for nonnumerical limit param
* Raise VolumeNotFound with correct volume_id
* Removes a broken link from the sidebar of Sphinx built pages
* Imported Translations from Transifex
* Support mount options for NFS/GlusterFS volumes
* Hide v1/v2 version entities in API when disabled
* Allow flake8 to run in venv
* Imported Translations from Transifex
* Imported Translations from Transifex
* Convert to oslo strutils.bool_from_string
* Update import of strutils from oslo
* Add thin provisioning support checks
* Update/Publish volume service updates on delete
* RemoteFsDriver: copy_image_to_volume and copy_volume_to_image
* Imported Translations from Transifex
* solidfire: Make sure src_uuid is passed correctly
* Implement cloned volume for the RBD driver
* Add .coveragerc to show proper coverage statistics. As in other openstack projects
* NetApp server tunneling fix
* Move iscsi helpers to brick directory
* Fix up hacking ignores a bit
* Hide lock_prefix argument using synchronized_with_prefix()
* Storwize/SVC: fix attach bug for live migration
* Deprecating old dot path locations for Folsom configs
* solidfire: Add ability to override account prefix
* Fixes an get_volume_stats reporting issue
* Increased unit test code coverage
* Create an LVM utility to use for local storage
* Add CINDER_LOCALEDIR env variable
* Remove gettext.install() from cinder/__init__.py
* Use flake8 and hacking
* Use pbr instead of openstack.common.setup
* Change the type of "free_capacity_gb" to be float
* Set default values for NFS/GlusterFS share_config files
* Add missing spaces to iscsi_iotype help
* Adds notifiers to both volumeTypes and volumeTypeExtraSpecs
* Fix missing spaces in Huawei Logging
* Add pylint-based lintstack test to tox environment
* Remove outdated cinder test doc
* Implement copy_image_to_volume and copy_volume_to_image on nfs backends
* Update import of oslo's processutils
* Fix ability to add custom volume_backend_name
* Add db client packages to dev env setup doc
* Check that volume is at least minDisk size
* Remove old_name from kwargs when using IET helper
* Copy the RHEL6 eventlet workaround from Oslo
* Remove setuptools-git as run time dependency
* Fix LHN driver to allow backend name configuration
* Deleting a backup removed the backup record from database
* Remove _path_exists method
* Encode username and password in config file
* Clear volumes stuck in 'downloading'
* Fixes 3PAR FC driver synchronization
* Avoid using whitespace in test_safe_parse_xml
* Add stats reporting to Nexenta Driver
* Remove duplicate method definition
* iscsi: Add ability to specify or autodetect block vs fileio
* Rename duplicate test method
* Update to latest copy of OSLO incubator
* Cinder wasn't filtering the backups returned to backup list API
* cinder volume service keeps retrying even code exception
* Add missing space to "volumes already consumed" message
* Add capabilities reporting to ThinLVM driver
* NetApp: Fix failing NetApp tests
* Use VERSION var for volume_stats version (Gluster/NFS)
* Add parsing to extra-specs key check
* Use a SSH pool to manage SSH connection
* Remove Flags usage from cinder.volume.driver
* new cinder.conf.sample and fix extract_opts.py
* fix default config option types
* Fix incompatible Storwize/SVC commands
* Fix backup manager formatting error
* Add service list functionality cinder-manage
* Clean up attach/detach tests
* Reformat openstack-common.conf
* Sync with oslo-incubator copy of setup.py
* Don't hard code AUTH_ into the swift backup url
* Remove update_volume_status log message from NFS driver
* Implement get_volume_stats for GlusterFS driver
* Fixed a volume creation re-schedule error
* Allow deletion of backups where the service is None
* Fix cinder-manage backup list to work with uuids
* leave re-scheduled volume status to creating
* Prevent create volume from snapshot with bad size
* Add du to rootwrap filters
* Change format of some judgments
* Remove InvalidPortRange exception
* Add availability_zone to the volume and snapshot notifications
* Throw InvalidSnapshot for failed snap delete
* remove deprecated assert_unicode sqlalchemy attribute
* Fix IBM copyright strings
* REST session validity not checked in get_volume_info
* Enforce exclusive options snapshot-id, source-volid and image-id
* Add snapshot events to the cinder notification
* getLogger should be called after logging is configured
* Mark sql_connection with secret flag
* Sync lockutils from oslo-incubator stable/grizzly
* Remove unused tools/rfc.sh
* Add the volume and snapshot gigabytes together
* Force deletes using tgt to workaround bug 1159948
* Fixed shared gigabytes quota resource
* CoraidDriver: support users that are not admin
* Fix quota updating when admin deletes common user's volume
* Last driver sync for Folsom and Grizzly
* Fix bug with 3PAR host entry in wrong domain
* Snapshot reservation sync calls wrong resource
* Fetch volume_types by uuid and not by name in v2
* Use the local configuration in the nfs drivers
* Fixed attach volume for EMC SMI-S iSCSI driver
* Extend param2id() to work with uuids
* Clean up started volume services in tests
* CoraidDriver: do not call login from __init__
* CoraidDriver: typo in _login exception handler
* Fixes Cinder REST API /volumes issue
* Add missing processutils for impl_zmq in oslo rpc
* Update Cinder's latest copy of OSLO grizzly stable
* Remove the log spam generated by the NetApp driver unit tests
* Speedup solidfire unit tests
* Updates to OSAPI sizelimit middleware
* Use OpenStack common project requires
* Rename cinder-rtstool to rtstool
* Make dd block size user configurable
* remove cinder-rtstool because of rtslib dep
* Add snapshots to the volume usage audit report
* CoraidDriver: retrive volume info (improvement)
* Remove AGPL rtslib pkg from pip-requires
* Fix Storwize/SVC LUN allocation with holes
* Remove references to FLAGS from volume/manager.py
* Allow snapshot_delete for NFS/GlusterFS drivers
* Pull Oslo log fix to enable root logger initialization
* Clean up exec_dirs prefix from rootwrap conf
* Fix typo in persona valid values
* Use self.configuration to support the multi-backend case

2013.1.rc1
----------

* Bump version for Grizzly RC1 cut
* Count Snapshots towards volume/gigabyte quotas
* Fix 3PAR driver hiding existing host error
* Switch all uses of 422 response code to 400
* Implement get_volume_stats in NFS driver
* cinder-manage does not print any version information
* Fix ISCSIDriver rescan
* Compression/tier capabilities for Storwize/SVC
* Fixes dettach volumes in Windows cinder plugin
* Fix _migrate_up in test_migrations
* Switch to final 1.1.0 oslo.config release
* Adds a flag to set glance api version to call
* Storwize/SVC driver fix for multibackend scenario
* Fix bad request response code on extra_specs create
* Fix bugs for Huawei driver
* Do not use prefix to lookup host in Storwize/SVC
* update error log arguements in filter scheduler
* Update oslo rpc libraries
* Remove/update unused log arguements in manager
* Removing flags in RBD in favor of configuration
* LIO iSCSI initiator ACL auto-config
* Fix a few bugs for LeftHand Grizzly
* Update tox.ini to support RHEL 6.x
* Fix volume capacity reporting
* Pull newly merged Olso update for 'is' operator
* Use nose and openstack nose plugin
* Exit run_tests with the result code of the test runner
* Mark configuration option netapp_password secret
* Add get_volume_stats in the sheepdog driver
* Switch to oslo.config
* Fix calling setUp() method of superclass from tearDown method
* Fix 3PAR drivers to work in multi-backend mode
* Fixed copy image to volume and clone volume
* Fixes issues found in /os-hosts API
* Fix Storwize/SVC storage_protocol reporting
* sync oslo changes for setup / version
* swift backup service checks version during restore
* Add some useful log to filter scheduler
* Elevate context for delete volume with no host
* Improved fail_reason for cinder-backup swift connection errors
* Convert from using FLAGS directly in SF driver
* Improve logging for volume operations via manager
* Only use iscsi_helper config option if using LVMISCSIDriver
* Fix query filter in volume_get_active_by_window()
* Changed to INFO level logging for main cinder-backup operations
* NetApp: Clean up lock file left behind by unit tests
* NetApp: Fix race condition in 7-mode iSCSI driver with DFM
* update install_venv_common to handle bootstrapping
* allow run_tests.sh to report why it failed
* Remove compat cfg wrapper
* XenAPINFS: Fix Volume always uploaded as vhd/ovf
* Fixed cinder-backup start errors seen with devstack
* Cinder devref doc cleanups
* Fix various exception paths
* Implement metadata options for snapshots
* Skip timestamp check if 'capabilities' is none
* Fix stale volume list for NetApp 7-mode ISCSI driver
* Implement a basic backup-volume-to-swift service
* Better error handling around volume delete
* Moved cinder_emc_config.xml.sample to emc folder
* Uses tempdir module to create/delete xml file
* Add HUAWEI volume driver in Cinder
* XenAPINFS: Create volume from image (generic)
* Bump the oslo-config version to address issues
* Ensure volume exists before deleting
* Add LIO configuration for iSCSI initiators
* rbd: implement get_volume_stats()
* Handle maxclonepervolume/node limits in SF driver
* Use oslo-config-2013.1b3
* Fix syntax error in  cinder-volume-usage-audit
* HP 3PAR Fibre Channel Driver and iSCSI Updates
* Fibre Channel base class for Cinder drivers
* Update cinder-manage to use FLAGS.log_dir
* Add a safe_minidom_parse_string function
* Add a volume driver in Cinder for Scality SOFS
* Fix create volume from image
* XenAPINFS: fix capacity reporting
* Update Storwize/SVC driver for Grizzly
* Set rootwrap_config in cinder.conf sample
* Skip tests if cinder is not installed
* Fix undef function call in test_migrations for py26
* Fix PEP8 violation (again)
* Update cinder-volume to enable multi volume support
* Install rtslib when installing cinder
* Sync latest cfg and log from oslo-incubator
* Handle 'infinite' and 'unknown' capacity in CapacityWeigher
* Add get_cluster_stats to SolidFire driver
* NetApp: Fix for snapshot not deleted in error state
* NetApp bug fix for multibackend scenario
* Adding support for Coraid AoE SANs Appliances
* Add an update option to run_tests.sh
* Update EMC SMI-S Driver
* Add LIO iSCSI backend support using python-rtslib
* Add GlusterFS volume driver
* Create a RemoteFsDriver class
* Fix ordering of function args
* Add an ID to temporary volume snapshot object
* Allow create_volume() to retry when exception happened
* Fixes the provisioning on selected volumes for NetApp 7 mode
* rbd: update volume<->image copying
* Fix PEP8 violation
* Update snapshot rest api to be consistent with volumes
* change display_description to description in volumes
* v2 volume/snapshot create will correctly give a 202 response
* add postgresql opportunistic testing
* make test_databases instance variable
* Move create_cloned_volume() to LVMVolumeDriver
* Update to latest oslo-version code
* Allow disabling of long-lived SSH connections
* Don't require importing paramiko for error
* Allow for specifying nfs mount options
* rework migration 004 testing with real data
* Allow tools/install_venv_common.py to be run from within the source directory
* add data injection on migrations
* sync database connect changes from nova
* XenAPINFS: Copy volume to glance
* XenAPINFS: Copy image from glance
* Fix inability to delete volumes in error state for NetApp driver
* Copy glance_image_metadata when cloning volumes
* Add volume_glance_metadata to volume.api.get
* Import Oslo's common rootwrap to Cinder
* Mark password config options with secret
* Fixes 'not in' operator usage
* Skip tests if cinder is not installed
* Fix provider_location column add for PSQL
* Update 3PAR driver
* Fix the generalized copy_image_to_volume operation
* import tools/flakes from oslo
* Add unit tests for ISCSIDriver._do_iscsi_discovery and ISCSIDriver._get_iscsi_properties
* Fixes "is not" usage
* Pull cfg module from Oslo and update cinder-manage accordingly
* Set source volume to "in use" during clone
* Update some Oslo Packages
* Fix typo in cinder/db/api.py
* Replace CRLF with unix-style "LF"
* Allow volume back-end to report 'infinite' or 'unknown' as capacity
* Wrap SolidFire size parameter in int
* Use install_venv_common.py from oslo
* Update osapi_volume_extension default
* Generic iSCSI copy volume<->image
* Implement LVM thin provisioning support
* Check for installed cinder in filter tests
* Fix hosts extension and enable its tests
* Check for non-default volume name template
* Get updated vol status in volume.api.reserve
* Update EMC SMI-S iSCSI Driver
* Clean up QTree when deleting volume on NetApp storage box
* Fix NFS volume creation
* Improve error message for missing NFS share config
* ensure zeros are written out when clearing volumes
* Fix error for extra specs update with empty body
* Clean up IPV6 config checks in test_wsgi
* Add capability to update volume metadata
* Fix sheepdog volume creation
* Add LUN# to provider_location in Nexenta driver
* Check for configured IPV6 before running tests
* New cinder.conf.sample format
* Move iscsi flags back to driver.py
* Snapshot support for XenAPINFS
* support a configurable volume wiping method
* Relax various version constraints
* Support for SSL in wsgi.Server
* Enhance wsgi to listen on ipv6 address
* Factor out LVM code
* Implement filter scheduler
* Revert "Implement filter scheduler"
* Update SolidFire Volume driver
* Provide HP 3PAR array iSCSI driver
* Fix CinderClient exception name in EMCISCSIDriver
* Enable cinder exception format checking in tests
* Update exceptions to pass correct kwargs
* Add option to make exception format errors fatal
* Implement filter scheduler
* Use tempdir for lock_path in tests
* Upgrade WebOb to 1.2.3
* Make WebOb version specification more flexible
* Fix cmds clearing in TargetAdminTestCase
* Add missing library
* use deleted = False, not 0 for update
* Implement ability to Clone volumes in Cinder
* Add pyflakes
* Adds synchronization to attach volume
* Add EMC Volume Driver in Cinder
* Added extra-spec key scoping to the 3PAR drivers
* Adding marker, pagination, sort key and sort direction to v2 api
* Fix typo in image_utils tempfile handling
* Make the NetAppISCSIDriver._is_clone_done() method able to handle empty responses. Add unit tests to exercise this case
* Make sure we don't double remove tmp on exception
* Add service mgmt extension
* Added the lockutils, fileutils, gettextutils
* Fixes a Windows volume driver bug on disk export
* Moving host admin extension with other extensions
* Allow the lvm backed drivers to use mirrrors
* CHAP support for IBM Storwize/SVC driver
* Remove instance quota re-sync code
* Add image metadata API extension
* Raise NotImplemented for drivers that don't support images
* Add *.swp to gitignore
* Support glance servers over https
* Add commands used by NFS volume driver to rootwrap
* Changing display_name to name in v2 api
* Make summary and detail view consistent with other projects
* creating separate v1 and v2 stubs and general fakes
* Make copy_to_volume a bit more useful
* Delete type call in api needs update to use ID
* Convert volume_type id from int to uuid
* Fixes the 3PAR drivers CPG validation
* Rename Config osapi_compute_link_prefix to osapi_volume_base_URL
* Fix exception when size is None
* Ensure request_spec can be serialized
* attaching volumes will set instance_uuid instantly
* Revert changes to monkey_patch
* Improve provider_location cleanup code for RBD
* Fix import order to make it alphabetical
* Fix None being passed into as_int()
* Use auth_token middleware from keystoneclient
* Provide i18n to those messages without _()
* Revert "use O_DIRECT when copying from /dev/zero too"
* Make pep8 checks a bit stricter
* Unpin lxml requirements
* use O_DIRECT when copying from /dev/zero too
* Add CONTRIBUTING file
* Add the persistency to the volume created by iscsi IET
* adding copy of v1 as v2
* Moving contrib to cinder.api
* Moving api v1 implementation into v1 directory
* Switching api to use base extension manager
* moving all middleware code in cinder.api.middleware
* Moving common api code into cinder.api
* Cleaning up volume driver paths
* Add volume bootable information to api response
* Add XenAPINFSDriver
* Add db table for Glance Metadata
* Remove redundant db.volume_update() in volume manager create_volume()
* Pin pep8 1.3.3
* Removes the xensm driver
* Pass in correct volume_ref to create_from_snapshot
* NetApp direct to filer drivers for iscsi and nfs
* Add hosts extension to Cinder
* Remove unused python-daemon dependency
* Make tox.ini run pep8/hacking checks on bin
* Various pep8/HACKING fixes for Cinder
* Volume RPC API Versioning
* Remove gen_uuid()
* Remove obsolete use_local_volumes
* Import order cleanup per HACKING
* Remove unused volume API method - remove_from_compute()
* Scheduler API clean up and refactor
* Remove dm_setup(remove) call in volume_delete
* Add ability to disable secure volume delete
* Remove the zeroing out of the volume altogether
* Add 'create_volume' to scheduler RPC API
* Fix run_tests.sh ambiguous usage msg and behaviour for -x option
* Add admin only action for force detach
* Changes bit mode of zadara.py to 644
* Port openstack-common/uuidutils to Cinder
* Fix 401 from auth_token middleware
* Splitting out volume drivers in driver.py
* Minor optimization in create_volume in HpSanISCSIDriver
* Adding a SSH Connection Pool
* Fixes 3par driver methods that were double locking
* Return volume type name on volume create
* pin sqlalchemy to the 0.7 series
* Add VolumeTenantAttribute API extension
* Log the body of an /action
* Detect and fix issues caused by vol ID migration
* Split out drivers in san.py
* Add VolumeHostAttribute API extension
* Add default volume type flag
* Fix typo so setting volume_tmp_dir works
* Rollback for resources during volume creation failure
* Allow the user to update a volume's metadata
* Add the generation of the username and password for iSCSI target
* Update HACKING.rst and related changes from Nova/PEP8
* Add trove classifiers for PyPI
* Ensure device node exists before wiping during volume deletion
* Update volume and snapshot status on delete
* Drop unused quota_usage db methods
* Drop duplicate sqlalchemy db api methods
* Change output strings to i18ned
* Adds support for Windows 2012 Storage Server blueprint windows2012driver https://blueprints.launchpad.net/cinder/+spec/windows2012driver
* Update common
* Fix incorrect class path for legacycinder formatter in logging_sample.conf
* Error message references incorrect variable
* Loosen anyjson dependency to avoid clash with ceilometer
* Configuration Options clean up
* Fix typo in policy documentation
* Add snapshot force delete admin action
* Mock out sleep in some retry tests
* Use policy based rule to define context.is_admin
* Sync openstack common and add policy
* Fix typo in sample configuration file
* Update distribute version in test requires
* Revert explicit usage of tgt-adm --conf option
* Fixes remove_export for IetAdm
* Add missing entries in setup, fix up pip-requires
* Fix NetAppCmodeISCSIDriver._get_lun_handle() method
* Remove unused code: check_for_export
* Return 400 if create volume snapshot force parameter is invalid
* Fix cinder-volume-usage-audit
* Sync with nova change I135ed85a
* Remove cinder gating hack
* Set the default availability zone back to nova
* Add lun number (0) to model_update in HpSanDriver
* Fixes to the SolarisISCSI Driver
* Stop double logging to the console
* Restore SIGPIPE default action for subprocesses
* Replace builtin hash with MD5 to solve 32/64-bit issues
* Correct IetAdm remove_iscsi_target
* Add nova migrate_version check to cinder import
* Bump version to 2013.1
* Clean up db.volume_create()
* Fix volume deletion when device mapper is used
* Update quota when deleting volume that failed to be scheduled
* Sync a change to rpc from openstack-common
* Add a resume delete on volume manager startup
* Improve entity validation in volumes APIs
* Add entity body validation helper
* Should've added super().tearDown() in test_iscsi
* Fixes bug 1050135
* Fix FLAGS.volumes_dir help message
* Use tmpdir and avoid leaving test files behind
* Sync log format changes from openstack-common
* Update rpc from openstack-common
* Add volume quota in volume/api.py and olume/manager.py
* Fixes bug 1049446
* Revert "Don't zero out snapshot volume on snapshot_delete"
* Add update to volume and snapshot controllers
* Nail the pip requirement at 1.1
* Clean up .gitignore
* Prevent from bug #1008866 is reverted
* rename nova.pot => cinder.pot, nova.po => cinder.po
* Don't zero out snapshot volume on snapshot_delete
* Recent changes to SolidFire API changed iqn format
* Remove unused utils.wrap_exception
* Sync notifier changes from openstack-common
* Clean up some codes about compute in VolumeTestCase
* Remove unused db api
* Typo nova => cinder
* Remove vpn_ping function in cinder/utils.py
* Update SolidFire driver to reflect IQN changes
* Rename test_nova_rootwrap.py to test_cinder_rootwrap.py
* Fixes potential bugs found by pylint
* Handle missing 'provider_location' in rm_export
* Specify the conf file when creating a volume
* avoid the buffer cache when copying volumes
* Fix Typo in LOG.error
* Remove dependencies for netaddr
* Filter volumes and snapshots by query string
* Remove null_kernel option
* Remove default_schedule_zone
* Remove memcached_servers config option
* Regenerate cinder.conf.sample
* Sync improvements to config file generator tools
* Sync misc changes from openstack-common
* Sync zmq changes from openstack-common
* Sync cfg changes from openstack-common
* Fix xml metadata for volumes api in cinder
* Fix bug where image size is incorrectly rejected
* Several hacking compliance fixes
* Remove Cheetah from pip-requires
* Update dev docs   * Quick pass at implementing the basics for cinder dev docs   * Remove the N/A compute related stuff   * Clean up the architecture a bit to only show cinder related   * Remove various modules form TOC's that aren't applicable
* Typo fix: nova => cinder
* Move newly created NFS exceptions to standard location in exception.py Addresses bug 1037619
* Add admin actions extension
* Removed unnecessary call to ensure_export
* Add cinder- prefix to all binaries
* Make size optional when creating a volume from a snap
* Fix creation of iscsi targets
* Spelling: Persistant=>Persistent
* Implement volume quota support in Cinder
* Remove unused return values and commented out code from NFS driver
* Remove unused flags
* Fix PEP8 issues
* Fix incorrect tgt-admin call in create_iscsi_target
* Add 'detaching' to volume status
* Typo fix in cinder: existant => existent
* Make glance image service check base exception classes
* Fix PEP8 issues
* Remove unused exceptions from cinder/exception.py
* Add nosehtmloutput as a test dependency
* Migrate volume related quota info in db migration
* Use event.listen() instead of deprecated listeners kwarg
* Add declare for xiv driver in fake_flags
* Remove logging in volume tests
* Call driver for attach/detach_volume
* Fix spelling typos
* Remove unused function
* blueprint zadara-volume-driver
* Adding the volume notifications to cinder
* add ability to clone images
* Update SolidFire volume driver
* Add proper support for deprecation messages
* Remove utils.deprecated functions
* Move volume size validation to api layer
* Map internal exceptions in the nova style
* Add driver for using files on a generic NFS server as virtual block devices Add NetApp-specific NFS virtual block driver
* Implements bp migrate-nova-volumes-to-cinder
* add get_location method for images
* rbd: implement create_volume_from_snapshot
* Replace deprecated client with python-glanceclient
* Remove unused imports
* Fix check_for_export() in non-exporting drivers
* Adds new volume API extensions
* Driver for IBM XIV storage
* Fake requests in tests should be to v1
* Add C-mode driver for NetApp
* storwize-svc: improved test coverage and fixes
* Use setuptools-git
* Add iscsiadm path for qauntal
* Create unique volumes_dir for testing
* Remove redundant 'availability_zone' config options
* Straight port of the NetApp driver updates from nova-volume to cinder
* Use volume driver specific execeptions
* Admin users should be restricted from seeing all snapshots by default
* Use openstack.common.notifier
* Admin users should be restricted from seeing all volumes by default
* Deprecate root_helper in favor of rootwrap_config
* Send 'create volume from snapshot' to the proper host
* Add persistent volumes for tgtd
* Scheduler-clean-up
* Include AUTHORS file in MANIFEST.in
* Add authors for IBM Storwize and SVC driver
* Driver for IBM Storwize and SVC storage
* Remove unused instance_name_template flag
* Allow XML payload for volume creation
* Include volume_metadata with object on vol create
* Trim volume type representation
* Port nova-rootwrap changes to cinder-rootwrap
* Don't do PEP8 test for openstack-common code
* Cleanup unused code in servce.py
* Use openstack.common.setup
* utils module is still being used by cinder-volume service
* Remove unused fake memcache client
* Remove unused check_snapshots_enabled
* Use openstack.common.log for logging
* Don't create volumes if an incorrect size was given
* Use rpc from openstack-common
* Add missing gettextutils from openstack-common
* Use save_and_reraise_exception() from common
* Use openstack.common.cfg.CONF
* Remove cinder.log usage from cinder.rpc
* Remove cinder.context dependency from cinder.rpc
* Localize rpc options to rpc code
* Add version to scheduler rpc API
* Sync cfg and iniparser from openstack-common
* Use cfg's new global CONF object
* Make use of openstack.common.jsonutils
* Sync with latest version of openstack.common.cfg
* Convert Cinder to use openstack-common jsonutils
* Add missing ack to impl_qpid
* Move queue_get_for() from db to rpc
* Add base support for rpc API versioning
* Make kombu support optional for running unit tests
* Stop using cinder.exception from cinder.rpc
* Remove unused synchronization decorator
* Remove 'cinder-manage config convert'
* Use cfg's new behavior of reset() clearing overrides
* Remove unused enabled_apis flag
* Remove some unused helper scripts
* Remove unused wrap_errors decorator
* Remove unused get_{id,version}_from_href()
* Remove unused metadata serialization
* Remove unused raise_http_conflict_for_instance_invalid_state()
* Remove unused OverLimitFault
* Remove old flagfile support
* Misused and not used config options
* Pass 'cinder' project into ConfigOpts
* Sync to newer openstack.common.cfg
* Convert Cinder to use openstack-common timeutils
* Do not duplicate nova docs in cinder
* Remove unused db api methods
* Create single initial Cinder DB migration file
* Updated HpSanISCSIDriver to use initialize/terminate methods
* Pruned Authors file to active contributors (from nova-volumes)
* Move nova-manage.rst to cinder-manage.rst
* Add action extensions to support nova integration
* Revert "Add action extensions to support nova integration."
* Fix volume['id'] from integer to string
* Add action extensions to support nova integration
* Set pep8 version to 1.1 in test_requires
* Fix topics so that the do not collide with nova
* Fix up coverage and jenkins test running
* Remove instance Foreign Key in volumes table, replace with instance_uuid
* Align the tox.ini file
* Removed cinder/api/openstack/compute and moved the relevant pieces under cinder/api/openstack/volume. Fixes bug 994177
* Initial fork out of Nova
